#ifndef _ShapeSchema_PGeom_BezierCurve_HeaderFile_
#include <ShapeSchema_PGeom_BezierCurve.hxx>
#endif
#ifndef _PGeom_BezierCurve_HeaderFile_
#include <PGeom_BezierCurve.hxx>
#endif
#include <ShapeSchema_PGeom_BezierCurve.ixx>
#ifndef _Storage_Schema_HeaderFile_
#include <Storage_Schema.hxx>
#endif
#ifndef _Storage_stCONSTclCOM_HeaderFile_
#include <Storage_stCONSTclCOM.hxx>
#endif

Handle_Standard_Type& ShapeSchema_PGeom_BezierCurve_Type_()
{

  static Handle_Standard_Type tSchema = STANDARD_TYPE(ShapeSchema_PGeom_BezierCurve); 
  static Handle_Standard_Type bSchema = STANDARD_TYPE(Storage_CallBack);

  static Handle_Standard_Transient _Ancestors[]= {tSchema,bSchema,NULL};
  static Handle_Standard_Type _aType = new Standard_Type("ShapeSchema_PGeom_BezierCurve",
			                                 sizeof(ShapeSchema_PGeom_BezierCurve),
			                                 1,
			                                 (Standard_Address)_Ancestors,
			                                 (Standard_Address)NULL);

  return _aType;
}

const Handle(ShapeSchema_PGeom_BezierCurve) Handle(ShapeSchema_PGeom_BezierCurve)::DownCast(const Handle(Storage_CallBack)& AnObject) {
  Handle(ShapeSchema_PGeom_BezierCurve) _anOtherObject;

  if (!AnObject.IsNull()) {
     if (AnObject->IsKind(STANDARD_TYPE(ShapeSchema_PGeom_BezierCurve))) {
       _anOtherObject = Handle(ShapeSchema_PGeom_BezierCurve)((Handle(ShapeSchema_PGeom_BezierCurve)&)AnObject);
     }
  }

  return _anOtherObject ;
}

Standard_Boolean ShapeSchema_PGeom_BezierCurve::IsKind(const Handle(Standard_Type)& AType) const { 
  return (STANDARD_TYPE(ShapeSchema_PGeom_BezierCurve) == AType || Storage_CallBack::IsKind(AType)); 
}

const Handle(Standard_Type)& ShapeSchema_PGeom_BezierCurve::DynamicType() const { 
  return STANDARD_TYPE(ShapeSchema_PGeom_BezierCurve) ; 
}
Handle(Standard_Persistent) ShapeSchema_PGeom_BezierCurve::New() const
{
 return new PGeom_BezierCurve(Storage_stCONSTclCOM());
}

void ShapeSchema_PGeom_BezierCurve::SAdd(const Handle(PGeom_BezierCurve)& p, const Handle(Storage_Schema)& theSchema)
{
  if (!p.IsNull()) {
    if (theSchema->AddPersistent(p,"PGeom_BezierCurve")) {
         theSchema->PersistentToAdd(p->_CSFDB_GetPGeom_BezierCurvepoles());
   theSchema->PersistentToAdd(p->_CSFDB_GetPGeom_BezierCurveweights());

    }
  }
}

void ShapeSchema_PGeom_BezierCurve::Add(const Handle(Standard_Persistent)& p, const Handle(Storage_Schema)& theSchema) const {
  ShapeSchema_PGeom_BezierCurve::SAdd((Handle(PGeom_BezierCurve)&)p,theSchema);
}

void ShapeSchema_PGeom_BezierCurve::SWrite(const Handle(Standard_Persistent)& p, Storage_BaseDriver& f, const Handle(Storage_Schema)& theSchema)
{ 
  if (!p.IsNull()) {
    Handle(PGeom_BezierCurve) &pp = (Handle(PGeom_BezierCurve)&)p;
    theSchema->WritePersistentObjectHeader(p,f);
    
    f.BeginWritePersistentObjectData();
  f.PutBoolean(pp->_CSFDB_GetPGeom_BezierCurverational());
  theSchema->WritePersistentReference(pp->_CSFDB_GetPGeom_BezierCurvepoles(),f);
  theSchema->WritePersistentReference(pp->_CSFDB_GetPGeom_BezierCurveweights(),f);

    f.EndWritePersistentObjectData();
  }
}

void ShapeSchema_PGeom_BezierCurve::Write(const Handle(Standard_Persistent)& p, Storage_BaseDriver& f, const Handle(Storage_Schema)& theSchema) const
{ 
 ShapeSchema_PGeom_BezierCurve::SWrite(p,f,theSchema);
}
void ShapeSchema_PGeom_BezierCurve::SRead(const Handle(Standard_Persistent)& p, Storage_BaseDriver& f, const Handle(Storage_Schema)& theSchema)
{ 
  if (!p.IsNull()) {
    Handle(PGeom_BezierCurve) &pp = (Handle(PGeom_BezierCurve)&)p;

    theSchema->ReadPersistentObjectHeader(f);
    f.BeginReadPersistentObjectData();


    Standard_Boolean PGeom_BezierCurverational;
    f.GetBoolean(PGeom_BezierCurverational);
    pp->_CSFDB_SetPGeom_BezierCurverational(PGeom_BezierCurverational);

    Handle(PColgp_HArray1OfPnt) PGeom_BezierCurvepoles;

    theSchema->ReadPersistentReference(PGeom_BezierCurvepoles,f);
    pp->_CSFDB_SetPGeom_BezierCurvepoles(PGeom_BezierCurvepoles);

    Handle(PColStd_HArray1OfReal) PGeom_BezierCurveweights;

    theSchema->ReadPersistentReference(PGeom_BezierCurveweights,f);
    pp->_CSFDB_SetPGeom_BezierCurveweights(PGeom_BezierCurveweights);

    f.EndReadPersistentObjectData();
  }
}

void ShapeSchema_PGeom_BezierCurve::Read(const Handle(Standard_Persistent)& p, Storage_BaseDriver& f, const Handle(Storage_Schema)& theSchema) const
{ 
 ShapeSchema_PGeom_BezierCurve::SRead(p,f,theSchema);
}
