#ifndef _ShapeSchema_PGeom_BezierSurface_HeaderFile_
#include <ShapeSchema_PGeom_BezierSurface.hxx>
#endif
#ifndef _PGeom_BezierSurface_HeaderFile_
#include <PGeom_BezierSurface.hxx>
#endif
#include <ShapeSchema_PGeom_BezierSurface.ixx>
#ifndef _Storage_Schema_HeaderFile_
#include <Storage_Schema.hxx>
#endif
#ifndef _Storage_stCONSTclCOM_HeaderFile_
#include <Storage_stCONSTclCOM.hxx>
#endif

Handle_Standard_Type& ShapeSchema_PGeom_BezierSurface_Type_()
{

  static Handle_Standard_Type tSchema = STANDARD_TYPE(ShapeSchema_PGeom_BezierSurface); 
  static Handle_Standard_Type bSchema = STANDARD_TYPE(Storage_CallBack);

  static Handle_Standard_Transient _Ancestors[]= {tSchema,bSchema,NULL};
  static Handle_Standard_Type _aType = new Standard_Type("ShapeSchema_PGeom_BezierSurface",
			                                 sizeof(ShapeSchema_PGeom_BezierSurface),
			                                 1,
			                                 (Standard_Address)_Ancestors,
			                                 (Standard_Address)NULL);

  return _aType;
}

const Handle(ShapeSchema_PGeom_BezierSurface) Handle(ShapeSchema_PGeom_BezierSurface)::DownCast(const Handle(Storage_CallBack)& AnObject) {
  Handle(ShapeSchema_PGeom_BezierSurface) _anOtherObject;

  if (!AnObject.IsNull()) {
     if (AnObject->IsKind(STANDARD_TYPE(ShapeSchema_PGeom_BezierSurface))) {
       _anOtherObject = Handle(ShapeSchema_PGeom_BezierSurface)((Handle(ShapeSchema_PGeom_BezierSurface)&)AnObject);
     }
  }

  return _anOtherObject ;
}

Standard_Boolean ShapeSchema_PGeom_BezierSurface::IsKind(const Handle(Standard_Type)& AType) const { 
  return (STANDARD_TYPE(ShapeSchema_PGeom_BezierSurface) == AType || Storage_CallBack::IsKind(AType)); 
}

const Handle(Standard_Type)& ShapeSchema_PGeom_BezierSurface::DynamicType() const { 
  return STANDARD_TYPE(ShapeSchema_PGeom_BezierSurface) ; 
}
Handle(Standard_Persistent) ShapeSchema_PGeom_BezierSurface::New() const
{
 return new PGeom_BezierSurface(Storage_stCONSTclCOM());
}

void ShapeSchema_PGeom_BezierSurface::SAdd(const Handle(PGeom_BezierSurface)& p, const Handle(Storage_Schema)& theSchema)
{
  if (!p.IsNull()) {
    if (theSchema->AddPersistent(p,"PGeom_BezierSurface")) {
         theSchema->PersistentToAdd(p->_CSFDB_GetPGeom_BezierSurfacepoles());
   theSchema->PersistentToAdd(p->_CSFDB_GetPGeom_BezierSurfaceweights());

    }
  }
}

void ShapeSchema_PGeom_BezierSurface::Add(const Handle(Standard_Persistent)& p, const Handle(Storage_Schema)& theSchema) const {
  ShapeSchema_PGeom_BezierSurface::SAdd((Handle(PGeom_BezierSurface)&)p,theSchema);
}

void ShapeSchema_PGeom_BezierSurface::SWrite(const Handle(Standard_Persistent)& p, Storage_BaseDriver& f, const Handle(Storage_Schema)& theSchema)
{ 
  if (!p.IsNull()) {
    Handle(PGeom_BezierSurface) &pp = (Handle(PGeom_BezierSurface)&)p;
    theSchema->WritePersistentObjectHeader(p,f);
    
    f.BeginWritePersistentObjectData();
  f.PutBoolean(pp->_CSFDB_GetPGeom_BezierSurfaceuRational());
  f.PutBoolean(pp->_CSFDB_GetPGeom_BezierSurfacevRational());
  theSchema->WritePersistentReference(pp->_CSFDB_GetPGeom_BezierSurfacepoles(),f);
  theSchema->WritePersistentReference(pp->_CSFDB_GetPGeom_BezierSurfaceweights(),f);

    f.EndWritePersistentObjectData();
  }
}

void ShapeSchema_PGeom_BezierSurface::Write(const Handle(Standard_Persistent)& p, Storage_BaseDriver& f, const Handle(Storage_Schema)& theSchema) const
{ 
 ShapeSchema_PGeom_BezierSurface::SWrite(p,f,theSchema);
}
void ShapeSchema_PGeom_BezierSurface::SRead(const Handle(Standard_Persistent)& p, Storage_BaseDriver& f, const Handle(Storage_Schema)& theSchema)
{ 
  if (!p.IsNull()) {
    Handle(PGeom_BezierSurface) &pp = (Handle(PGeom_BezierSurface)&)p;

    theSchema->ReadPersistentObjectHeader(f);
    f.BeginReadPersistentObjectData();


    Standard_Boolean PGeom_BezierSurfaceuRational;
    f.GetBoolean(PGeom_BezierSurfaceuRational);
    pp->_CSFDB_SetPGeom_BezierSurfaceuRational(PGeom_BezierSurfaceuRational);

    Standard_Boolean PGeom_BezierSurfacevRational;
    f.GetBoolean(PGeom_BezierSurfacevRational);
    pp->_CSFDB_SetPGeom_BezierSurfacevRational(PGeom_BezierSurfacevRational);

    Handle(PColgp_HArray2OfPnt) PGeom_BezierSurfacepoles;

    theSchema->ReadPersistentReference(PGeom_BezierSurfacepoles,f);
    pp->_CSFDB_SetPGeom_BezierSurfacepoles(PGeom_BezierSurfacepoles);

    Handle(PColStd_HArray2OfReal) PGeom_BezierSurfaceweights;

    theSchema->ReadPersistentReference(PGeom_BezierSurfaceweights,f);
    pp->_CSFDB_SetPGeom_BezierSurfaceweights(PGeom_BezierSurfaceweights);

    f.EndReadPersistentObjectData();
  }
}

void ShapeSchema_PGeom_BezierSurface::Read(const Handle(Standard_Persistent)& p, Storage_BaseDriver& f, const Handle(Storage_Schema)& theSchema) const
{ 
 ShapeSchema_PGeom_BezierSurface::SRead(p,f,theSchema);
}
