// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _AIS_BadEdgeFilter_HeaderFile
#define _AIS_BadEdgeFilter_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_AIS_BadEdgeFilter_HeaderFile
#include <Handle_AIS_BadEdgeFilter.hxx>
#endif

#ifndef _TopTools_DataMapOfIntegerListOfShape_HeaderFile
#include <TopTools_DataMapOfIntegerListOfShape.hxx>
#endif
#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
#ifndef _SelectMgr_Filter_HeaderFile
#include <SelectMgr_Filter.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
#ifndef _TopAbs_ShapeEnum_HeaderFile
#include <TopAbs_ShapeEnum.hxx>
#endif
#ifndef _Handle_SelectMgr_EntityOwner_HeaderFile
#include <Handle_SelectMgr_EntityOwner.hxx>
#endif
class SelectMgr_EntityOwner;
class TopoDS_Edge;


//! A Class <br>
class AIS_BadEdgeFilter : public SelectMgr_Filter {

public:
 // Methods PUBLIC
 // 

//! Constructs an empty filter object for bad edges. <br>
Standard_EXPORT AIS_BadEdgeFilter();


Standard_EXPORT virtual  Standard_Boolean ActsOn(const TopAbs_ShapeEnum aType) const;


Standard_EXPORT virtual  Standard_Boolean IsOk(const Handle(SelectMgr_EntityOwner)& EO) const;

//! sets  <myContour> with  current  contour. used  by <br>
//!          IsOk. <br>
Standard_EXPORT   void SetContour(const Standard_Integer Index) ;

//!  Adds an  edge  to the list  of non-selectionnable <br>
//!          edges. <br>
Standard_EXPORT   void AddEdge(const TopoDS_Edge& anEdge,const Standard_Integer Index) ;

//! removes from the  list of non-selectionnable edges <br>
//!          all edges in the contour <Index>. <br>
Standard_EXPORT   void RemoveEdges(const Standard_Integer Index) ;
//Standard_EXPORT ~AIS_BadEdgeFilter();




 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
TopTools_DataMapOfIntegerListOfShape myBadEdges;
Standard_Integer myContour;


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
