// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _AIS_MultipleConnectedShape_HeaderFile
#define _AIS_MultipleConnectedShape_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_AIS_MultipleConnectedShape_HeaderFile
#include <Handle_AIS_MultipleConnectedShape.hxx>
#endif

#ifndef _TopoDS_Shape_HeaderFile
#include <TopoDS_Shape.hxx>
#endif
#ifndef _AIS_MultipleConnectedInteractive_HeaderFile
#include <AIS_MultipleConnectedInteractive.hxx>
#endif
#ifndef _AIS_KindOfInteractive_HeaderFile
#include <AIS_KindOfInteractive.hxx>
#endif
#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
#ifndef _Handle_Prs3d_Projector_HeaderFile
#include <Handle_Prs3d_Projector.hxx>
#endif
#ifndef _Handle_Prs3d_Presentation_HeaderFile
#include <Handle_Prs3d_Presentation.hxx>
#endif
#ifndef _Handle_Geom_Transformation_HeaderFile
#include <Handle_Geom_Transformation.hxx>
#endif
#ifndef _Handle_SelectMgr_Selection_HeaderFile
#include <Handle_SelectMgr_Selection.hxx>
#endif
#ifndef _Handle_PrsMgr_PresentationManager3d_HeaderFile
#include <Handle_PrsMgr_PresentationManager3d.hxx>
#endif
#ifndef _Handle_PrsMgr_PresentationManager2d_HeaderFile
#include <Handle_PrsMgr_PresentationManager2d.hxx>
#endif
#ifndef _Handle_Graphic2d_GraphicObject_HeaderFile
#include <Handle_Graphic2d_GraphicObject.hxx>
#endif
class Standard_NotImplemented;
class TopoDS_Shape;
class Prs3d_Projector;
class Prs3d_Presentation;
class Geom_Transformation;
class SelectMgr_Selection;
class PrsMgr_PresentationManager3d;
class PrsMgr_PresentationManager2d;
class Graphic2d_GraphicObject;


//! Constructs an Interactive Object connected to a list of <br>
//! Interactive Objects having a Shape. These include <br>
//! AIS_Shape, and AIS_ConnectedShape. <br>
//! Presentation of Hidden parts is calculated automatically. <br>
//! You define the Interactive Object by gathering <br>
//! together several other object presentations as in <br>
//! AIS_MultipleConnectedInteractive. <br>
class AIS_MultipleConnectedShape : public AIS_MultipleConnectedInteractive {

public:
 // Methods PUBLIC
 // 

//! Initializes the shape aShape, a multiple connected <br>
//! Interactive Object grouping different <br>
//! projector-dependent representations of an entity. <br>
Standard_EXPORT AIS_MultipleConnectedShape(const TopoDS_Shape& aShape);


Standard_EXPORT virtual  AIS_KindOfInteractive Type() const;


Standard_EXPORT virtual  Standard_Integer Signature() const;

//! Returns true is shape decomposition is accepted. <br>
Standard_EXPORT virtual  Standard_Boolean AcceptShapeDecomposition() const;
//! Constructs the reference shape ashap. <br>
  void Set(const TopoDS_Shape& ashap) ;
//! Returns the shape which is constructed in Set. <br>
 const TopoDS_Shape& Shape() const;

//! this method should fill the presentation according to the <br>
//!          enumerated mode of the application and to the display parameter <br>
//!          of the application. <br>
Standard_EXPORT virtual  void Compute(const Handle(PrsMgr_PresentationManager2d)& aPresentationManager,const Handle(Graphic2d_GraphicObject)& aPresentation,const Standard_Integer aMode = 0) ;
//Standard_EXPORT ~AIS_MultipleConnectedShape();




 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 


Standard_EXPORT virtual  void Compute(const Handle(Prs3d_Projector)& aProjector,const Handle(Prs3d_Presentation)& aPresentation) ;


Standard_EXPORT virtual  void Compute(const Handle(Prs3d_Projector)& aProjector,const Handle(Geom_Transformation)& aTrsf,const Handle(Prs3d_Presentation)& aPresentation) ;


Standard_EXPORT virtual  void ComputeSelection(const Handle(SelectMgr_Selection)& aSelection,const Standard_Integer aMode) ;


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


Standard_EXPORT   void Compute(const Handle(Prs3d_Projector)& aProjector,const Handle(Prs3d_Presentation)& aPresentation,const TopoDS_Shape& aShape) ;

//! this method is redefined virtual; <br>
//!          when the instance is connected to another <br>
//!          InteractiveObject,this method doesn't <br>
//!          compute anything, but just uses the <br>
//!          presentation of this last object, with <br>
//!          a transformation if there's one stored. <br>
Standard_EXPORT virtual  void Compute(const Handle(PrsMgr_PresentationManager3d)& aPresentationManager,const Handle(Prs3d_Presentation)& aPresentation,const Standard_Integer aMode = 0) ;


 // Fields PRIVATE
 //
TopoDS_Shape myShape;


};


#include <AIS_MultipleConnectedShape.lxx>



// other Inline functions and methods (like "C++: function call" methods)
//


#endif
