// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _AlienImage_XAlienImage_HeaderFile
#define _AlienImage_XAlienImage_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_AlienImage_XAlienImage_HeaderFile
#include <Handle_AlienImage_XAlienImage.hxx>
#endif

#ifndef _Handle_AlienImage_X11XWDAlienData_HeaderFile
#include <Handle_AlienImage_X11XWDAlienData.hxx>
#endif
#ifndef _AlienImage_AlienUserImage_HeaderFile
#include <AlienImage_AlienUserImage.hxx>
#endif
#ifndef _Handle_Image_Image_HeaderFile
#include <Handle_Image_Image.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
class AlienImage_X11XWDAlienData;
class TCollection_AsciiString;
class Image_Image;
class OSD_File;


//! Defines an X11 Alien image, i.e. an image file to be <br>
//! used with X11 xwd utility. <br>
class AlienImage_XAlienImage : public AlienImage_AlienUserImage {

public:
 // Methods PUBLIC
 // 

//! Constructs an empty X11 alien image. <br>
Standard_EXPORT AlienImage_XAlienImage();

//! Frees memory allocated by XAlienImage <br>
Standard_EXPORT   void Clear() ;
~AlienImage_XAlienImage()
{
  Clear();
}


//! Sets the Image name for the Name function. <br>
Standard_EXPORT   void SetName(const TCollection_AsciiString& aName) ;

//! Returns the Image name. <br>
Standard_EXPORT  const TCollection_AsciiString& Name() const;

//! Converts an XAlienImage object to a Image object. <br>
Standard_EXPORT   Handle_Image_Image ToImage() const;

//! Converts an Image object to a XAlienImage object. <br>
Standard_EXPORT   void FromImage(const Handle(Image_Image)& anImage) ;

//! Reads the content of a  XAlienImage object from a file . <br>
//!          Returns True if file is a XWD file . <br>
Standard_EXPORT   Standard_Boolean Read(OSD_File& afile) ;

//! Writes the content of a  XAlienImage object to a file . <br>
Standard_EXPORT   Standard_Boolean Write(OSD_File& afile) const;




 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
Handle_AlienImage_X11XWDAlienData myData;


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
