// File generated by CPPExt (Value)
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _AppParCurves_HeaderFile
#define _AppParCurves_HeaderFile

#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
#ifndef _Standard_Real_HeaderFile
#include <Standard_Real.hxx>
#endif
class math_Vector;
class math_Matrix;
class math_IntegerVector;
class AppParCurves_MLineTool;
class AppParCurves_MultiPoint;
class AppParCurves_MultiCurve;
class AppParCurves_MultiBSpCurve;
class AppParCurves_ConstraintCouple;
class AppParCurves_LeastSquare;
class AppParCurves_ResolConstraint;
class AppParCurves_Function;
class AppParCurves_BSpFunction;
class AppParCurves_Gradient;
class AppParCurves_Gradient_BFGS;
class AppParCurves_ParLeastSquare;
class AppParCurves_ResConstraint;
class AppParCurves_ParFunction;
class AppParCurves_BSpGradient;
class AppParCurves_BSpGradient_BFGS;
class AppParCurves_BSpParLeastSquare;
class AppParCurves_BSpParFunction;
class AppParCurves_Projection;
class AppParCurves_ProLeastSquare;
class AppParCurves_ProConstraint;
class AppParCurves_ProFunction;
class AppParCurves_SmoothCriterion;
class AppParCurves_LinearCriteria;
class AppParCurves_MyCriterion;
class AppParCurves_Variational;
class AppParCurves_Array1OfConstraintCouple;
class AppParCurves_HArray1OfConstraintCouple;
class AppParCurves_Array1OfMultiPoint;
class AppParCurves_HArray1OfMultiPoint;
class AppParCurves_Array1OfMultiCurve;
class AppParCurves_HArray1OfMultiCurve;
class AppParCurves_SequenceOfMultiCurve;
class AppParCurves_Array1OfMultiBSpCurve;
class AppParCurves_HArray1OfMultiBSpCurve;
class AppParCurves_SequenceOfMultiBSpCurve;
class AppParCurves_SequenceNodeOfSequenceOfMultiCurve;
class AppParCurves_SequenceNodeOfSequenceOfMultiBSpCurve;


#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_Macro_HeaderFile
#include <Standard_Macro.hxx>
#endif

//! Parallel Approximation in n curves. <br>
//! This package gives all the algorithms used to approximate a MultiLine <br>
//! described by the tool MLineTool. <br>
//! The result of the approximation will be a MultiCurve. <br>
class AppParCurves  {

public:

    void* operator new(size_t,void* anAddress) 
      {
        return anAddress;
      }
    void* operator new(size_t size) 
      { 
        return Standard::Allocate(size); 
      }
    void  operator delete(void *anAddress) 
      { 
        if (anAddress) Standard::Free((Standard_Address&)anAddress); 
      }
 // Methods PUBLIC
 // 


Standard_EXPORT static  void BernsteinMatrix(const Standard_Integer NbPoles,const math_Vector& U,math_Matrix& A) ;


Standard_EXPORT static  void Bernstein(const Standard_Integer NbPoles,const math_Vector& U,math_Matrix& A,math_Matrix& DA) ;


Standard_EXPORT static  void SecondDerivativeBernstein(const Standard_Real U,math_Vector& DDA) ;


Standard_EXPORT static  void SplineFunction(const Standard_Integer NbPoles,const Standard_Integer Degree,const math_Vector& Parameters,const math_Vector& FlatKnots,math_Matrix& A,math_Matrix& DA,math_IntegerVector& Index) ;





protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //

friend class AppParCurves_MLineTool;
friend class AppParCurves_MultiPoint;
friend class AppParCurves_MultiCurve;
friend class AppParCurves_MultiBSpCurve;
friend class AppParCurves_ConstraintCouple;
friend class AppParCurves_LeastSquare;
friend class AppParCurves_ResolConstraint;
friend class AppParCurves_Function;
friend class AppParCurves_BSpFunction;
friend class AppParCurves_Gradient;
friend class AppParCurves_Gradient_BFGS;
friend class AppParCurves_ParLeastSquare;
friend class AppParCurves_ResConstraint;
friend class AppParCurves_ParFunction;
friend class AppParCurves_BSpGradient;
friend class AppParCurves_BSpGradient_BFGS;
friend class AppParCurves_BSpParLeastSquare;
friend class AppParCurves_BSpParFunction;
friend class AppParCurves_Projection;
friend class AppParCurves_ProLeastSquare;
friend class AppParCurves_ProConstraint;
friend class AppParCurves_ProFunction;
friend class AppParCurves_SmoothCriterion;
friend class AppParCurves_LinearCriteria;
friend class AppParCurves_MyCriterion;
friend class AppParCurves_Variational;
friend class AppParCurves_Array1OfConstraintCouple;
friend class AppParCurves_HArray1OfConstraintCouple;
friend class AppParCurves_Array1OfMultiPoint;
friend class AppParCurves_HArray1OfMultiPoint;
friend class AppParCurves_Array1OfMultiCurve;
friend class AppParCurves_HArray1OfMultiCurve;
friend class AppParCurves_SequenceOfMultiCurve;
friend class AppParCurves_Array1OfMultiBSpCurve;
friend class AppParCurves_HArray1OfMultiBSpCurve;
friend class AppParCurves_SequenceOfMultiBSpCurve;
friend class AppParCurves_SequenceNodeOfSequenceOfMultiCurve;
friend class AppParCurves_SequenceNodeOfSequenceOfMultiBSpCurve;

};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
