// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _Aspect_MarkMap_HeaderFile
#define _Aspect_MarkMap_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_Aspect_MarkMap_HeaderFile
#include <Handle_Aspect_MarkMap.hxx>
#endif

#ifndef _Aspect_SequenceOfMarkMapEntry_HeaderFile
#include <Aspect_SequenceOfMarkMapEntry.hxx>
#endif
#ifndef _MMgt_TShared_HeaderFile
#include <MMgt_TShared.hxx>
#endif
#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
class Aspect_BadAccess;
class Aspect_MarkMapEntry;
class Aspect_MarkerStyle;


//! This class defines a MarkMap object. <br>
class Aspect_MarkMap : public MMgt_TShared {

public:
 // Methods PUBLIC
 // 


Standard_EXPORT Aspect_MarkMap();

//! Adds an entry in the mark map <me>. <br>
//!  Warning: Raises BadAccess if MarkMap size is exceeded. <br>
Standard_EXPORT   void AddEntry(const Aspect_MarkMapEntry& AnEntry) ;

//! Search an identical marker style entry in the mark map <me> <br>
//! and returns the MarkMapEntry Index if exist. <br>
//! Or add a new entry and returns the computed MarkMapEntry index used. <br>
Standard_EXPORT   Standard_Integer AddEntry(const Aspect_MarkerStyle& aStyle) ;

//! Returns the Allocated markmap Size <br>
Standard_EXPORT   Standard_Integer Size() const;

//! Returns the MarkMapEntry.Index of the MarkMap <br>
//!          at rank <aMarkmapIndex> . <br>
Standard_EXPORT   Standard_Integer Index(const Standard_Integer aMarkmapIndex) const;


Standard_EXPORT   void Dump() const;

//! Returns the Mark map entry with the index <AnIndex>. <br>
//!  Warning: Raises BadAccess if the index less than 1 or <br>
//!	    greater than Size. <br>
Standard_EXPORT   Aspect_MarkMapEntry Entry(const Standard_Integer AnIndex) const;
//Standard_EXPORT ~Aspect_MarkMap();




 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //
Aspect_SequenceOfMarkMapEntry mydata;


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
