// File generated by CPPExt (Value)
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _BOP_BuilderTools_HeaderFile
#define _BOP_BuilderTools_HeaderFile

#ifndef _BooleanOperations_StateOfShape_HeaderFile
#include <BooleanOperations_StateOfShape.hxx>
#endif
#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
#ifndef _BOP_Operation_HeaderFile
#include <BOP_Operation.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
#ifndef _TopAbs_State_HeaderFile
#include <TopAbs_State.hxx>
#endif
#ifndef _TopAbs_ShapeEnum_HeaderFile
#include <TopAbs_ShapeEnum.hxx>
#endif
class TopoDS_Face;
class TopoDS_Edge;
class TColStd_IndexedMapOfInteger;
class BOPTools_CArray1OfSSInterference;
class BOPTColStd_IndexedDataMapOfIntegerIndexedMapOfInteger;
class TopTools_ListOfShape;
class BOP_ListOfConnexityBlock;


#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_Macro_HeaderFile
#include <Standard_Macro.hxx>
#endif


//!  Some  handy tools used by classes <br>
//!  BOP_ShellShell, <br>
//!  BOP_ShellSolid, <br>
//!  BOP_SolidSolid <br>
//!  to build a result <br>
class BOP_BuilderTools  {

public:

    void* operator new(size_t,void* anAddress) 
      {
        return anAddress;
      }
    void* operator new(size_t size) 
      { 
        return Standard::Allocate(size); 
      }
    void  operator delete(void *anAddress) 
      { 
        if (anAddress) Standard::Free((Standard_Address&)anAddress); 
      }
 // Methods PUBLIC
 // 


Standard_EXPORT static  BooleanOperations_StateOfShape StateToCompare(const Standard_Integer iRank,const BOP_Operation anOp) ;


Standard_EXPORT static  Standard_Boolean ToReverseSection(const Standard_Integer iRank,const BOP_Operation anOp) ;


Standard_EXPORT static  Standard_Boolean ToReverseFace(const Standard_Integer iRank,const BOP_Operation anOp) ;


Standard_EXPORT static  void OrientSectionEdgeOnF1(const TopoDS_Face& aF1,const TopoDS_Face& aF2,const Standard_Integer iRank,const BOP_Operation anOp,TopoDS_Edge& aE) ;


Standard_EXPORT static  Standard_Boolean IsSameDomainFaceWithF1(const Standard_Integer nF1,const Standard_Integer nF2,const TColStd_IndexedMapOfInteger& aFFM,BOPTools_CArray1OfSSInterference& aFFs) ;


Standard_EXPORT static  Standard_Boolean IsPartIN2DToKeep(const TopAbs_State aSt,const Standard_Integer iRank,const BOP_Operation anOp) ;


Standard_EXPORT static  Standard_Boolean IsPartOn2dToKeep(const TopAbs_State aSt,const Standard_Integer iRank,const BOP_Operation anOp) ;


Standard_EXPORT static  void DoMap(BOPTools_CArray1OfSSInterference& aFFs,BOPTColStd_IndexedDataMapOfIntegerIndexedMapOfInteger& aFFMap) ;


Standard_EXPORT static  void MakeConnexityBlocks(const TopTools_ListOfShape& aLE,const TopAbs_ShapeEnum aType,BOP_ListOfConnexityBlock& aLConBlks) ;





protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
