// File generated by CPPExt (Value)
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _BOP_EdgeInfo_HeaderFile
#define _BOP_EdgeInfo_HeaderFile

#ifndef _TopoDS_Edge_HeaderFile
#include <TopoDS_Edge.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
#ifndef _Standard_Real_HeaderFile
#include <Standard_Real.hxx>
#endif
class TopoDS_Edge;


#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_Macro_HeaderFile
#include <Standard_Macro.hxx>
#endif


//!  The  auxiliary class to store data about edges <br>
//!  that have common vertex <br>
//! <br>
class BOP_EdgeInfo  {

public:

    void* operator new(size_t,void* anAddress) 
      {
        return anAddress;
      }
    void* operator new(size_t size) 
      { 
        return Standard::Allocate(size); 
      }
    void  operator delete(void *anAddress) 
      { 
        if (anAddress) Standard::Free((Standard_Address&)anAddress); 
      }
 // Methods PUBLIC
 // 


//! Empty constructor; <br>
Standard_EXPORT BOP_EdgeInfo();


//! Modifier <br>
Standard_EXPORT   void SetEdge(const TopoDS_Edge& aE) ;


//! Modifier <br>
Standard_EXPORT   void SetPassed(const Standard_Boolean aFlag) ;


//! Modifier <br>
Standard_EXPORT   void SetAngle(const Standard_Real anAngle) ;


//! Modifier <br>
Standard_EXPORT   void SetInFlag(const Standard_Boolean aFlag) ;


//! Selector <br>
Standard_EXPORT  const TopoDS_Edge& Edge() const;


//! Selector <br>
Standard_EXPORT   Standard_Boolean Passed() const;


//! Selector <br>
Standard_EXPORT   Standard_Real Angle() const;


//! Selector <br>
Standard_EXPORT   Standard_Boolean IsIn() const;





protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
TopoDS_Edge myEdge;
Standard_Boolean myPassed;
Standard_Boolean myInFlag;
Standard_Real myAngle;


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
