// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _BOP_Loop_HeaderFile
#define _BOP_Loop_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_BOP_Loop_HeaderFile
#include <Handle_BOP_Loop.hxx>
#endif

#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
#ifndef _TopoDS_Shape_HeaderFile
#include <TopoDS_Shape.hxx>
#endif
#ifndef _BOP_BlockIterator_HeaderFile
#include <BOP_BlockIterator.hxx>
#endif
#ifndef _MMgt_TShared_HeaderFile
#include <MMgt_TShared.hxx>
#endif
class TopoDS_Shape;
class BOP_BlockIterator;



//!         A Loop is an existing shape (Shell,Wire) or a set <br>
//!         of shapes (Faces,Edges) which are connex. <br>
//!         a set of connex shape is represented by a BlockIterator <br>
class BOP_Loop : public MMgt_TShared {

public:
 // Methods PUBLIC
 // 


//! Creates the object using the  shape S; <br>
Standard_EXPORT BOP_Loop(const TopoDS_Shape& S);


//! Creates the object using the BlockIterator BI; <br>
Standard_EXPORT BOP_Loop(const BOP_BlockIterator& BI);


//! Returns TRUE if the object was created using shape <br>
Standard_EXPORT virtual  Standard_Boolean IsShape() const;


//! Returns Shape from which  the object was created <br>
//! Valid only when IsShape() is TRUE <br>
Standard_EXPORT virtual const TopoDS_Shape& Shape() const;


Standard_EXPORT  const BOP_BlockIterator& BlockIterator() const;
//Standard_EXPORT ~BOP_Loop();




 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //
Standard_Boolean myIsShape;
TopoDS_Shape myShape;
BOP_BlockIterator myBlockIterator;


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
