// File generated by CPPExt (Value)
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _BOP_SolidSolid_HeaderFile
#define _BOP_SolidSolid_HeaderFile

#ifndef _BOP_ShellSolid_HeaderFile
#include <BOP_ShellSolid.hxx>
#endif
#ifndef _Handle_BOP_HistoryCollector_HeaderFile
#include <Handle_BOP_HistoryCollector.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
#ifndef _TopAbs_State_HeaderFile
#include <TopAbs_State.hxx>
#endif
#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
class BOPTools_DSFiller;
class BOP_HistoryCollector;
class TopTools_ListOfShape;
class BOP_ShellFaceSet;
class TopoDS_Shape;
class TopTools_DataMapOfShapeInteger;
class BOPTColStd_IndexedDataMapOfIntegerIndexedMapOfInteger;


#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_Macro_HeaderFile
#include <Standard_Macro.hxx>
#endif


//!        Performs Boolean Operations  (BO) <br>
//!        Common,Cut,Fuse for solids as <br>
//!        arguments <br>
class BOP_SolidSolid  : public BOP_ShellSolid {

public:

    void* operator new(size_t,void* anAddress) 
      {
        return anAddress;
      }
    void* operator new(size_t size) 
      { 
        return Standard::Allocate(size); 
      }
    void  operator delete(void *anAddress) 
      { 
        if (anAddress) Standard::Free((Standard_Address&)anAddress); 
      }
 // Methods PUBLIC
 // 


//! Empty constructor; <br>
Standard_EXPORT BOP_SolidSolid();


//! See base classes, please <br>
Standard_EXPORT virtual  void DoWithFiller(const BOPTools_DSFiller& aDSF) ;


//! Destructor <br>
Standard_EXPORT virtual  void Destroy() ;
Standard_EXPORT virtual ~BOP_SolidSolid(){Destroy();}


//! See base classes, please <br>
Standard_EXPORT virtual  void DoNewFaces() ;


//! See base classes, please <br>
Standard_EXPORT virtual  void BuildResult() ;


Standard_EXPORT virtual  void SetHistoryCollector(const Handle(BOP_HistoryCollector)& theHistory) ;





protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


Standard_EXPORT   void PrepareSFS(const TopTools_ListOfShape& aFaces,BOP_ShellFaceSet& aSFS) ;


Standard_EXPORT   void PrepareFaceSplits() ;


Standard_EXPORT   Standard_Boolean PropagateFaceStateByEdges(const TopoDS_Shape& theFace,const TopTools_DataMapOfShapeInteger& theMapOfEdgeIndex,TopAbs_State& theState) ;


Standard_EXPORT   Standard_Boolean ComputeStateByInsidePoints(const Standard_Integer theFaceIndex,const Standard_Integer theBaseFaceIndex,const Standard_Integer theFaceRank,const BOPTColStd_IndexedDataMapOfIntegerIndexedMapOfInteger& theFFMap,TopAbs_State& theState) ;


Standard_EXPORT   Standard_Boolean TakeOnSplit(const Standard_Integer theFaceIndex,const Standard_Integer theBaseFaceIndex) const;


 // Fields PRIVATE
 //


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
