// File generated by CPPExt (Value)
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _BRepBlend_Extremity_HeaderFile
#define _BRepBlend_Extremity_HeaderFile

#ifndef _Handle_Adaptor3d_HVertex_HeaderFile
#include <Handle_Adaptor3d_HVertex.hxx>
#endif
#ifndef _BRepBlend_SequenceOfPointOnRst_HeaderFile
#include <BRepBlend_SequenceOfPointOnRst.hxx>
#endif
#ifndef _gp_Pnt_HeaderFile
#include <gp_Pnt.hxx>
#endif
#ifndef _gp_Vec_HeaderFile
#include <gp_Vec.hxx>
#endif
#ifndef _Standard_Real_HeaderFile
#include <Standard_Real.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
#ifndef _Handle_Adaptor2d_HCurve2d_HeaderFile
#include <Handle_Adaptor2d_HCurve2d.hxx>
#endif
#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
class Adaptor3d_HVertex;
class Standard_DomainError;
class Standard_OutOfRange;
class Adaptor2d_HCurve2d;
class BRepBlend_PointOnRst;
class BRepBlend_SequenceOfPointOnRst;
class gp_Pnt;
class gp_Vec;
class IntSurf_Transition;


#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_Macro_HeaderFile
#include <Standard_Macro.hxx>
#endif


class BRepBlend_Extremity  {

public:

    void* operator new(size_t,void* anAddress) 
      {
        return anAddress;
      }
    void* operator new(size_t size) 
      { 
        return Standard::Allocate(size); 
      }
    void  operator delete(void *anAddress) 
      { 
        if (anAddress) Standard::Free((Standard_Address&)anAddress); 
      }
 // Methods PUBLIC
 // 


Standard_EXPORT BRepBlend_Extremity();


Standard_EXPORT BRepBlend_Extremity(const gp_Pnt& P,const Standard_Real U,const Standard_Real V,const Standard_Real Param,const Standard_Real Tol);


Standard_EXPORT BRepBlend_Extremity(const gp_Pnt& P,const Standard_Real U,const Standard_Real V,const Standard_Real Param,const Standard_Real Tol,const Handle(Adaptor3d_HVertex)& Vtx);


Standard_EXPORT BRepBlend_Extremity(const gp_Pnt& P,const Standard_Real W,const Standard_Real Param,const Standard_Real Tol);


Standard_EXPORT   void SetValue(const gp_Pnt& P,const Standard_Real U,const Standard_Real V,const Standard_Real Param,const Standard_Real Tol) ;


Standard_EXPORT   void SetValue(const gp_Pnt& P,const Standard_Real U,const Standard_Real V,const Standard_Real Param,const Standard_Real Tol,const Handle(Adaptor3d_HVertex)& Vtx) ;


Standard_EXPORT   void SetValue(const gp_Pnt& P,const Standard_Real W,const Standard_Real Param,const Standard_Real Tol) ;

 const gp_Pnt& Value() const;

  void SetTangent(const gp_Vec& Tangent) ;

  Standard_Boolean HasTangent() const;

 const gp_Vec& Tangent() const;

  Standard_Real Tolerance() const;


Standard_EXPORT   void SetVertex(const Handle(Adaptor3d_HVertex)& V) ;


Standard_EXPORT   void AddArc(const Handle(Adaptor2d_HCurve2d)& A,const Standard_Real Param,const IntSurf_Transition& TLine,const IntSurf_Transition& TArc) ;

  void Parameters(Standard_Real& U,Standard_Real& V) const;

  Standard_Boolean IsVertex() const;

 const Handle_Adaptor3d_HVertex& Vertex() const;

  Standard_Integer NbPointOnRst() const;

 const BRepBlend_PointOnRst& PointOnRst(const Standard_Integer Index) const;

  Standard_Real Parameter() const;

  Standard_Real ParameterOnGuide() const;





protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
Handle_Adaptor3d_HVertex vtx;
BRepBlend_SequenceOfPointOnRst seqpt;
gp_Pnt pt;
gp_Vec tang;
Standard_Real param;
Standard_Real u;
Standard_Real v;
Standard_Real tol;
Standard_Boolean isvtx;
Standard_Boolean hastang;


};

#define TheVertex Handle_Adaptor3d_HVertex
#define TheVertex_hxx <Adaptor3d_HVertex.hxx>
#define TheArc Handle_Adaptor2d_HCurve2d
#define TheArc_hxx <Adaptor2d_HCurve2d.hxx>
#define ThePointOnRst BRepBlend_PointOnRst
#define ThePointOnRst_hxx <BRepBlend_PointOnRst.hxx>
#define TheSequenceOfPointOnRst BRepBlend_SequenceOfPointOnRst
#define TheSequenceOfPointOnRst_hxx <BRepBlend_SequenceOfPointOnRst.hxx>
#define Blend_Extremity BRepBlend_Extremity
#define Blend_Extremity_hxx <BRepBlend_Extremity.hxx>

#include <Blend_Extremity.lxx>

#undef TheVertex
#undef TheVertex_hxx
#undef TheArc
#undef TheArc_hxx
#undef ThePointOnRst
#undef ThePointOnRst_hxx
#undef TheSequenceOfPointOnRst
#undef TheSequenceOfPointOnRst_hxx
#undef Blend_Extremity
#undef Blend_Extremity_hxx


// other Inline functions and methods (like "C++: function call" methods)
//


#endif
