// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _BRepCheck_Shell_HeaderFile
#define _BRepCheck_Shell_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_BRepCheck_Shell_HeaderFile
#include <Handle_BRepCheck_Shell.hxx>
#endif

#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
#ifndef _BRepCheck_Status_HeaderFile
#include <BRepCheck_Status.hxx>
#endif
#ifndef _TopTools_IndexedDataMapOfShapeListOfShape_HeaderFile
#include <TopTools_IndexedDataMapOfShapeListOfShape.hxx>
#endif
#ifndef _BRepCheck_Result_HeaderFile
#include <BRepCheck_Result.hxx>
#endif
class TopoDS_Shell;
class TopoDS_Shape;
class TopTools_ListOfShape;



class BRepCheck_Shell : public BRepCheck_Result {

public:
 // Methods PUBLIC
 // 


Standard_EXPORT BRepCheck_Shell(const TopoDS_Shell& S);


Standard_EXPORT   void InContext(const TopoDS_Shape& ContextShape) ;


Standard_EXPORT   void Minimum() ;


Standard_EXPORT   void Blind() ;

//! Checks if the oriented  faces of the shell  give a <br>
//!          closed shell.    If the  wire is  closed,  returns <br>
//!          BRepCheck_NoError.If      <Update>     is  set  to <br>
//!          Standard_True, registers the status in the list. <br>
Standard_EXPORT   BRepCheck_Status Closed(const Standard_Boolean Update = Standard_False) ;

//! Checks if the   oriented faces  of  the shell  are <br>
//!          correctly oriented.  An internal  call is  made to <br>
//!          the  method  Closed.   If  <Update>    is set   to <br>
//!          Standard_True, registers the status in the list. <br>
Standard_EXPORT   BRepCheck_Status Orientation(const Standard_Boolean Update = Standard_False) ;


Standard_EXPORT   void SetUnorientable() ;


Standard_EXPORT   Standard_Boolean IsUnorientable() const;


Standard_EXPORT   Standard_Integer NbConnectedSet(TopTools_ListOfShape& theSets) ;
//Standard_EXPORT ~BRepCheck_Shell();




 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
Standard_Integer myNbori;
Standard_Boolean myCdone;
BRepCheck_Status myCstat;
Standard_Boolean myOdone;
BRepCheck_Status myOstat;
TopTools_IndexedDataMapOfShapeListOfShape myMapEF;


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
