// File generated by CPPExt (Value)
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _BRepClass_Intersector_HeaderFile
#define _BRepClass_Intersector_HeaderFile

#ifndef _Geom2dInt_IntConicCurveOfGInter_HeaderFile
#include <Geom2dInt_IntConicCurveOfGInter.hxx>
#endif
#ifndef _Standard_Real_HeaderFile
#include <Standard_Real.hxx>
#endif
class gp_Lin2d;
class BRepClass_Edge;
class gp_Dir2d;


#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_Macro_HeaderFile
#include <Standard_Macro.hxx>
#endif

//! Implement the Intersector2d required by the classifier. <br>
class BRepClass_Intersector  : public Geom2dInt_IntConicCurveOfGInter {

public:

    void* operator new(size_t,void* anAddress) 
      {
        return anAddress;
      }
    void* operator new(size_t size) 
      { 
        return Standard::Allocate(size); 
      }
    void  operator delete(void *anAddress) 
      { 
        if (anAddress) Standard::Free((Standard_Address&)anAddress); 
      }
 // Methods PUBLIC
 // 


Standard_EXPORT BRepClass_Intersector();

//! Intersect the line segment and the edge. <br>
Standard_EXPORT   void Perform(const gp_Lin2d& L,const Standard_Real P,const Standard_Real Tol,const BRepClass_Edge& E) ;

//! Returns in <T>,  <N> and <C>  the tangent,  normal <br>
//!          and  curvature of the edge  <E> at parameter value <br>
//!          <U>. <br>
Standard_EXPORT   void LocalGeometry(const BRepClass_Edge& E,const Standard_Real U,gp_Dir2d& T,gp_Dir2d& N,Standard_Real& C) const;





protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
