// File generated by CPPExt (Value)
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _BRepFill_HeaderFile
#define _BRepFill_HeaderFile

#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
#ifndef _Standard_Real_HeaderFile
#include <Standard_Real.hxx>
#endif
class TopoDS_Face;
class TopoDS_Edge;
class TopoDS_Shell;
class TopoDS_Wire;
class TopoDS_Shape;
class gp_Ax3;
class gp_Pnt;
class gp_Vec;
class TColStd_Array1OfReal;
class BRepFill_Generator;
class BRepFill_SectionLaw;
class BRepFill_ShapeLaw;
class BRepFill_NSections;
class BRepFill_Draft;
class BRepFill_LocationLaw;
class BRepFill_DraftLaw;
class BRepFill_Edge3DLaw;
class BRepFill_EdgeOnSurfLaw;
class BRepFill_ACRLaw;
class BRepFill_Pipe;
class BRepFill_PipeShell;
class BRepFill_Evolved;
class BRepFill_Sweep;
class BRepFill_CompatibleWires;
class BRepFill_OffsetWire;
class BRepFill_OffsetAncestors;
class BRepFill_ListOfOffsetWire;
class BRepFill_ApproxSeewing;
class BRepFill_MultiLine;
class BRepFill_MultiLineTool;
class BRepFill_ComputeCLine;
class BRepFill_TrimSurfaceTool;
class BRepFill_TrimEdgeTool;
class BRepFill_SectionPlacement;
class BRepFill_Section;
class BRepFill_TrimShellCorner;
class BRepFill_SequenceOfSection;
class BRepFill_DataMapOfNodeDataMapOfShapeShape;
class BRepFill_DataMapOfNodeShape;
class BRepFill_DataMapOfShapeSequenceOfShape;
class BRepFill_DataMapOfShapeDataMapOfShapeListOfShape;
class BRepFill_DataMapOfShapeSequenceOfReal;
class BRepFill_DataMapOfShapeSequenceOfPnt;
class BRepFill_DataMapOfOrientedShapeListOfShape;
class BRepFill_CurveConstraint;
class BRepFill_Filling;
class BRepFill_FaceAndOrder;
class BRepFill_EdgeFaceAndOrder;
class BRepFill_SequenceOfFaceAndOrder;
class BRepFill_SequenceOfEdgeFaceAndOrder;
class BRepFill_ListNodeOfListOfOffsetWire;
class BRepFill_ListIteratorOfListOfOffsetWire;
class BRepFill_MyLeastSquareOfComputeCLine;
class BRepFill_SequenceNodeOfSequenceOfSection;
class BRepFill_DataMapNodeOfDataMapOfNodeDataMapOfShapeShape;
class BRepFill_DataMapIteratorOfDataMapOfNodeDataMapOfShapeShape;
class BRepFill_DataMapNodeOfDataMapOfNodeShape;
class BRepFill_DataMapIteratorOfDataMapOfNodeShape;
class BRepFill_DataMapNodeOfDataMapOfShapeSequenceOfShape;
class BRepFill_DataMapIteratorOfDataMapOfShapeSequenceOfShape;
class BRepFill_DataMapNodeOfDataMapOfShapeDataMapOfShapeListOfShape;
class BRepFill_DataMapIteratorOfDataMapOfShapeDataMapOfShapeListOfShape;
class BRepFill_DataMapNodeOfDataMapOfShapeSequenceOfReal;
class BRepFill_DataMapIteratorOfDataMapOfShapeSequenceOfReal;
class BRepFill_DataMapNodeOfDataMapOfShapeSequenceOfPnt;
class BRepFill_DataMapIteratorOfDataMapOfShapeSequenceOfPnt;
class BRepFill_DataMapNodeOfDataMapOfOrientedShapeListOfShape;
class BRepFill_DataMapIteratorOfDataMapOfOrientedShapeListOfShape;
class BRepFill_SequenceNodeOfSequenceOfFaceAndOrder;
class BRepFill_SequenceNodeOfSequenceOfEdgeFaceAndOrder;


#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_Macro_HeaderFile
#include <Standard_Macro.hxx>
#endif


class BRepFill  {

public:

    void* operator new(size_t,void* anAddress) 
      {
        return anAddress;
      }
    void* operator new(size_t size) 
      { 
        return Standard::Allocate(size); 
      }
    void  operator delete(void *anAddress) 
      { 
        if (anAddress) Standard::Free((Standard_Address&)anAddress); 
      }
 // Methods PUBLIC
 // 


Standard_EXPORT static  TopoDS_Face Face(const TopoDS_Edge& Edge1,const TopoDS_Edge& Edge2) ;


Standard_EXPORT static  TopoDS_Shell Shell(const TopoDS_Wire& Wire1,const TopoDS_Wire& Wire2) ;

//! Computes  <AxeProf>  as Follow. <Location> is <br>
//!          the Position of the nearest vertex V  of <Profile> <br>
//!          to <Spine>.<XDirection> is confused with the tangent <br>
//!          to <Spine> at the projected point of V on the Spine. <br>
//!          <Direction> is normal to <Spine>. <br>
//!          <Spine> is a plane wire or a plane face. <br>
Standard_EXPORT static  void Axe(const TopoDS_Shape& Spine,const TopoDS_Wire& Profile,gp_Ax3& AxeProf,Standard_Boolean& ProfOnSpine,const Standard_Real Tol) ;

//!  Compute ACR on a  wire <br>
Standard_EXPORT static  void ComputeACR(const TopoDS_Wire& wire,TColStd_Array1OfReal& ACR) ;


Standard_EXPORT static  TopoDS_Wire InsertACR(const TopoDS_Wire& wire,const TColStd_Array1OfReal& ACRcuts,const Standard_Real prec) ;





protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 

//! Computes origins and orientation on a closed wire <br>
Standard_EXPORT static  void SearchOrigin(TopoDS_Wire& W,const gp_Pnt& P,const gp_Vec& V,const Standard_Real Tol) ;


 // Fields PRIVATE
 //

friend class BRepFill_Generator;
friend class BRepFill_SectionLaw;
friend class BRepFill_ShapeLaw;
friend class BRepFill_NSections;
friend class BRepFill_Draft;
friend class BRepFill_LocationLaw;
friend class BRepFill_DraftLaw;
friend class BRepFill_Edge3DLaw;
friend class BRepFill_EdgeOnSurfLaw;
friend class BRepFill_ACRLaw;
friend class BRepFill_Pipe;
friend class BRepFill_PipeShell;
friend class BRepFill_Evolved;
friend class BRepFill_Sweep;
friend class BRepFill_CompatibleWires;
friend class BRepFill_OffsetWire;
friend class BRepFill_OffsetAncestors;
friend class BRepFill_ListOfOffsetWire;
friend class BRepFill_ApproxSeewing;
friend class BRepFill_MultiLine;
friend class BRepFill_MultiLineTool;
friend class BRepFill_ComputeCLine;
friend class BRepFill_TrimSurfaceTool;
friend class BRepFill_TrimEdgeTool;
friend class BRepFill_SectionPlacement;
friend class BRepFill_Section;
friend class BRepFill_TrimShellCorner;
friend class BRepFill_SequenceOfSection;
friend class BRepFill_DataMapOfNodeDataMapOfShapeShape;
friend class BRepFill_DataMapOfNodeShape;
friend class BRepFill_DataMapOfShapeSequenceOfShape;
friend class BRepFill_DataMapOfShapeDataMapOfShapeListOfShape;
friend class BRepFill_DataMapOfShapeSequenceOfReal;
friend class BRepFill_DataMapOfShapeSequenceOfPnt;
friend class BRepFill_DataMapOfOrientedShapeListOfShape;
friend class BRepFill_CurveConstraint;
friend class BRepFill_Filling;
friend class BRepFill_FaceAndOrder;
friend class BRepFill_EdgeFaceAndOrder;
friend class BRepFill_SequenceOfFaceAndOrder;
friend class BRepFill_SequenceOfEdgeFaceAndOrder;
friend class BRepFill_ListNodeOfListOfOffsetWire;
friend class BRepFill_ListIteratorOfListOfOffsetWire;
friend class BRepFill_MyLeastSquareOfComputeCLine;
friend class BRepFill_SequenceNodeOfSequenceOfSection;
friend class BRepFill_DataMapNodeOfDataMapOfNodeDataMapOfShapeShape;
friend class BRepFill_DataMapIteratorOfDataMapOfNodeDataMapOfShapeShape;
friend class BRepFill_DataMapNodeOfDataMapOfNodeShape;
friend class BRepFill_DataMapIteratorOfDataMapOfNodeShape;
friend class BRepFill_DataMapNodeOfDataMapOfShapeSequenceOfShape;
friend class BRepFill_DataMapIteratorOfDataMapOfShapeSequenceOfShape;
friend class BRepFill_DataMapNodeOfDataMapOfShapeDataMapOfShapeListOfShape;
friend class BRepFill_DataMapIteratorOfDataMapOfShapeDataMapOfShapeListOfShape;
friend class BRepFill_DataMapNodeOfDataMapOfShapeSequenceOfReal;
friend class BRepFill_DataMapIteratorOfDataMapOfShapeSequenceOfReal;
friend class BRepFill_DataMapNodeOfDataMapOfShapeSequenceOfPnt;
friend class BRepFill_DataMapIteratorOfDataMapOfShapeSequenceOfPnt;
friend class BRepFill_DataMapNodeOfDataMapOfOrientedShapeListOfShape;
friend class BRepFill_DataMapIteratorOfDataMapOfOrientedShapeListOfShape;
friend class BRepFill_SequenceNodeOfSequenceOfFaceAndOrder;
friend class BRepFill_SequenceNodeOfSequenceOfEdgeFaceAndOrder;

};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
