// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _BRepFill_ShapeLaw_HeaderFile
#define _BRepFill_ShapeLaw_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_BRepFill_ShapeLaw_HeaderFile
#include <Handle_BRepFill_ShapeLaw.hxx>
#endif

#ifndef _TopoDS_Shape_HeaderFile
#include <TopoDS_Shape.hxx>
#endif
#ifndef _Handle_TopTools_HArray1OfShape_HeaderFile
#include <Handle_TopTools_HArray1OfShape.hxx>
#endif
#ifndef _Handle_Law_Function_HeaderFile
#include <Handle_Law_Function.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
#ifndef _BRepFill_SectionLaw_HeaderFile
#include <BRepFill_SectionLaw.hxx>
#endif
#ifndef _Handle_GeomFill_SectionLaw_HeaderFile
#include <Handle_GeomFill_SectionLaw.hxx>
#endif
#ifndef _GeomAbs_Shape_HeaderFile
#include <GeomAbs_Shape.hxx>
#endif
#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
#ifndef _Standard_Real_HeaderFile
#include <Standard_Real.hxx>
#endif
class TopTools_HArray1OfShape;
class Law_Function;
class TopoDS_Vertex;
class TopoDS_Wire;
class GeomFill_SectionLaw;
class TopoDS_Shape;
class TopoDS_Edge;


//! Build Section Law, with an Vertex, or an Wire <br>
class BRepFill_ShapeLaw : public BRepFill_SectionLaw {

public:
 // Methods PUBLIC
 // 

//! Construct an constant Law <br>
Standard_EXPORT BRepFill_ShapeLaw(const TopoDS_Vertex& V,const Standard_Boolean Build = Standard_True);

//! Construct an constant Law <br>
Standard_EXPORT BRepFill_ShapeLaw(const TopoDS_Wire& W,const Standard_Boolean Build = Standard_True);

//! Construct an evolutive Law <br>
Standard_EXPORT BRepFill_ShapeLaw(const TopoDS_Wire& W,const Handle(Law_Function)& L,const Standard_Boolean Build = Standard_True);

//! Say if the input shape is a  vertex. <br>
Standard_EXPORT virtual  Standard_Boolean IsVertex() const;

//! Say if the Law is  Constant. <br>
Standard_EXPORT virtual  Standard_Boolean IsConstant() const;

//! Give the law build on a concaneted section <br>
Standard_EXPORT virtual  Handle_GeomFill_SectionLaw ConcatenedLaw() const;


Standard_EXPORT virtual  GeomAbs_Shape Continuity(const Standard_Integer Index,const Standard_Real TolAngular) const;


Standard_EXPORT virtual  Standard_Real VertexTol(const Standard_Integer Index,const Standard_Real Param) const;


Standard_EXPORT virtual  TopoDS_Vertex Vertex(const Standard_Integer Index,const Standard_Real Param) const;


Standard_EXPORT virtual  void D0(const Standard_Real Param,TopoDS_Shape& S) ;

 const TopoDS_Edge& Edge(const Standard_Integer Index) const;
//Standard_EXPORT ~BRepFill_ShapeLaw();




 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //
Standard_Boolean vertex;


private: 

 // Methods PRIVATE
 // 


Standard_EXPORT   void Init(const Standard_Boolean B) ;


 // Fields PRIVATE
 //
TopoDS_Shape myShape;
Handle_TopTools_HArray1OfShape myEdges;
Handle_Law_Function TheLaw;


};


#include <BRepFill_ShapeLaw.lxx>



// other Inline functions and methods (like "C++: function call" methods)
//


#endif
