// File generated by CPPExt (Value)
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _BRepGProp_UFunctionOfVinertGK_HeaderFile
#define _BRepGProp_UFunctionOfVinertGK_HeaderFile

#ifndef _BRepGProp_Face_HeaderFile
#include <BRepGProp_Face.hxx>
#endif
#ifndef _gp_Pnt_HeaderFile
#include <gp_Pnt.hxx>
#endif
#ifndef _Standard_Address_HeaderFile
#include <Standard_Address.hxx>
#endif
#ifndef _Standard_Real_HeaderFile
#include <Standard_Real.hxx>
#endif
#ifndef _GProp_ValueType_HeaderFile
#include <GProp_ValueType.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
#ifndef _math_Function_HeaderFile
#include <math_Function.hxx>
#endif
class TopoDS_Edge;
class BRepGProp_Face;
class BRepGProp_Domain;
class BRepGProp_VinertGK;
class BRepGProp_TFunctionOfVinertGK;
class gp_Pnt;
class gp_XYZ;


#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_Macro_HeaderFile
#include <Standard_Macro.hxx>
#endif


class BRepGProp_UFunctionOfVinertGK  : public math_Function {

public:

    void* operator new(size_t,void* anAddress) 
      {
        return anAddress;
      }
    void* operator new(size_t size) 
      { 
        return Standard::Allocate(size); 
      }
    void  operator delete(void *anAddress) 
      { 
        if (anAddress) Standard::Free((Standard_Address&)anAddress); 
      }
 // Methods PUBLIC
 // 


Standard_EXPORT BRepGProp_UFunctionOfVinertGK(const BRepGProp_Face& theSurface,const gp_Pnt& theVertex,const Standard_Boolean IsByPoint,const Standard_Address theCoeffs);

  void SetValueType(const GProp_ValueType theType) ;

  void SetVParam(const Standard_Real theVParam) ;


Standard_EXPORT virtual  Standard_Boolean Value(const Standard_Real X,Standard_Real& F) ;





protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


Standard_EXPORT   Standard_Real VolumeValue(const Standard_Real X,gp_XYZ& thePMP0,Standard_Real& theS,Standard_Real& theD1) ;


Standard_EXPORT   Standard_Boolean CenterMassValue(const Standard_Real X,Standard_Real& F) ;


Standard_EXPORT   Standard_Boolean InertiaValue(const Standard_Real X,Standard_Real& F) ;


 // Fields PRIVATE
 //
BRepGProp_Face mySurface;
gp_Pnt myVertex;
Standard_Address myCoeffs;
Standard_Real myVParam;
GProp_ValueType myValueType;
Standard_Boolean myIsByPoint;


};

#define Arc TopoDS_Edge
#define Arc_hxx <TopoDS_Edge.hxx>
#define Face BRepGProp_Face
#define Face_hxx <BRepGProp_Face.hxx>
#define Domain BRepGProp_Domain
#define Domain_hxx <BRepGProp_Domain.hxx>
#define GProp_UFunction BRepGProp_UFunctionOfVinertGK
#define GProp_UFunction_hxx <BRepGProp_UFunctionOfVinertGK.hxx>
#define GProp_TFunction BRepGProp_TFunctionOfVinertGK
#define GProp_TFunction_hxx <BRepGProp_TFunctionOfVinertGK.hxx>
#define GProp_VGPropsGK BRepGProp_VinertGK
#define GProp_VGPropsGK_hxx <BRepGProp_VinertGK.hxx>

#include <GProp_UFunction.lxx>

#undef Arc
#undef Arc_hxx
#undef Face
#undef Face_hxx
#undef Domain
#undef Domain_hxx
#undef GProp_UFunction
#undef GProp_UFunction_hxx
#undef GProp_TFunction
#undef GProp_TFunction_hxx
#undef GProp_VGPropsGK
#undef GProp_VGPropsGK_hxx


// other Inline functions and methods (like "C++: function call" methods)
//


#endif
