// File generated by CPPExt (Value)
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _BRepMesh_DiscretFactory_HeaderFile
#define _BRepMesh_DiscretFactory_HeaderFile

#ifndef _BRepMesh_PDiscretRoot_HeaderFile
#include <BRepMesh_PDiscretRoot.hxx>
#endif
#ifndef _BRepMesh_FactoryError_HeaderFile
#include <BRepMesh_FactoryError.hxx>
#endif
#ifndef _BRepMesh_MapOfAsciiString_HeaderFile
#include <BRepMesh_MapOfAsciiString.hxx>
#endif
#ifndef _TCollection_AsciiString_HeaderFile
#include <TCollection_AsciiString.hxx>
#endif
#ifndef _Standard_Real_HeaderFile
#include <Standard_Real.hxx>
#endif
class BRepMesh_MapOfAsciiString;
class TCollection_AsciiString;
class TopoDS_Shape;


#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_Macro_HeaderFile
#include <Standard_Macro.hxx>
#endif


class BRepMesh_DiscretFactory  {

public:

    void* operator new(size_t,void* anAddress) 
      {
        return anAddress;
      }
    void* operator new(size_t size) 
      { 
        return Standard::Allocate(size); 
      }
    void  operator delete(void *anAddress) 
      { 
        if (anAddress) Standard::Free((Standard_Address&)anAddress); 
      }
 // Methods PUBLIC
 // 


Standard_EXPORT static  BRepMesh_DiscretFactory& Get() ;


Standard_EXPORT  const BRepMesh_MapOfAsciiString& Names() const;


Standard_EXPORT   void SetDefaultName(const TCollection_AsciiString& theName) ;


Standard_EXPORT  const TCollection_AsciiString& DefaultName() const;


Standard_EXPORT   void SetFunctionName(const TCollection_AsciiString& theName) ;


Standard_EXPORT  const TCollection_AsciiString& FunctionName() const;


Standard_EXPORT   BRepMesh_PDiscretRoot& Discret(const TopoDS_Shape& theShape,const Standard_Real theDeflection,const Standard_Real theAngle) ;


Standard_EXPORT   BRepMesh_FactoryError ErrorStatus() const;





protected:

 // Methods PROTECTED
 // 


Standard_EXPORT BRepMesh_DiscretFactory();
Standard_EXPORT virtual ~BRepMesh_DiscretFactory();


Standard_EXPORT   void Clear() ;


 // Fields PROTECTED
 //
BRepMesh_PDiscretRoot myPDiscret;
BRepMesh_FactoryError myErrorStatus;
BRepMesh_MapOfAsciiString myNames;
TCollection_AsciiString myFixedNames[1];
TCollection_AsciiString myDefaultName;
TCollection_AsciiString myFunctionName;


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
