// File generated by CPPExt (Value)
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _BRepSweep_Iterator_HeaderFile
#define _BRepSweep_Iterator_HeaderFile

#ifndef _TopoDS_Iterator_HeaderFile
#include <TopoDS_Iterator.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
#ifndef _TopAbs_Orientation_HeaderFile
#include <TopAbs_Orientation.hxx>
#endif
class Standard_NoMoreObject;
class Standard_NoSuchObject;
class TopoDS_Shape;


#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_Macro_HeaderFile
#include <Standard_Macro.hxx>
#endif

//! This class provides iteration services required by <br>
//!          the Generating Line (TopoDS Shape) of a BRepSweep. <br>
//!          This   tool is  used  to   iterate  on the  direct <br>
//!          sub-shapes of a Shape. <br>
//! <br>
class BRepSweep_Iterator  {

public:

    void* operator new(size_t,void* anAddress) 
      {
        return anAddress;
      }
    void* operator new(size_t size) 
      { 
        return Standard::Allocate(size); 
      }
    void  operator delete(void *anAddress) 
      { 
        if (anAddress) Standard::Free((Standard_Address&)anAddress); 
      }
 // Methods PUBLIC
 // 


Standard_EXPORT BRepSweep_Iterator();

//! Resest the Iterator on sub-shapes of <aShape>. <br>
Standard_EXPORT   void Init(const TopoDS_Shape& aShape) ;
//! Returns True if there is a current sub-shape. <br>
//! <br>
  Standard_Boolean More() const;

//! Moves to the next sub-shape. <br>
Standard_EXPORT   void Next() ;
//! Returns the current sub-shape. <br>
 const TopoDS_Shape& Value() const;
//! Returns the orientation of the current sub-shape. <br>
  TopAbs_Orientation Orientation() const;





protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
TopoDS_Iterator myIterator;


};


#include <BRepSweep_Iterator.lxx>



// other Inline functions and methods (like "C++: function call" methods)
//


#endif
