// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _BRep_TEdge_HeaderFile
#define _BRep_TEdge_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_BRep_TEdge_HeaderFile
#include <Handle_BRep_TEdge.hxx>
#endif

#ifndef _Standard_Real_HeaderFile
#include <Standard_Real.hxx>
#endif
#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
#ifndef _BRep_ListOfCurveRepresentation_HeaderFile
#include <BRep_ListOfCurveRepresentation.hxx>
#endif
#ifndef _TopoDS_TEdge_HeaderFile
#include <TopoDS_TEdge.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
#ifndef _Handle_TopoDS_TShape_HeaderFile
#include <Handle_TopoDS_TShape.hxx>
#endif
class BRep_ListOfCurveRepresentation;
class TopoDS_TShape;


//! The TEdge from BRep is  inherited from  the  TEdge <br>
//!          from TopoDS. It contains the geometric data. <br>
//! <br>
//!          The TEdge contains : <br>
//! <br>
//!           * A tolerance. <br>
//! <br>
//!           * A same parameter flag. <br>
//! <br>
//!           * A same range flag. <br>
//! <br>
//!           * A Degenerated flag. <br>
//! <br>
//!           *  A  list   of curve representation. <br>
class BRep_TEdge : public TopoDS_TEdge {

public:
 // Methods PUBLIC
 // 

//! Creates an empty TEdge. <br>
Standard_EXPORT BRep_TEdge();

  Standard_Real Tolerance() const;

  void Tolerance(const Standard_Real T) ;
//! Sets the tolerance  to the   max  of <T>  and  the <br>
//!          current  tolerance. <br>
//! <br>
  void UpdateTolerance(const Standard_Real T) ;


Standard_EXPORT   Standard_Boolean SameParameter() const;


Standard_EXPORT   void SameParameter(const Standard_Boolean S) ;


Standard_EXPORT   Standard_Boolean SameRange() const;


Standard_EXPORT   void SameRange(const Standard_Boolean S) ;


Standard_EXPORT   Standard_Boolean Degenerated() const;


Standard_EXPORT   void Degenerated(const Standard_Boolean S) ;

 const BRep_ListOfCurveRepresentation& Curves() const;

  BRep_ListOfCurveRepresentation& ChangeCurves() ;

//! Returns a copy  of the  TShape  with no sub-shapes. <br>
Standard_EXPORT   Handle_TopoDS_TShape EmptyCopy() const;
//Standard_EXPORT ~BRep_TEdge();




 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
Standard_Real myTolerance;
Standard_Integer myFlags;
BRep_ListOfCurveRepresentation myCurves;


};


#include <BRep_TEdge.lxx>



// other Inline functions and methods (like "C++: function call" methods)
//


#endif
