// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _BRep_TVertex_HeaderFile
#define _BRep_TVertex_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_BRep_TVertex_HeaderFile
#include <Handle_BRep_TVertex.hxx>
#endif

#ifndef _gp_Pnt_HeaderFile
#include <gp_Pnt.hxx>
#endif
#ifndef _Standard_Real_HeaderFile
#include <Standard_Real.hxx>
#endif
#ifndef _BRep_ListOfPointRepresentation_HeaderFile
#include <BRep_ListOfPointRepresentation.hxx>
#endif
#ifndef _TopoDS_TVertex_HeaderFile
#include <TopoDS_TVertex.hxx>
#endif
#ifndef _Handle_TopoDS_TShape_HeaderFile
#include <Handle_TopoDS_TShape.hxx>
#endif
class gp_Pnt;
class BRep_ListOfPointRepresentation;
class TopoDS_TShape;


//! The TVertex from  BRep inherits  from  the TVertex <br>
//!          from TopoDS. It contains the geometric data. <br>
//! <br>
//!          The  TVertex contains a 3d point and a tolerance. <br>
//! <br>
class BRep_TVertex : public TopoDS_TVertex {

public:
 // Methods PUBLIC
 // 


Standard_EXPORT BRep_TVertex();

  Standard_Real Tolerance() const;

  void Tolerance(const Standard_Real T) ;
//! Sets the tolerance  to the   max  of <T>  and  the <br>
//!          current  tolerance. <br>
//! <br>
  void UpdateTolerance(const Standard_Real T) ;

 const gp_Pnt& Pnt() const;

  void Pnt(const gp_Pnt& P) ;

 const BRep_ListOfPointRepresentation& Points() const;

  BRep_ListOfPointRepresentation& ChangePoints() ;

//! Returns a copy  of the  TShape  with no sub-shapes. <br>
Standard_EXPORT   Handle_TopoDS_TShape EmptyCopy() const;
//Standard_EXPORT ~BRep_TVertex();




 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
gp_Pnt myPnt;
Standard_Real myTolerance;
BRep_ListOfPointRepresentation myPoints;


};


#include <BRep_TVertex.lxx>



// other Inline functions and methods (like "C++: function call" methods)
//


#endif
