// File generated by CPPExt (Value)
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _BinTools_HeaderFile
#define _BinTools_HeaderFile

#ifndef _Standard_OStream_HeaderFile
#include <Standard_OStream.hxx>
#endif
#ifndef _Standard_Real_HeaderFile
#include <Standard_Real.hxx>
#endif
#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
#ifndef _Standard_ExtCharacter_HeaderFile
#include <Standard_ExtCharacter.hxx>
#endif
#ifndef _Standard_IStream_HeaderFile
#include <Standard_IStream.hxx>
#endif
class BinTools_ShapeSet;
class BinTools_Curve2dSet;
class BinTools_CurveSet;
class BinTools_SurfaceSet;
class BinTools_LocationSet;


#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_Macro_HeaderFile
#include <Standard_Macro.hxx>
#endif

//! Tool to keep shapes in binary format <br>
class BinTools  {

public:

    void* operator new(size_t,void* anAddress) 
      {
        return anAddress;
      }
    void* operator new(size_t size) 
      { 
        return Standard::Allocate(size); 
      }
    void  operator delete(void *anAddress) 
      { 
        if (anAddress) Standard::Free((Standard_Address&)anAddress); 
      }
 // Methods PUBLIC
 // 


Standard_EXPORT static  Standard_OStream& PutReal(Standard_OStream& OS,const Standard_Real theValue) ;


Standard_EXPORT static  Standard_OStream& PutInteger(Standard_OStream& OS,const Standard_Integer theValue) ;


Standard_EXPORT static  Standard_OStream& PutBool(Standard_OStream& OS,const Standard_Boolean theValue) ;


Standard_EXPORT static  Standard_OStream& PutExtChar(Standard_OStream& OS,const Standard_ExtCharacter theValue) ;


Standard_EXPORT static  Standard_IStream& GetReal(Standard_IStream& IS,Standard_Real& theValue) ;


Standard_EXPORT static  Standard_IStream& GetInteger(Standard_IStream& IS,Standard_Integer& theValue) ;


Standard_EXPORT static  Standard_IStream& GetBool(Standard_IStream& IS,Standard_Boolean& theValue) ;


Standard_EXPORT static  Standard_IStream& GetExtChar(Standard_IStream& IS,Standard_ExtCharacter& theValue) ;





protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //

friend class BinTools_ShapeSet;
friend class BinTools_Curve2dSet;
friend class BinTools_CurveSet;
friend class BinTools_SurfaceSet;
friend class BinTools_LocationSet;

};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
