// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _CDF_Session_HeaderFile
#define _CDF_Session_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_CDF_Session_HeaderFile
#include <Handle_CDF_Session.hxx>
#endif

#ifndef _Handle_CDF_Directory_HeaderFile
#include <Handle_CDF_Directory.hxx>
#endif
#ifndef _Handle_CDF_Application_HeaderFile
#include <Handle_CDF_Application.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
#ifndef _Handle_CDF_MetaDataDriver_HeaderFile
#include <Handle_CDF_MetaDataDriver.hxx>
#endif
#ifndef _Standard_Transient_HeaderFile
#include <Standard_Transient.hxx>
#endif
class CDF_Directory;
class CDF_Application;
class CDF_MetaDataDriver;
class Standard_NoSuchObject;
class Standard_MultiplyDefined;



class CDF_Session : public Standard_Transient {

public:
 // Methods PUBLIC
 // 


Standard_EXPORT CDF_Session();

//! returns true if a session has been created. <br>
Standard_EXPORT static  Standard_Boolean Exists() ;

//! returns the only one instance of Session <br>
//!          that has been created. <br>
Standard_EXPORT static  Handle_CDF_Session CurrentSession() ;

//! returns the directory of the session; <br>
Standard_EXPORT   Handle_CDF_Directory Directory() const;


Standard_EXPORT   Standard_Boolean HasCurrentApplication() const;


Standard_EXPORT   Handle_CDF_Application CurrentApplication() const;


Standard_EXPORT   void SetCurrentApplication(const Handle(CDF_Application)& anApplication) ;


Standard_EXPORT   void UnsetCurrentApplication() ;


Standard_EXPORT   Handle_CDF_MetaDataDriver MetaDataDriver() const;


Standard_EXPORT   void LoadDriver() ;
//Standard_EXPORT ~CDF_Session();


friend class CDF_Application;


 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
Handle_CDF_Directory myDirectory;
Handle_CDF_Application myCurrentApplication;
Standard_Boolean myHasCurrentApplication;
Handle_CDF_MetaDataDriver myMetaDataDriver;


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
