// File generated by CPPExt (Value)
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _CDM_StackOfDocument_HeaderFile
#define _CDM_StackOfDocument_HeaderFile

#ifndef _Standard_Address_HeaderFile
#include <Standard_Address.hxx>
#endif
#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
#ifndef _Handle_CDM_Document_HeaderFile
#include <Handle_CDM_Document.hxx>
#endif
#ifndef _Handle_CDM_StackNodeOfStackOfDocument_HeaderFile
#include <Handle_CDM_StackNodeOfStackOfDocument.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
class Standard_NoSuchObject;
class CDM_StackIteratorOfStackOfDocument;
class CDM_Document;
class CDM_StackNodeOfStackOfDocument;


#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_Macro_HeaderFile
#include <Standard_Macro.hxx>
#endif


class CDM_StackOfDocument  {

public:

    void* operator new(size_t,void* anAddress) 
      {
        return anAddress;
      }
    void* operator new(size_t size) 
      { 
        return Standard::Allocate(size); 
      }
    void  operator delete(void *anAddress) 
      { 
        if (anAddress) Standard::Free((Standard_Address&)anAddress); 
      }
 // Methods PUBLIC
 // 


Standard_EXPORT CDM_StackOfDocument();


Standard_EXPORT  const CDM_StackOfDocument& Assign(const CDM_StackOfDocument& Other) ;
 const CDM_StackOfDocument& operator =(const CDM_StackOfDocument& Other) 
{
  return Assign(Other);
}


  Standard_Boolean IsEmpty() const;

  Standard_Integer Depth() const;


Standard_EXPORT  const Handle_CDM_Document& Top() const;


Standard_EXPORT   void Push(const Handle(CDM_Document)& I) ;


Standard_EXPORT   void Pop() ;


Standard_EXPORT   void Clear() ;
~CDM_StackOfDocument()
{
  Clear();
}



Standard_EXPORT   Handle_CDM_Document& ChangeTop() ;


friend class CDM_StackIteratorOfStackOfDocument;



protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


Standard_EXPORT CDM_StackOfDocument(const CDM_StackOfDocument& Other);


 // Fields PRIVATE
 //
Standard_Address myTop;
Standard_Integer myDepth;


};

#define Item Handle_CDM_Document
#define Item_hxx <CDM_Document.hxx>
#define TCollection_StackNode CDM_StackNodeOfStackOfDocument
#define TCollection_StackNode_hxx <CDM_StackNodeOfStackOfDocument.hxx>
#define TCollection_StackIterator CDM_StackIteratorOfStackOfDocument
#define TCollection_StackIterator_hxx <CDM_StackIteratorOfStackOfDocument.hxx>
#define Handle_TCollection_StackNode Handle_CDM_StackNodeOfStackOfDocument
#define TCollection_StackNode_Type_() CDM_StackNodeOfStackOfDocument_Type_()
#define TCollection_Stack CDM_StackOfDocument
#define TCollection_Stack_hxx <CDM_StackOfDocument.hxx>

#include <TCollection_Stack.lxx>

#undef Item
#undef Item_hxx
#undef TCollection_StackNode
#undef TCollection_StackNode_hxx
#undef TCollection_StackIterator
#undef TCollection_StackIterator_hxx
#undef Handle_TCollection_StackNode
#undef TCollection_StackNode_Type_
#undef TCollection_Stack
#undef TCollection_Stack_hxx


// other Inline functions and methods (like "C++: function call" methods)
//


#endif
