// File generated by CPPExt (Value)
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _ChFiDS_FaceInterference_HeaderFile
#define _ChFiDS_FaceInterference_HeaderFile

#ifndef _Standard_Real_HeaderFile
#include <Standard_Real.hxx>
#endif
#ifndef _Handle_Geom2d_Curve_HeaderFile
#include <Handle_Geom2d_Curve.hxx>
#endif
#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
#ifndef _TopAbs_Orientation_HeaderFile
#include <TopAbs_Orientation.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
class Geom2d_Curve;


#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_Macro_HeaderFile
#include <Standard_Macro.hxx>
#endif

//! interference face/fillet <br>
class ChFiDS_FaceInterference  {

public:

    void* operator new(size_t,void* anAddress) 
      {
        return anAddress;
      }
    void* operator new(size_t size) 
      { 
        return Standard::Allocate(size); 
      }
    void  operator delete(void *anAddress) 
      { 
        if (anAddress) Standard::Free((Standard_Address&)anAddress); 
      }
 // Methods PUBLIC
 // 


Standard_EXPORT ChFiDS_FaceInterference();

  void SetInterference(const Standard_Integer LineIndex,const TopAbs_Orientation Trans,const Handle(Geom2d_Curve)& PCurv1,const Handle(Geom2d_Curve)& PCurv2) ;


Standard_EXPORT   void SetTransition(const TopAbs_Orientation Trans) ;

  void SetFirstParameter(const Standard_Real U1) ;

  void SetLastParameter(const Standard_Real U1) ;


Standard_EXPORT   void SetParameter(const Standard_Real U1,const Standard_Boolean IsFirst) ;

  Standard_Integer LineIndex() const;

  void SetLineIndex(const Standard_Integer I) ;

  TopAbs_Orientation Transition() const;

 const Handle_Geom2d_Curve& PCurveOnFace() const;

 const Handle_Geom2d_Curve& PCurveOnSurf() const;

  Handle_Geom2d_Curve& ChangePCurveOnFace() ;

  Handle_Geom2d_Curve& ChangePCurveOnSurf() ;

  Standard_Real FirstParameter() const;

  Standard_Real LastParameter() const;


Standard_EXPORT   Standard_Real Parameter(const Standard_Boolean IsFirst) const;





protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
Standard_Real firstParam;
Standard_Real lastParam;
Handle_Geom2d_Curve pCurveOnFace;
Handle_Geom2d_Curve pCurveOnSurf;
Standard_Integer lineindex;
TopAbs_Orientation LineTransition;


};


#include <ChFiDS_FaceInterference.lxx>



// other Inline functions and methods (like "C++: function call" methods)
//


#endif
