// File generated by CPPExt (Value)
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _Draft_EdgeInfo_HeaderFile
#define _Draft_EdgeInfo_HeaderFile

#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
#ifndef _Handle_Geom_Curve_HeaderFile
#include <Handle_Geom_Curve.hxx>
#endif
#ifndef _TopoDS_Face_HeaderFile
#include <TopoDS_Face.hxx>
#endif
#ifndef _Handle_Geom2d_Curve_HeaderFile
#include <Handle_Geom2d_Curve.hxx>
#endif
#ifndef _gp_Pnt_HeaderFile
#include <gp_Pnt.hxx>
#endif
#ifndef _Standard_Real_HeaderFile
#include <Standard_Real.hxx>
#endif
class Geom_Curve;
class Geom2d_Curve;
class Standard_DomainError;
class TopoDS_Face;
class gp_Pnt;


#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_Macro_HeaderFile
#include <Standard_Macro.hxx>
#endif


class Draft_EdgeInfo  {

public:

    void* operator new(size_t,void* anAddress) 
      {
        return anAddress;
      }
    void* operator new(size_t size) 
      { 
        return Standard::Allocate(size); 
      }
    void  operator delete(void *anAddress) 
      { 
        if (anAddress) Standard::Free((Standard_Address&)anAddress); 
      }
 // Methods PUBLIC
 // 


Standard_EXPORT Draft_EdgeInfo();


Standard_EXPORT Draft_EdgeInfo(const Standard_Boolean HasNewGeometry);


Standard_EXPORT   void Add(const TopoDS_Face& F) ;


Standard_EXPORT   void RootFace(const TopoDS_Face& F) ;


Standard_EXPORT   void Tangent(const gp_Pnt& P) ;


Standard_EXPORT   Standard_Boolean IsTangent(gp_Pnt& P) const;


Standard_EXPORT   Standard_Boolean NewGeometry() const;


Standard_EXPORT   void SetNewGeometry(const Standard_Boolean NewGeom) ;


Standard_EXPORT  const Handle_Geom_Curve& Geometry() const;


Standard_EXPORT  const TopoDS_Face& FirstFace() const;


Standard_EXPORT  const TopoDS_Face& SecondFace() const;


Standard_EXPORT  const Handle_Geom2d_Curve& FirstPC() const;


Standard_EXPORT  const Handle_Geom2d_Curve& SecondPC() const;


Standard_EXPORT   Handle_Geom_Curve& ChangeGeometry() ;


Standard_EXPORT   Handle_Geom2d_Curve& ChangeFirstPC() ;


Standard_EXPORT   Handle_Geom2d_Curve& ChangeSecondPC() ;


Standard_EXPORT  const TopoDS_Face& RootFace() const;


Standard_EXPORT   void Tolerance(const Standard_Real tol) ;


Standard_EXPORT   Standard_Real Tolerance() const;





protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
Standard_Boolean myNewGeom;
Handle_Geom_Curve myGeom;
TopoDS_Face myFirstF;
TopoDS_Face mySeconF;
Handle_Geom2d_Curve myFirstPC;
Handle_Geom2d_Curve mySeconPC;
TopoDS_Face myRootFace;
Standard_Boolean myTgt;
gp_Pnt myPt;
Standard_Real myTol;


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
