// File generated by CPPExt (Value)
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _Draft_FaceInfo_HeaderFile
#define _Draft_FaceInfo_HeaderFile

#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
#ifndef _Handle_Geom_Surface_HeaderFile
#include <Handle_Geom_Surface.hxx>
#endif
#ifndef _TopoDS_Face_HeaderFile
#include <TopoDS_Face.hxx>
#endif
#ifndef _Handle_Geom_Curve_HeaderFile
#include <Handle_Geom_Curve.hxx>
#endif
class Geom_Surface;
class Geom_Curve;
class Standard_DomainError;
class TopoDS_Face;


#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_Macro_HeaderFile
#include <Standard_Macro.hxx>
#endif


class Draft_FaceInfo  {

public:

    void* operator new(size_t,void* anAddress) 
      {
        return anAddress;
      }
    void* operator new(size_t size) 
      { 
        return Standard::Allocate(size); 
      }
    void  operator delete(void *anAddress) 
      { 
        if (anAddress) Standard::Free((Standard_Address&)anAddress); 
      }
 // Methods PUBLIC
 // 


Standard_EXPORT Draft_FaceInfo();


Standard_EXPORT Draft_FaceInfo(const Handle(Geom_Surface)& S,const Standard_Boolean HasNewGeometry);


Standard_EXPORT   void RootFace(const TopoDS_Face& F) ;


Standard_EXPORT   Standard_Boolean NewGeometry() const;


Standard_EXPORT   void Add(const TopoDS_Face& F) ;


Standard_EXPORT  const TopoDS_Face& FirstFace() const;


Standard_EXPORT  const TopoDS_Face& SecondFace() const;


Standard_EXPORT  const Handle_Geom_Surface& Geometry() const;


Standard_EXPORT   Handle_Geom_Surface& ChangeGeometry() ;


Standard_EXPORT  const TopoDS_Face& RootFace() const;


Standard_EXPORT   Handle_Geom_Curve& ChangeCurve() ;


Standard_EXPORT  const Handle_Geom_Curve& Curve() const;





protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
Standard_Boolean myNewGeom;
Handle_Geom_Surface myGeom;
TopoDS_Face myRootFace;
TopoDS_Face myF1;
TopoDS_Face myF2;
Handle_Geom_Curve myCurv;


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
