// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _Draw_Grid_HeaderFile
#define _Draw_Grid_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_Draw_Grid_HeaderFile
#include <Handle_Draw_Grid.hxx>
#endif

#ifndef _Standard_Real_HeaderFile
#include <Standard_Real.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
#ifndef _Draw_Drawable3D_HeaderFile
#include <Draw_Drawable3D.hxx>
#endif
class Draw_Display;



class Draw_Grid : public Draw_Drawable3D {

public:
 // Methods PUBLIC
 // 

//! Creates a grid. <br>
Standard_EXPORT Draw_Grid();

//! Sets the steps along the X, Y & Z axis. <br>
Standard_EXPORT   void Steps(const Standard_Real StepX,const Standard_Real StepY,const Standard_Real StepZ) ;
//! Returns the step along the X axis. <br>
  Standard_Real StepX() const;
//! Returns the step along the Y axis. <br>
  Standard_Real StepY() const;
//! Returns the step along the Z axis. <br>
  Standard_Real StepZ() const;
//! Returns if the grid is active or not. <br>
  Standard_Boolean IsActive() const;

//! Displays the grid. <br>
Standard_EXPORT   void DrawOn(Draw_Display& Out) const;
//Standard_EXPORT ~Draw_Grid();




 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
Standard_Real myStepX;
Standard_Real myStepY;
Standard_Real myStepZ;
Standard_Boolean myIsActive;


};


#include <Draw_Grid.lxx>



// other Inline functions and methods (like "C++: function call" methods)
//


#endif
