// File generated by CPPExt (Value)
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _DsgPrs_IdenticPresentation_HeaderFile
#define _DsgPrs_IdenticPresentation_HeaderFile

#ifndef _Handle_Prs3d_Presentation_HeaderFile
#include <Handle_Prs3d_Presentation.hxx>
#endif
#ifndef _Handle_Prs3d_Drawer_HeaderFile
#include <Handle_Prs3d_Drawer.hxx>
#endif
class Prs3d_Presentation;
class Prs3d_Drawer;
class TCollection_ExtendedString;
class gp_Pnt;
class gp_Ax2;
class gp_Elips;


#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_Macro_HeaderFile
#include <Standard_Macro.hxx>
#endif


class DsgPrs_IdenticPresentation  {

public:

    void* operator new(size_t,void* anAddress) 
      {
        return anAddress;
      }
    void* operator new(size_t size) 
      { 
        return Standard::Allocate(size); 
      }
    void  operator delete(void *anAddress) 
      { 
        if (anAddress) Standard::Free((Standard_Address&)anAddress); 
      }
 // Methods PUBLIC
 // 

//! draws a line between <aPntAttach> and <br>
//!          <aPntOffset>. <br>
Standard_EXPORT static  void Add(const Handle(Prs3d_Presentation)& aPresentation,const Handle(Prs3d_Drawer)& aDrawer,const TCollection_ExtendedString& aText,const gp_Pnt& aPntAttach,const gp_Pnt& aPntOffset) ;

//! draws the 'identic' presentation by <br>
//!          drawing a line between <aFAttach> and <br>
//!          <aSAttach> , and a linkimg segment <br>
//!          between <aPntOffset> and its projection <br>
//!          on the precedent line. <br>
Standard_EXPORT static  void Add(const Handle(Prs3d_Presentation)& aPresentation,const Handle(Prs3d_Drawer)& aDrawer,const TCollection_ExtendedString& aText,const gp_Pnt& aFAttach,const gp_Pnt& aSAttach,const gp_Pnt& aPntOffset) ;

//! draws the 'identic' presentation in the case of <br>
//!          circles : draws an arc of circle between <br>
//!          <aFAttach> and <aSAttach> of center <aCenter> <br>
//!          and of radius dist(aCenter, aFAttach), and <br>
//!          draws a segment between <aPntOffset> and <br>
//!          its projection on the arc. <br>
Standard_EXPORT static  void Add(const Handle(Prs3d_Presentation)& aPresentation,const Handle(Prs3d_Drawer)& aDrawer,const TCollection_ExtendedString& aText,const gp_Ax2& aAx2,const gp_Pnt& aCenter,const gp_Pnt& aFAttach,const gp_Pnt& aSAttach,const gp_Pnt& aPntOffset) ;

//! draws the 'identic' presentation in the case of <br>
//!          circles : draws an arc of circle between <br>
//!          <aFAttach> and <aSAttach> of center <aCenter> <br>
//!          and of radius dist(aCenter, aFAttach), and <br>
//!          draws a segment between <aPntOffset> and <aPntOnCirc> <br>
Standard_EXPORT static  void Add(const Handle(Prs3d_Presentation)& aPresentation,const Handle(Prs3d_Drawer)& aDrawer,const TCollection_ExtendedString& aText,const gp_Ax2& aAx2,const gp_Pnt& aCenter,const gp_Pnt& aFAttach,const gp_Pnt& aSAttach,const gp_Pnt& aPntOffset,const gp_Pnt& aPntOnCirc) ;

//! draws the 'identic' presentation in the case of <br>
//!          ellipses: draws an arc of the anEllipse <br>
//!          between <aFAttach> and <aSAttach> and <br>
//!          draws a segment between <aPntOffset> and <aPntOnElli> <br>
Standard_EXPORT static  void Add(const Handle(Prs3d_Presentation)& aPresentation,const Handle(Prs3d_Drawer)& aDrawer,const TCollection_ExtendedString& aText,const gp_Elips& anEllipse,const gp_Pnt& aFAttach,const gp_Pnt& aSAttach,const gp_Pnt& aPntOffset,const gp_Pnt& aPntOnElli) ;





protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
