// File generated by CPPExt (Value)
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _DsgPrs_RadiusPresentation_HeaderFile
#define _DsgPrs_RadiusPresentation_HeaderFile

#ifndef _Handle_Prs3d_Presentation_HeaderFile
#include <Handle_Prs3d_Presentation.hxx>
#endif
#ifndef _Handle_Prs3d_Drawer_HeaderFile
#include <Handle_Prs3d_Drawer.hxx>
#endif
#ifndef _Standard_Real_HeaderFile
#include <Standard_Real.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
#ifndef _DsgPrs_ArrowSide_HeaderFile
#include <DsgPrs_ArrowSide.hxx>
#endif
class Prs3d_Presentation;
class Prs3d_Drawer;
class TCollection_ExtendedString;
class gp_Pnt;
class gp_Circ;


#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_Macro_HeaderFile
#include <Standard_Macro.hxx>
#endif

//! A framework to define display of radii. <br>
class DsgPrs_RadiusPresentation  {

public:

    void* operator new(size_t,void* anAddress) 
      {
        return anAddress;
      }
    void* operator new(size_t size) 
      { 
        return Standard::Allocate(size); 
      }
    void  operator delete(void *anAddress) 
      { 
        if (anAddress) Standard::Free((Standard_Address&)anAddress); 
      }
 // Methods PUBLIC
 // 

//! Adds the point AttachmentPoint, the circle aCircle, <br>
//! the text aText, and the parameters firstparam and <br>
//! lastparam to the presentation object aPresentation. <br>
//! The display attributes of these elements is defined by <br>
//! the attribute manager aDrawer. <br>
//! If the Boolean drawFromCenter is false, the <br>
//! arrowhead will point towards the center of aCircle. <br>
//! If the Boolean reverseArrow is true, the arrowhead <br>
//! will point away from the attachment point. <br>
Standard_EXPORT static  void Add(const Handle(Prs3d_Presentation)& aPresentation,const Handle(Prs3d_Drawer)& aDrawer,const TCollection_ExtendedString& aText,const gp_Pnt& AttachmentPoint,const gp_Circ& aCircle,const Standard_Real firstparam,const Standard_Real lastparam,const Standard_Boolean drawFromCenter = Standard_True,const Standard_Boolean reverseArrow = Standard_False) ;

//!  Adds the point AttachmentPoint, the circle aCircle, <br>
//! the text aText, and the parameters firstparam and <br>
//! lastparam to the presentation object aPresentation. <br>
//! The display attributes of these elements is defined by <br>
//! the attribute manager aDrawer. <br>
//! The value of the enumeration Arrowside determines <br>
//! the type of arrow displayed: whether there will be <br>
//! arrowheads at both ends or only one, for example. <br>
//! If the Boolean drawFromCenter is false, the <br>
//! arrowhead will point towards the center of aCircle. <br>
//! If the Boolean reverseArrow is true, the arrowhead <br>
//! will point away from the attachment point. <br>
Standard_EXPORT static  void Add(const Handle(Prs3d_Presentation)& aPresentation,const Handle(Prs3d_Drawer)& aDrawer,const TCollection_ExtendedString& aText,const gp_Pnt& AttachmentPoint,const gp_Circ& aCircle,const Standard_Real firstparam,const Standard_Real lastparam,const DsgPrs_ArrowSide ArrowSide,const Standard_Boolean drawFromCenter = Standard_True,const Standard_Boolean reverseArrow = Standard_False) ;

//!  Adds the circle aCircle, the text aText, the points <br>
//! AttachmentPoint, Center and EndOfArrow to the <br>
//! presentation object aPresentation. <br>
//! The display attributes of these elements is defined by <br>
//! the attribute manager aDrawer. <br>
//! The value of the enumeration Arrowside determines <br>
//! the type of arrow displayed: whether there will be <br>
//! arrowheads at both ends or only one, for example. <br>
//! If the Boolean drawFromCenter is false, the <br>
//! arrowhead will point towards the center of aCircle. <br>
//! If the Boolean reverseArrow is true, the arrowhead <br>
//! will point away from the attachment point. <br>
Standard_EXPORT static  void Add(const Handle(Prs3d_Presentation)& aPresentation,const Handle(Prs3d_Drawer)& aDrawer,const TCollection_ExtendedString& aText,const gp_Pnt& AttachmentPoint,const gp_Pnt& Center,const gp_Pnt& EndOfArrow,const DsgPrs_ArrowSide ArrowSide,const Standard_Boolean drawFromCenter = Standard_True,const Standard_Boolean reverseArrow = Standard_False) ;





protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
