// File generated by CPPExt (Value)
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _Extrema_CurveTool_HeaderFile
#define _Extrema_CurveTool_HeaderFile

#ifndef _Standard_Real_HeaderFile
#include <Standard_Real.hxx>
#endif
#ifndef _GeomAbs_Shape_HeaderFile
#include <GeomAbs_Shape.hxx>
#endif
#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
#ifndef _GeomAbs_CurveType_HeaderFile
#include <GeomAbs_CurveType.hxx>
#endif
#ifndef _gp_Pnt_HeaderFile
#include <gp_Pnt.hxx>
#endif
#ifndef _gp_Lin_HeaderFile
#include <gp_Lin.hxx>
#endif
#ifndef _gp_Circ_HeaderFile
#include <gp_Circ.hxx>
#endif
#ifndef _gp_Elips_HeaderFile
#include <gp_Elips.hxx>
#endif
#ifndef _gp_Hypr_HeaderFile
#include <gp_Hypr.hxx>
#endif
#ifndef _gp_Parab_HeaderFile
#include <gp_Parab.hxx>
#endif
#ifndef _Handle_Geom_BezierCurve_HeaderFile
#include <Handle_Geom_BezierCurve.hxx>
#endif
#ifndef _Handle_Geom_BSplineCurve_HeaderFile
#include <Handle_Geom_BSplineCurve.hxx>
#endif
class Adaptor3d_Curve;
class TColStd_Array1OfReal;
class gp_Pnt;
class gp_Vec;
class Geom_BezierCurve;
class Geom_BSplineCurve;


#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_Macro_HeaderFile
#include <Standard_Macro.hxx>
#endif


class Extrema_CurveTool  {

public:

    void* operator new(size_t,void* anAddress) 
      {
        return anAddress;
      }
    void* operator new(size_t size) 
      { 
        return Standard::Allocate(size); 
      }
    void  operator delete(void *anAddress) 
      { 
        if (anAddress) Standard::Free((Standard_Address&)anAddress); 
      }
 // Methods PUBLIC
 // 

static  Standard_Real FirstParameter(const Adaptor3d_Curve& C) ;

static  Standard_Real LastParameter(const Adaptor3d_Curve& C) ;

static  GeomAbs_Shape Continuity(const Adaptor3d_Curve& C) ;
//! Returns  the number  of  intervals for  continuity <br>
//!          <S>. May be one if Continuity(me) >= <S> <br>
static  Standard_Integer NbIntervals(Adaptor3d_Curve& C,const GeomAbs_Shape S) ;
//! Stores in <T> the  parameters bounding the intervals <br>
//!          of continuity <S>. <br>
//! <br>
//!          The array must provide  enough room to  accomodate <br>
//!          for the parameters. i.e. T.Length() > NbIntervals() <br>
static  void Intervals(Adaptor3d_Curve& C,TColStd_Array1OfReal& T,const GeomAbs_Shape S) ;


Standard_EXPORT static  Standard_Boolean IsPeriodic(const Adaptor3d_Curve& C) ;

static  Standard_Real Period(const Adaptor3d_Curve& C) ;

static  Standard_Real Resolution(const Adaptor3d_Curve& C,const Standard_Real R3d) ;

static  GeomAbs_CurveType GetType(const Adaptor3d_Curve& C) ;

static  gp_Pnt Value(const Adaptor3d_Curve& C,const Standard_Real U) ;

static  void D1(const Adaptor3d_Curve& C,const Standard_Real U,gp_Pnt& P,gp_Vec& V) ;

static  void D2(const Adaptor3d_Curve& C,const Standard_Real U,gp_Pnt& P,gp_Vec& V1,gp_Vec& V2) ;

static  gp_Lin Line(const Adaptor3d_Curve& C) ;

static  gp_Circ Circle(const Adaptor3d_Curve& C) ;

static  gp_Elips Ellipse(const Adaptor3d_Curve& C) ;

static  gp_Hypr Hyperbola(const Adaptor3d_Curve& C) ;

static  gp_Parab Parabola(const Adaptor3d_Curve& C) ;

static  Standard_Integer Degree(const Adaptor3d_Curve& C) ;

static  Standard_Boolean IsRational(const Adaptor3d_Curve& C) ;

static  Standard_Integer NbPoles(const Adaptor3d_Curve& C) ;

static  Standard_Integer NbKnots(const Adaptor3d_Curve& C) ;

static  Handle_Geom_BezierCurve Bezier(const Adaptor3d_Curve& C) ;

static  Handle_Geom_BSplineCurve BSpline(const Adaptor3d_Curve& C) ;





protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //


};


#include <Extrema_CurveTool.lxx>



// other Inline functions and methods (like "C++: function call" methods)
//


#endif
