// File generated by CPPExt (Value)
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _GProp_CelGProps_HeaderFile
#define _GProp_CelGProps_HeaderFile

#ifndef _GProp_GProps_HeaderFile
#include <GProp_GProps.hxx>
#endif
#ifndef _Standard_Real_HeaderFile
#include <Standard_Real.hxx>
#endif
class gp_Circ;
class gp_Pnt;
class gp_Lin;


#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_Macro_HeaderFile
#include <Standard_Macro.hxx>
#endif


//!  Computes the  global properties of bounded curves <br>
//!  in 3D space. <br>
//!  It can be an elementary curve from package gp such as <br>
//!  Lin, Circ, Elips, Parab . <br>
class GProp_CelGProps  : public GProp_GProps {

public:

    void* operator new(size_t,void* anAddress) 
      {
        return anAddress;
      }
    void* operator new(size_t size) 
      { 
        return Standard::Allocate(size); 
      }
    void  operator delete(void *anAddress) 
      { 
        if (anAddress) Standard::Free((Standard_Address&)anAddress); 
      }
 // Methods PUBLIC
 // 


Standard_EXPORT GProp_CelGProps();


Standard_EXPORT GProp_CelGProps(const gp_Circ& C,const gp_Pnt& CLocation);


Standard_EXPORT GProp_CelGProps(const gp_Circ& C,const Standard_Real U1,const Standard_Real U2,const gp_Pnt& CLocation);


Standard_EXPORT GProp_CelGProps(const gp_Lin& C,const Standard_Real U1,const Standard_Real U2,const gp_Pnt& CLocation);


Standard_EXPORT   void SetLocation(const gp_Pnt& CLocation) ;


Standard_EXPORT   void Perform(const gp_Circ& C,const Standard_Real U1,const Standard_Real U2) ;


Standard_EXPORT   void Perform(const gp_Lin& C,const Standard_Real U1,const Standard_Real U2) ;





protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
