// File generated by CPPExt (Value)
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _GeomFill_CornerState_HeaderFile
#define _GeomFill_CornerState_HeaderFile

#ifndef _Standard_Real_HeaderFile
#include <Standard_Real.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif


#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_Macro_HeaderFile
#include <Standard_Macro.hxx>
#endif

//! Class  (should    be  a  structure)   storing  the <br>
//!          informations         about     continuity, normals <br>
//!          parallelism,  coons conditions and bounds tangents <br>
//!          angle on the corner of contour to be filled. <br>
class GeomFill_CornerState  {

public:

    void* operator new(size_t,void* anAddress) 
      {
        return anAddress;
      }
    void* operator new(size_t size) 
      { 
        return Standard::Allocate(size); 
      }
    void  operator delete(void *anAddress) 
      { 
        if (anAddress) Standard::Free((Standard_Address&)anAddress); 
      }
 // Methods PUBLIC
 // 


Standard_EXPORT GeomFill_CornerState();


Standard_EXPORT   Standard_Real Gap() const;


Standard_EXPORT   void Gap(const Standard_Real G) ;


Standard_EXPORT   Standard_Real TgtAng() const;


Standard_EXPORT   void TgtAng(const Standard_Real Ang) ;


Standard_EXPORT   Standard_Boolean HasConstraint() const;


Standard_EXPORT   void Constraint() ;


Standard_EXPORT   Standard_Real NorAng() const;


Standard_EXPORT   void NorAng(const Standard_Real Ang) ;


Standard_EXPORT   Standard_Boolean IsToKill(Standard_Real& Scal) const;


Standard_EXPORT   void DoKill(const Standard_Real Scal) ;





protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
Standard_Real gap;
Standard_Real tgtang;
Standard_Boolean isconstrained;
Standard_Real norang;
Standard_Real scal;
Standard_Boolean coonscnd;


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
