// File generated by CPPExt (Value)
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _GeomLProp_SLProps_HeaderFile
#define _GeomLProp_SLProps_HeaderFile

#ifndef _Handle_Geom_Surface_HeaderFile
#include <Handle_Geom_Surface.hxx>
#endif
#ifndef _Standard_Real_HeaderFile
#include <Standard_Real.hxx>
#endif
#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
#ifndef _gp_Pnt_HeaderFile
#include <gp_Pnt.hxx>
#endif
#ifndef _gp_Vec_HeaderFile
#include <gp_Vec.hxx>
#endif
#ifndef _gp_Dir_HeaderFile
#include <gp_Dir.hxx>
#endif
#ifndef _LProp_Status_HeaderFile
#include <LProp_Status.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
class Geom_Surface;
class LProp_BadContinuity;
class Standard_DomainError;
class Standard_OutOfRange;
class LProp_NotDefined;
class GeomLProp_SurfaceTool;
class gp_Pnt;
class gp_Vec;
class gp_Dir;


#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_Macro_HeaderFile
#include <Standard_Macro.hxx>
#endif


class GeomLProp_SLProps  {

public:

    void* operator new(size_t,void* anAddress) 
      {
        return anAddress;
      }
    void* operator new(size_t size) 
      { 
        return Standard::Allocate(size); 
      }
    void  operator delete(void *anAddress) 
      { 
        if (anAddress) Standard::Free((Standard_Address&)anAddress); 
      }
 // Methods PUBLIC
 // 


Standard_EXPORT GeomLProp_SLProps(const Handle(Geom_Surface)& S,const Standard_Real U,const Standard_Real V,const Standard_Integer N,const Standard_Real Resolution);


Standard_EXPORT GeomLProp_SLProps(const Handle(Geom_Surface)& S,const Standard_Integer N,const Standard_Real Resolution);


Standard_EXPORT GeomLProp_SLProps(const Standard_Integer N,const Standard_Real Resolution);


Standard_EXPORT   void SetSurface(const Handle(Geom_Surface)& S) ;


Standard_EXPORT   void SetParameters(const Standard_Real U,const Standard_Real V) ;


Standard_EXPORT  const gp_Pnt& Value() const;


Standard_EXPORT  const gp_Vec& D1U() ;


Standard_EXPORT  const gp_Vec& D1V() ;


Standard_EXPORT  const gp_Vec& D2U() ;


Standard_EXPORT  const gp_Vec& D2V() ;


Standard_EXPORT  const gp_Vec& DUV() ;


Standard_EXPORT   Standard_Boolean IsTangentUDefined() ;


Standard_EXPORT   void TangentU(gp_Dir& D) ;


Standard_EXPORT   Standard_Boolean IsTangentVDefined() ;


Standard_EXPORT   void TangentV(gp_Dir& D) ;


Standard_EXPORT   Standard_Boolean IsNormalDefined() ;


Standard_EXPORT  const gp_Dir& Normal() ;


Standard_EXPORT   Standard_Boolean IsCurvatureDefined() ;


Standard_EXPORT   Standard_Boolean IsUmbilic() ;


Standard_EXPORT   Standard_Real MaxCurvature() ;


Standard_EXPORT   Standard_Real MinCurvature() ;


Standard_EXPORT   void CurvatureDirections(gp_Dir& MaxD,gp_Dir& MinD) ;


Standard_EXPORT   Standard_Real MeanCurvature() ;


Standard_EXPORT   Standard_Real GaussianCurvature() ;





protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
Handle_Geom_Surface surf;
Standard_Real u;
Standard_Real v;
Standard_Integer level;
Standard_Integer cn;
Standard_Real linTol;
gp_Pnt pnt;
gp_Vec d1U;
gp_Vec d1V;
gp_Vec d2U;
gp_Vec d2V;
gp_Vec dUV;
gp_Dir normal;
Standard_Real minCurv;
Standard_Real maxCurv;
gp_Dir dirMinCurv;
gp_Dir dirMaxCurv;
Standard_Real meanCurv;
Standard_Real gausCurv;
Standard_Integer significantFirstUDerivativeOrder;
Standard_Integer significantFirstVDerivativeOrder;
LProp_Status uTangentStatus;
LProp_Status vTangentStatus;
LProp_Status normalStatus;
LProp_Status curvatureStatus;


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
