// File generated by CPPExt (Value)
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _GeomLib_DenominatorMultiplier_HeaderFile
#define _GeomLib_DenominatorMultiplier_HeaderFile

#ifndef _Handle_Geom_BSplineSurface_HeaderFile
#include <Handle_Geom_BSplineSurface.hxx>
#endif
#ifndef _TColStd_Array1OfReal_HeaderFile
#include <TColStd_Array1OfReal.hxx>
#endif
#ifndef _Standard_Real_HeaderFile
#include <Standard_Real.hxx>
#endif
class Geom_BSplineSurface;
class Standard_OutOfRange;
class Standard_ConstructionError;
class TColStd_Array1OfReal;


#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_Macro_HeaderFile
#include <Standard_Macro.hxx>
#endif

//! this class is used to  construct the BSpline curve <br>
//!          from an Approximation ( ApproxAFunction from AdvApprox). <br>
class GeomLib_DenominatorMultiplier  {

public:

    void* operator new(size_t,void* anAddress) 
      {
        return anAddress;
      }
    void* operator new(size_t size) 
      { 
        return Standard::Allocate(size); 
      }
    void  operator delete(void *anAddress) 
      { 
        if (anAddress) Standard::Free((Standard_Address&)anAddress); 
      }
 // Methods PUBLIC
 // 

//! if the surface is rational this will define the evaluator <br>
//!          of a real function of 2 variables a(u,v) such that <br>
//!          if we define a new surface by : <br>
//!                       a(u,v) * N(u,v) <br>
//!          NewF(u,v) = ---------------- <br>
//!                       a(u,v) * D(u,v) <br>
Standard_EXPORT GeomLib_DenominatorMultiplier(const Handle(Geom_BSplineSurface)& Surface,const TColStd_Array1OfReal& KnotVector);

//! Returns the value of <br>
//!          a(UParameter,VParameter)= <br>
//! <br>
//!            H0(UParameter)/Denominator(Umin,Vparameter) <br>
//! <br>
//!            D Denominator(Umin,Vparameter) <br>
//!          - ------------------------------[H1(u)]/(Denominator(Umin,Vparameter)^2) <br>
//!            D U <br>
//! <br>
//!          + H3(UParameter)/Denominator(Umax,Vparameter) <br>
//! <br>
//!            D Denominator(Umax,Vparameter) <br>
//!          - ------------------------------[H2(u)]/(Denominator(Umax,Vparameter)^2) <br>
//!            D U <br>
Standard_EXPORT   Standard_Real Value(const Standard_Real UParameter,const Standard_Real VParameter) const;





protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
Handle_Geom_BSplineSurface mySurface;
TColStd_Array1OfReal myKnotFlatVector;


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
