// File generated by CPPExt (Value)
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _GeomToIGES_GeomPoint_HeaderFile
#define _GeomToIGES_GeomPoint_HeaderFile

#ifndef _GeomToIGES_GeomEntity_HeaderFile
#include <GeomToIGES_GeomEntity.hxx>
#endif
#ifndef _Handle_IGESGeom_Point_HeaderFile
#include <Handle_IGESGeom_Point.hxx>
#endif
#ifndef _Handle_Geom_Point_HeaderFile
#include <Handle_Geom_Point.hxx>
#endif
#ifndef _Handle_Geom_CartesianPoint_HeaderFile
#include <Handle_Geom_CartesianPoint.hxx>
#endif
class GeomToIGES_GeomEntity;
class IGESGeom_Point;
class Geom_Point;
class Geom_CartesianPoint;


#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_Macro_HeaderFile
#include <Standard_Macro.hxx>
#endif

//! This class implements the transfer of the Point Entity from Geom <br>
//!          to IGES . These are : <br>
//!          . Point <br>
//!              * CartesianPoint <br>
class GeomToIGES_GeomPoint  : public GeomToIGES_GeomEntity {

public:

    void* operator new(size_t,void* anAddress) 
      {
        return anAddress;
      }
    void* operator new(size_t size) 
      { 
        return Standard::Allocate(size); 
      }
    void  operator delete(void *anAddress) 
      { 
        if (anAddress) Standard::Free((Standard_Address&)anAddress); 
      }
 // Methods PUBLIC
 // 


Standard_EXPORT GeomToIGES_GeomPoint();

//! Creates a tool GeomPoint ready to run and sets its <br>
//!         fields as GE's. <br>
Standard_EXPORT GeomToIGES_GeomPoint(const GeomToIGES_GeomEntity& GE);

//!  Transfert  a  Point from Geom to IGES. If this <br>
//!            Entity could not be converted, this member returns a NullEntity. <br>
Standard_EXPORT   Handle_IGESGeom_Point TransferPoint(const Handle(Geom_Point)& start) ;

//!  Transfert  a  CartesianPoint from Geom to IGES. If this <br>
//!            Entity could not be converted, this member returns a NullEntity. <br>
Standard_EXPORT   Handle_IGESGeom_Point TransferPoint(const Handle(Geom_CartesianPoint)& start) ;





protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
