// File generated by CPPExt (Value)
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _GeomToIGES_GeomVector_HeaderFile
#define _GeomToIGES_GeomVector_HeaderFile

#ifndef _GeomToIGES_GeomEntity_HeaderFile
#include <GeomToIGES_GeomEntity.hxx>
#endif
#ifndef _Handle_IGESGeom_Direction_HeaderFile
#include <Handle_IGESGeom_Direction.hxx>
#endif
#ifndef _Handle_Geom_Vector_HeaderFile
#include <Handle_Geom_Vector.hxx>
#endif
#ifndef _Handle_Geom_VectorWithMagnitude_HeaderFile
#include <Handle_Geom_VectorWithMagnitude.hxx>
#endif
#ifndef _Handle_Geom_Direction_HeaderFile
#include <Handle_Geom_Direction.hxx>
#endif
class GeomToIGES_GeomEntity;
class IGESGeom_Direction;
class Geom_Vector;
class Geom_VectorWithMagnitude;
class Geom_Direction;


#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_Macro_HeaderFile
#include <Standard_Macro.hxx>
#endif

//! This class implements the transfer of the Vector from Geom <br>
//!          to IGES . These can be : <br>
//!          . Vector <br>
//!              * Direction <br>
//!              * VectorWithMagnitude <br>
class GeomToIGES_GeomVector  : public GeomToIGES_GeomEntity {

public:

    void* operator new(size_t,void* anAddress) 
      {
        return anAddress;
      }
    void* operator new(size_t size) 
      { 
        return Standard::Allocate(size); 
      }
    void  operator delete(void *anAddress) 
      { 
        if (anAddress) Standard::Free((Standard_Address&)anAddress); 
      }
 // Methods PUBLIC
 // 


Standard_EXPORT GeomToIGES_GeomVector();

//! Creates a tool GeomVector ready to run and sets its <br>
//!         fields as GE's. <br>
Standard_EXPORT GeomToIGES_GeomVector(const GeomToIGES_GeomEntity& GE);

//!  Transfert  a  GeometryEntity which  answer True  to  the <br>
//!            member : BRepToIGES::IsGeomVector(Geometry).  If this <br>
//!            Entity could not be converted, this member returns a NullEntity. <br>
Standard_EXPORT   Handle_IGESGeom_Direction TransferVector(const Handle(Geom_Vector)& start) ;


Standard_EXPORT   Handle_IGESGeom_Direction TransferVector(const Handle(Geom_VectorWithMagnitude)& start) ;


Standard_EXPORT   Handle_IGESGeom_Direction TransferVector(const Handle(Geom_Direction)& start) ;





protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
