// File generated by CPPExt (Value)
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _GeomliteTest_HeaderFile
#define _GeomliteTest_HeaderFile

class Draw_Interpretor;


#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_Macro_HeaderFile
#include <Standard_Macro.hxx>
#endif

//! this  package  provides  elementary commands for  curves  and <br>
//!          surface. <br>
class GeomliteTest  {

public:

    void* operator new(size_t,void* anAddress) 
      {
        return anAddress;
      }
    void* operator new(size_t size) 
      { 
        return Standard::Allocate(size); 
      }
    void  operator delete(void *anAddress) 
      { 
        if (anAddress) Standard::Free((Standard_Address&)anAddress); 
      }
 // Methods PUBLIC
 // 

//! defines all geometric commands. <br>
Standard_EXPORT static  void AllCommands(Draw_Interpretor& I) ;

//! defines curve commands. <br>
Standard_EXPORT static  void CurveCommands(Draw_Interpretor& I) ;

//! defines surface commands. <br>
Standard_EXPORT static  void SurfaceCommands(Draw_Interpretor& I) ;

//! defines commands to test the Geom2dAPI <br>
//!          - Intersection <br>
//!          - Extrema <br>
//!          - Projection <br>
//!          - Approximation, interpolation <br>
Standard_EXPORT static  void API2dCommands(Draw_Interpretor& I) ;

//! defines constrained curves commands. <br>
Standard_EXPORT static  void ApproxCommands(Draw_Interpretor& I) ;

//! defines curves and surfaces modification commands. <br>
//!          - Curve extension to point <br>
//!          - Surface extension by length <br>
Standard_EXPORT static  void ModificationCommands(Draw_Interpretor& I) ;





protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
