// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _Graphic3d_Texture1Dsegment_HeaderFile
#define _Graphic3d_Texture1Dsegment_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_Graphic3d_Texture1Dsegment_HeaderFile
#include <Handle_Graphic3d_Texture1Dsegment.hxx>
#endif

#ifndef _Standard_ShortReal_HeaderFile
#include <Standard_ShortReal.hxx>
#endif
#ifndef _Graphic3d_Texture1D_HeaderFile
#include <Graphic3d_Texture1D.hxx>
#endif
#ifndef _Handle_Graphic3d_StructureManager_HeaderFile
#include <Handle_Graphic3d_StructureManager.hxx>
#endif
#ifndef _Standard_CString_HeaderFile
#include <Standard_CString.hxx>
#endif
#ifndef _Graphic3d_NameOfTexture1D_HeaderFile
#include <Graphic3d_NameOfTexture1D.hxx>
#endif
class Graphic3d_StructureManager;


//!  This class provides the implementation <br>
//! of a 1D texture applyable along a segment. <br>
//! You might use the SetSegment() method <br>
//! to set the way the texture is "streched" on facets. <br>
class Graphic3d_Texture1Dsegment : public Graphic3d_Texture1D {

public:
 // Methods PUBLIC
 // 

//! Creates a texture from a file <br>
Standard_EXPORT Graphic3d_Texture1Dsegment(const Handle(Graphic3d_StructureManager)& VM,const Standard_CString FileName);

//! Creates a texture from a predefined texture name set. <br>
Standard_EXPORT Graphic3d_Texture1Dsegment(const Handle(Graphic3d_StructureManager)& VM,const Graphic3d_NameOfTexture1D NOT);

//! Sets the texture application bounds. Defines the way <br>
//! the texture is stretched across facets. <br>
//! Default values are <0.0, 0.0, 0.0> , <0.0, 0.0, 1.0> <br>
Standard_EXPORT   void SetSegment(const Standard_ShortReal X1,const Standard_ShortReal Y1,const Standard_ShortReal Z1,const Standard_ShortReal X2,const Standard_ShortReal Y2,const Standard_ShortReal Z2) ;

//! Returns the values of the current segment X1, Y1, Z1 , X2, Y2, Z2. <br>
Standard_EXPORT   void Segment(Standard_ShortReal& X1,Standard_ShortReal& Y1,Standard_ShortReal& Z1,Standard_ShortReal& X2,Standard_ShortReal& Y2,Standard_ShortReal& Z2) const;
//Standard_EXPORT ~Graphic3d_Texture1Dsegment();




 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
Standard_ShortReal MyX1;
Standard_ShortReal MyY1;
Standard_ShortReal MyZ1;
Standard_ShortReal MyX2;
Standard_ShortReal MyY2;
Standard_ShortReal MyZ2;


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
