// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _Graphic3d_Texture2D_HeaderFile
#define _Graphic3d_Texture2D_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_Graphic3d_Texture2D_HeaderFile
#include <Handle_Graphic3d_Texture2D.hxx>
#endif

#ifndef _Graphic3d_NameOfTexture2D_HeaderFile
#include <Graphic3d_NameOfTexture2D.hxx>
#endif
#ifndef _Graphic3d_TextureMap_HeaderFile
#include <Graphic3d_TextureMap.hxx>
#endif
#ifndef _Handle_Graphic3d_StructureManager_HeaderFile
#include <Handle_Graphic3d_StructureManager.hxx>
#endif
#ifndef _Standard_CString_HeaderFile
#include <Standard_CString.hxx>
#endif
#ifndef _Graphic3d_TypeOfTexture_HeaderFile
#include <Graphic3d_TypeOfTexture.hxx>
#endif
#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
class Standard_OutOfRange;
class Graphic3d_StructureManager;


//! This abstract class for managing 2D textures <br>
class Graphic3d_Texture2D : public Graphic3d_TextureMap {

public:
 // Methods PUBLIC
 // 


//! Returns the name of the predefined textures or NOT_2D_UNKNOWN <br>
//! when the name is given as a filename. <br>
Standard_EXPORT   Graphic3d_NameOfTexture2D Name() const;


//! Returns the number of predefined textures. <br>
Standard_EXPORT static  Standard_Integer NumberOfTextures() ;


//! Returns the name of the predefined texture of rank <aRank> <br>
Standard_EXPORT static  Standard_CString TextureName(const Standard_Integer aRank) ;
//Standard_EXPORT ~Graphic3d_Texture2D();




 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 


Standard_EXPORT Graphic3d_Texture2D(const Handle(Graphic3d_StructureManager)& SM,const Standard_CString aFileName,const Graphic3d_TypeOfTexture aType);


Standard_EXPORT Graphic3d_Texture2D(const Handle(Graphic3d_StructureManager)& SM,const Graphic3d_NameOfTexture2D aName,const Graphic3d_TypeOfTexture aType);


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
Graphic3d_NameOfTexture2D myName;


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
