// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _IFSelect_GraphCounter_HeaderFile
#define _IFSelect_GraphCounter_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_IFSelect_GraphCounter_HeaderFile
#include <Handle_IFSelect_GraphCounter.hxx>
#endif

#ifndef _Handle_IFSelect_SelectDeduct_HeaderFile
#include <Handle_IFSelect_SelectDeduct.hxx>
#endif
#ifndef _IFSelect_SignCounter_HeaderFile
#include <IFSelect_SignCounter.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
#ifndef _Handle_TColStd_HSequenceOfTransient_HeaderFile
#include <Handle_TColStd_HSequenceOfTransient.hxx>
#endif
class IFSelect_SelectDeduct;
class TColStd_HSequenceOfTransient;
class Interface_Graph;


//! A GraphCounter computes values to be sorted with the help of <br>
//!           a Graph. I.E. not from a Signature <br>
//! <br>
//!           The default GraphCounter works with an Applied Selection (a <br>
//!           SelectDeduct), the value is the count of selected entities <br>
//!           from each input entities) <br>
class IFSelect_GraphCounter : public IFSelect_SignCounter {

public:
 // Methods PUBLIC
 // 

//! Creates a GraphCounter, without applied selection <br>
Standard_EXPORT IFSelect_GraphCounter(const Standard_Boolean withmap = Standard_True,const Standard_Boolean withlist = Standard_False);

//! Returns the applied selection <br>
Standard_EXPORT   Handle_IFSelect_SelectDeduct Applied() const;

//! Sets a new applied selection <br>
Standard_EXPORT   void SetApplied(const Handle(IFSelect_SelectDeduct)& sel) ;

//! Adds a list of entities in the context given by the graph <br>
//!           Default takes the count of entities selected by the applied <br>
//!           selection, when it is given each entity of the list <br>
//!           Can be redefined <br>
Standard_EXPORT virtual  void AddWithGraph(const Handle(TColStd_HSequenceOfTransient)& list,const Interface_Graph& graph) ;
//Standard_EXPORT ~IFSelect_GraphCounter();




 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
Handle_IFSelect_SelectDeduct theapplied;


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
