// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _IFSelect_SelectModelRoots_HeaderFile
#define _IFSelect_SelectModelRoots_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_IFSelect_SelectModelRoots_HeaderFile
#include <Handle_IFSelect_SelectModelRoots.hxx>
#endif

#ifndef _IFSelect_SelectBase_HeaderFile
#include <IFSelect_SelectBase.hxx>
#endif
class Interface_EntityIterator;
class Interface_Graph;
class TCollection_AsciiString;


//! A SelectModelRoots gets all the Root Entities of an <br>
//!           InterfaceModel. Remember that a "Root Entity" is defined as <br>
//!           having no Sharing Entity (if there is a Loop between Entities, <br>
//!           none of them can be a "Root"). <br>
class IFSelect_SelectModelRoots : public IFSelect_SelectBase {

public:
 // Methods PUBLIC
 // 

//! Creates a SelectModelRoot <br>
Standard_EXPORT IFSelect_SelectModelRoots();

//! Returns the list of selected entities : the Roots of the Model <br>
//!           (note that this result assures naturally uniqueness) <br>
Standard_EXPORT   Interface_EntityIterator RootResult(const Interface_Graph& G) const;

//! Returns a text defining the criterium : "Model Roots" <br>
Standard_EXPORT   TCollection_AsciiString Label() const;
//Standard_EXPORT ~IFSelect_SelectModelRoots();




 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
