// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _IGESAppli_LevelFunction_HeaderFile
#define _IGESAppli_LevelFunction_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_IGESAppli_LevelFunction_HeaderFile
#include <Handle_IGESAppli_LevelFunction.hxx>
#endif

#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
#ifndef _Handle_TCollection_HAsciiString_HeaderFile
#include <Handle_TCollection_HAsciiString.hxx>
#endif
#ifndef _IGESData_IGESEntity_HeaderFile
#include <IGESData_IGESEntity.hxx>
#endif
class TCollection_HAsciiString;


//! defines LevelFunction, Type <406> Form <3> <br>
//!          in package IGESAppli <br>
//!          Used to transfer the meaning or intended use of a level <br>
//!          in the sending system <br>
class IGESAppli_LevelFunction : public IGESData_IGESEntity {

public:
 // Methods PUBLIC
 // 


Standard_EXPORT IGESAppli_LevelFunction();

//! This method is used to set the fields of the class <br>
//!           LevelFunction <br>
//!       - nbPropVal    : Number of Properties, always = 2 <br>
//!       - aCode        : Function Description code <br>
//!                        default = 0 <br>
//!       - aFuncDescrip : Function Description <br>
//!                        default = null string <br>
Standard_EXPORT   void Init(const Standard_Integer nbPropVal,const Standard_Integer aCode,const Handle(TCollection_HAsciiString)& aFuncDescrip) ;

//! is always 2 <br>
Standard_EXPORT   Standard_Integer NbPropertyValues() const;

//! returns the function description code . Default = 0 <br>
Standard_EXPORT   Standard_Integer FuncDescriptionCode() const;

//! returns the function description <br>
//! Default = null string <br>
Standard_EXPORT   Handle_TCollection_HAsciiString FuncDescription() const;
//Standard_EXPORT ~IGESAppli_LevelFunction();




 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
Standard_Integer theNbPropertyValues;
Standard_Integer theFuncDescripCode;
Handle_TCollection_HAsciiString theFuncDescrip;


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
