// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _IGESAppli_PartNumber_HeaderFile
#define _IGESAppli_PartNumber_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_IGESAppli_PartNumber_HeaderFile
#include <Handle_IGESAppli_PartNumber.hxx>
#endif

#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
#ifndef _Handle_TCollection_HAsciiString_HeaderFile
#include <Handle_TCollection_HAsciiString.hxx>
#endif
#ifndef _IGESData_IGESEntity_HeaderFile
#include <IGESData_IGESEntity.hxx>
#endif
class TCollection_HAsciiString;


//! defines PartNumber, Type <406> Form <9> <br>
//!          in package IGESAppli <br>
//!          Attaches a set of text strings that define the common <br>
//!          part numbers to an entity being used to represent a <br>
//!          physical component <br>
class IGESAppli_PartNumber : public IGESData_IGESEntity {

public:
 // Methods PUBLIC
 // 


Standard_EXPORT IGESAppli_PartNumber();

//! This method is used to set the fields of the class <br>
//!           PartNumber <br>
//!       - nbPropVal : number of property values, always = 4 <br>
//!       - aGenName  : Generic part number or name <br>
//!       - aMilName  : Military Standard (MIL-STD) part number <br>
//!       - aVendName : Vendor part number or name <br>
//!       - anIntName : Internal part number <br>
Standard_EXPORT   void Init(const Standard_Integer nbPropVal,const Handle(TCollection_HAsciiString)& aGenName,const Handle(TCollection_HAsciiString)& aMilName,const Handle(TCollection_HAsciiString)& aVendName,const Handle(TCollection_HAsciiString)& anIntName) ;

//! returns number of property values, always = 4 <br>
Standard_EXPORT   Standard_Integer NbPropertyValues() const;

//! returns Generic part number or name <br>
Standard_EXPORT   Handle_TCollection_HAsciiString GenericNumber() const;

//! returns Military Standard (MIL-STD) part number <br>
Standard_EXPORT   Handle_TCollection_HAsciiString MilitaryNumber() const;

//! returns Vendor part number or name <br>
Standard_EXPORT   Handle_TCollection_HAsciiString VendorNumber() const;

//! returns Internal part number <br>
Standard_EXPORT   Handle_TCollection_HAsciiString InternalNumber() const;
//Standard_EXPORT ~IGESAppli_PartNumber();




 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
Standard_Integer theNbPropertyValues;
Handle_TCollection_HAsciiString theGenericNumber;
Handle_TCollection_HAsciiString theMilitaryNumber;
Handle_TCollection_HAsciiString theVendorNumber;
Handle_TCollection_HAsciiString theInternalNumber;


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
