// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _IGESBasic_SubfigureDef_HeaderFile
#define _IGESBasic_SubfigureDef_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_IGESBasic_SubfigureDef_HeaderFile
#include <Handle_IGESBasic_SubfigureDef.hxx>
#endif

#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
#ifndef _Handle_TCollection_HAsciiString_HeaderFile
#include <Handle_TCollection_HAsciiString.hxx>
#endif
#ifndef _Handle_IGESData_HArray1OfIGESEntity_HeaderFile
#include <Handle_IGESData_HArray1OfIGESEntity.hxx>
#endif
#ifndef _IGESData_IGESEntity_HeaderFile
#include <IGESData_IGESEntity.hxx>
#endif
#ifndef _Handle_IGESData_IGESEntity_HeaderFile
#include <Handle_IGESData_IGESEntity.hxx>
#endif
#ifndef _Handle_Standard_Transient_HeaderFile
#include <Handle_Standard_Transient.hxx>
#endif
class TCollection_HAsciiString;
class IGESData_HArray1OfIGESEntity;
class Standard_OutOfRange;
class IGESData_IGESEntity;
class Standard_Transient;


//! defines SubfigureDef, Type <308> Form <0> <br>
//!          in package IGESBasic <br>
//!          This Entity permits a single definition of a detail to <br>
//!          be utilized in multiple instances in the creation of <br>
//!          the whole picture <br>
class IGESBasic_SubfigureDef : public IGESData_IGESEntity {

public:
 // Methods PUBLIC
 // 


Standard_EXPORT IGESBasic_SubfigureDef();

//! This method is used to set the fields of the class <br>
//!          SubfigureDef <br>
//!       - aDepth           : It indicates the amount of nesting <br>
//!       - aName            : the subfigure name <br>
//!       - allAssocEntities : the associated entities <br>
Standard_EXPORT   void Init(const Standard_Integer aDepth,const Handle(TCollection_HAsciiString)& aName,const Handle(IGESData_HArray1OfIGESEntity)& allAssocEntities) ;

//! returns depth of the Subfigure <br>
//! if theDepth = 0 - No reference to any subfigure instance. <br>
Standard_EXPORT   Standard_Integer Depth() const;

//! returns the name of Subfigure <br>
Standard_EXPORT   Handle_TCollection_HAsciiString Name() const;

//! returns number of entities. Is greater than or equal to zero. <br>
Standard_EXPORT   Standard_Integer NbEntities() const;

//! returns the specific entity as indicated by Index <br>
//! raises exception if Index <= 0 or Index > NbEntities() <br>
Standard_EXPORT   Handle_IGESData_IGESEntity AssociatedEntity(const Standard_Integer Index) const;

//! returns the specific entity as indicated by Index <br>
//! raises exception if Index <= 0 or Index > NbEntities() <br>
Standard_EXPORT   Handle_Standard_Transient Value(const Standard_Integer Index) const;
//Standard_EXPORT ~IGESBasic_SubfigureDef();




 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
Standard_Integer theDepth;
Handle_TCollection_HAsciiString theName;
Handle_IGESData_HArray1OfIGESEntity theAssocEntities;


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
