// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _IGESGeom_CompositeCurve_HeaderFile
#define _IGESGeom_CompositeCurve_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_IGESGeom_CompositeCurve_HeaderFile
#include <Handle_IGESGeom_CompositeCurve.hxx>
#endif

#ifndef _Handle_IGESData_HArray1OfIGESEntity_HeaderFile
#include <Handle_IGESData_HArray1OfIGESEntity.hxx>
#endif
#ifndef _IGESData_IGESEntity_HeaderFile
#include <IGESData_IGESEntity.hxx>
#endif
#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
#ifndef _Handle_IGESData_IGESEntity_HeaderFile
#include <Handle_IGESData_IGESEntity.hxx>
#endif
class IGESData_HArray1OfIGESEntity;
class Standard_OutOfRange;
class IGESData_IGESEntity;


//! defines IGESCompositeCurve, Type <102> Form <0> <br>
//!          in package IGESGeom <br>
//!          A composite curve is defined as an ordered list of entities <br>
//!          consisting of a point, connect point and parametrised curve <br>
//!          entities (excluding the CompositeCurve entity). <br>
class IGESGeom_CompositeCurve : public IGESData_IGESEntity {

public:
 // Methods PUBLIC
 // 


Standard_EXPORT IGESGeom_CompositeCurve();

//! This method is used to set the fields of the class <br>
//!           CompositeCurve <br>
//!       - allEntities : Constituent Entities of the composite curve <br>
Standard_EXPORT   void Init(const Handle(IGESData_HArray1OfIGESEntity)& allEntities) ;

//! returns the number of curves contained in the CompositeCurve <br>
Standard_EXPORT   Standard_Integer NbCurves() const;

//! returns Component of the CompositeCurve (a curve or a point) <br>
//! raises exception if Index <= 0 or Index > NbCurves() <br>
Standard_EXPORT   Handle_IGESData_IGESEntity Curve(const Standard_Integer Index) const;
//Standard_EXPORT ~IGESGeom_CompositeCurve();




 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
Handle_IGESData_HArray1OfIGESEntity theEntities;


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
