// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _IGESGeom_TransformationMatrix_HeaderFile
#define _IGESGeom_TransformationMatrix_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_IGESGeom_TransformationMatrix_HeaderFile
#include <Handle_IGESGeom_TransformationMatrix.hxx>
#endif

#ifndef _Handle_TColStd_HArray2OfReal_HeaderFile
#include <Handle_TColStd_HArray2OfReal.hxx>
#endif
#ifndef _IGESData_TransfEntity_HeaderFile
#include <IGESData_TransfEntity.hxx>
#endif
#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
#ifndef _Standard_Real_HeaderFile
#include <Standard_Real.hxx>
#endif
class TColStd_HArray2OfReal;
class Standard_DimensionMismatch;
class Standard_OutOfRange;
class gp_GTrsf;


//! defines IGESTransformationMatrix, Type <124> Form <0> <br>
//!          in package IGESGeom <br>
//!          The transformation matrix entity transforms three-row column <br>
//!          vectors by means of matrix multiplication and then a vector <br>
//!          addition. This entity can be considered as an "operator" <br>
//!          entity in that it starts with the input vector, operates on <br>
//!          it as described above, and produces the output vector. <br>
class IGESGeom_TransformationMatrix : public IGESData_TransfEntity {

public:
 // Methods PUBLIC
 // 


Standard_EXPORT IGESGeom_TransformationMatrix();

//! This method is used to set the fields of the class <br>
//!           TransformationMatrix <br>
//!       - aMatrix : 3 x 4 array containing elements of the <br>
//!                   transformation matrix <br>
//! raises exception if aMatrix is not 3 x 4 array <br>
Standard_EXPORT   void Init(const Handle(TColStd_HArray2OfReal)& aMatrix) ;

//! Changes FormNumber (indicates the Type of Transf : <br>
//!           Transformation 0-1 or Coordinate System 10-11-12) <br>
//!           Error if not in ranges [0-1] or [10-12] <br>
Standard_EXPORT   void SetFormNumber(const Standard_Integer form) ;

//! returns individual Data <br>
//! Errro if I not in [1-3] or J not in [1-4] <br>
Standard_EXPORT   Standard_Real Data(const Standard_Integer I,const Standard_Integer J) const;

//! returns the transformation matrix <br>
//! 4th row elements of GTrsf will always be 0, 0, 0, 1 (not defined) <br>
Standard_EXPORT   gp_GTrsf Value() const;
//Standard_EXPORT ~IGESGeom_TransformationMatrix();




 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
Handle_TColStd_HArray2OfReal theData;


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
