// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _IGESGraph_ReadWriteModule_HeaderFile
#define _IGESGraph_ReadWriteModule_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_IGESGraph_ReadWriteModule_HeaderFile
#include <Handle_IGESGraph_ReadWriteModule.hxx>
#endif

#ifndef _IGESData_ReadWriteModule_HeaderFile
#include <IGESData_ReadWriteModule.hxx>
#endif
#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
#ifndef _Handle_IGESData_IGESEntity_HeaderFile
#include <Handle_IGESData_IGESEntity.hxx>
#endif
#ifndef _Handle_IGESData_IGESReaderData_HeaderFile
#include <Handle_IGESData_IGESReaderData.hxx>
#endif
class Standard_DomainError;
class IGESData_IGESEntity;
class IGESData_IGESReaderData;
class IGESData_ParamReader;
class IGESData_IGESWriter;


//! Defines Graph File Access Module for IGESGraph (specific parts) <br>
//!           Specific actions concern : Read and Write Own Parameters of <br>
//!           an IGESEntity. <br>
class IGESGraph_ReadWriteModule : public IGESData_ReadWriteModule {

public:
 // Methods PUBLIC
 // 

//! Creates a ReadWriteModule & puts it into ReaderLib & WriterLib <br>
Standard_EXPORT IGESGraph_ReadWriteModule();

//! Defines Case Numbers for Entities of IGESGraph <br>
Standard_EXPORT   Standard_Integer CaseIGES(const Standard_Integer typenum,const Standard_Integer formnum) const;

//! Reads own parameters from file for an Entity of IGESGraph <br>
Standard_EXPORT   void ReadOwnParams(const Standard_Integer CN,const Handle(IGESData_IGESEntity)& ent,const Handle(IGESData_IGESReaderData)& IR,IGESData_ParamReader& PR) const;

//! Writes own parameters to IGESWriter <br>
Standard_EXPORT   void WriteOwnParams(const Standard_Integer CN,const Handle(IGESData_IGESEntity)& ent,IGESData_IGESWriter& IW) const;
//Standard_EXPORT ~IGESGraph_ReadWriteModule();




 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
