// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _IGESSelect_SetVersion5_HeaderFile
#define _IGESSelect_SetVersion5_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_IGESSelect_SetVersion5_HeaderFile
#include <Handle_IGESSelect_SetVersion5.hxx>
#endif

#ifndef _IGESSelect_ModelModifier_HeaderFile
#include <IGESSelect_ModelModifier.hxx>
#endif
#ifndef _Handle_IGESData_IGESModel_HeaderFile
#include <Handle_IGESData_IGESModel.hxx>
#endif
class IFSelect_ContextModif;
class IGESData_IGESModel;
class Interface_CopyTool;
class TCollection_AsciiString;


//! Sets IGES Version (coded in global parameter 23) to be at least <br>
//!           IGES 5.1 . If it is older, it is set to IGES 5.1, and <br>
//!           LastChangeDate (new Global n0 25) is added (current time) <br>
//!           Else, it does nothing (i.e. changes neither IGES Version nor <br>
//!           LastChangeDate) <br>
class IGESSelect_SetVersion5 : public IGESSelect_ModelModifier {

public:
 // Methods PUBLIC
 // 

//! Creates an SetVersion5, which uses the system Date for Last <br>
//!           Change Date <br>
Standard_EXPORT IGESSelect_SetVersion5();

//! Specific action : only <target> is used : IGES Version (coded) <br>
//!           is upgraded to 5.1 if it is older, and it this case the new <br>
//!           global parameter 25 (LastChangeDate) is set to current time <br>
Standard_EXPORT   void Performing(IFSelect_ContextModif& ctx,const Handle(IGESData_IGESModel)& target,Interface_CopyTool& TC) const;

//! Returns a text which is <br>
//!           "Update IGES Version to 5.1" <br>
Standard_EXPORT   TCollection_AsciiString Label() const;
//Standard_EXPORT ~IGESSelect_SetVersion5();




 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
