// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _IGESToBRep_Actor_HeaderFile
#define _IGESToBRep_Actor_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_IGESToBRep_Actor_HeaderFile
#include <Handle_IGESToBRep_Actor.hxx>
#endif

#ifndef _Handle_Interface_InterfaceModel_HeaderFile
#include <Handle_Interface_InterfaceModel.hxx>
#endif
#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
#ifndef _Standard_Real_HeaderFile
#include <Standard_Real.hxx>
#endif
#ifndef _Transfer_ActorOfTransientProcess_HeaderFile
#include <Transfer_ActorOfTransientProcess.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
#ifndef _Handle_Standard_Transient_HeaderFile
#include <Handle_Standard_Transient.hxx>
#endif
#ifndef _Handle_Transfer_Binder_HeaderFile
#include <Handle_Transfer_Binder.hxx>
#endif
#ifndef _Handle_Transfer_TransientProcess_HeaderFile
#include <Handle_Transfer_TransientProcess.hxx>
#endif
class Interface_InterfaceModel;
class Standard_Transient;
class Transfer_Binder;
class Transfer_TransientProcess;


//! This class performs the transfer of an Entity from <br>
//!           IGESToBRep <br>
//! <br>
//!           I.E. for each type of Entity, it invokes the appropriate Tool <br>
//!           then returns the Binder which contains the Result <br>
class IGESToBRep_Actor : public Transfer_ActorOfTransientProcess {

public:
 // Methods PUBLIC
 // 


Standard_EXPORT IGESToBRep_Actor();


Standard_EXPORT   void SetModel(const Handle(Interface_InterfaceModel)& model) ;

//!---Purpose   By default continuity = 0 <br>
//!           if continuity = 1 : try C1 <br>
//!           if continuity = 2 : try C2 <br>
Standard_EXPORT   void SetContinuity(const Standard_Integer continuity = 0) ;

//! Return "thecontinuity" <br>
Standard_EXPORT   Standard_Integer GetContinuity() const;


Standard_EXPORT virtual  Standard_Boolean Recognize(const Handle(Standard_Transient)& start) ;


Standard_EXPORT virtual  Handle_Transfer_Binder Transfer(const Handle(Standard_Transient)& start,const Handle(Transfer_TransientProcess)& TP) ;

//! Returns the tolerance which was actually used, either from <br>
//!           the file or from statics <br>
Standard_EXPORT   Standard_Real UsedTolerance() const;
//Standard_EXPORT ~IGESToBRep_Actor();




 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
Handle_Interface_InterfaceModel themodel;
Standard_Integer thecontinuity;
Standard_Real theeps;


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
