// File generated by CPPExt (Value)
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _IGESToBRep_TopoSurface_HeaderFile
#define _IGESToBRep_TopoSurface_HeaderFile

#ifndef _Standard_Real_HeaderFile
#include <Standard_Real.hxx>
#endif
#ifndef _IGESToBRep_CurveAndSurface_HeaderFile
#include <IGESToBRep_CurveAndSurface.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
#ifndef _Handle_IGESData_IGESEntity_HeaderFile
#include <Handle_IGESData_IGESEntity.hxx>
#endif
#ifndef _Handle_IGESGeom_RuledSurface_HeaderFile
#include <Handle_IGESGeom_RuledSurface.hxx>
#endif
#ifndef _Handle_IGESGeom_SurfaceOfRevolution_HeaderFile
#include <Handle_IGESGeom_SurfaceOfRevolution.hxx>
#endif
#ifndef _Handle_IGESGeom_TabulatedCylinder_HeaderFile
#include <Handle_IGESGeom_TabulatedCylinder.hxx>
#endif
#ifndef _Handle_IGESGeom_OffsetSurface_HeaderFile
#include <Handle_IGESGeom_OffsetSurface.hxx>
#endif
#ifndef _Handle_IGESGeom_TrimmedSurface_HeaderFile
#include <Handle_IGESGeom_TrimmedSurface.hxx>
#endif
#ifndef _Handle_IGESGeom_BoundedSurface_HeaderFile
#include <Handle_IGESGeom_BoundedSurface.hxx>
#endif
#ifndef _Handle_IGESGeom_Plane_HeaderFile
#include <Handle_IGESGeom_Plane.hxx>
#endif
#ifndef _Handle_IGESSolid_PlaneSurface_HeaderFile
#include <Handle_IGESSolid_PlaneSurface.hxx>
#endif
#ifndef _Handle_IGESBasic_SingleParent_HeaderFile
#include <Handle_IGESBasic_SingleParent.hxx>
#endif
class IGESToBRep_CurveAndSurface;
class TopoDS_Shape;
class IGESData_IGESEntity;
class IGESGeom_RuledSurface;
class IGESGeom_SurfaceOfRevolution;
class IGESGeom_TabulatedCylinder;
class IGESGeom_OffsetSurface;
class IGESGeom_TrimmedSurface;
class IGESGeom_BoundedSurface;
class IGESGeom_Plane;
class IGESSolid_PlaneSurface;
class IGESBasic_SingleParent;
class gp_Pln;
class gp_Trsf;
class gp_Trsf2d;


#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_Macro_HeaderFile
#include <Standard_Macro.hxx>
#endif

//! Provides methods to transfer topologic surfaces entities <br>
//!           from IGES to CASCADE. <br>
class IGESToBRep_TopoSurface  : public IGESToBRep_CurveAndSurface {

public:

    void* operator new(size_t,void* anAddress) 
      {
        return anAddress;
      }
    void* operator new(size_t size) 
      { 
        return Standard::Allocate(size); 
      }
    void  operator delete(void *anAddress) 
      { 
        if (anAddress) Standard::Free((Standard_Address&)anAddress); 
      }
 // Methods PUBLIC
 // 

//! Creates  a tool TopoSurface  ready  to  run, with <br>
//!         epsilons  set  to  1.E-04,  TheModeTopo  to  True,  the <br>
//!         optimization of  the continuity to False. <br>
Standard_EXPORT IGESToBRep_TopoSurface();

//! Creates a tool TopoSurface ready to run and sets its <br>
//!         fields as CS's. <br>
Standard_EXPORT IGESToBRep_TopoSurface(const IGESToBRep_CurveAndSurface& CS);

//! Creates a tool TopoSurface ready to run. <br>
Standard_EXPORT IGESToBRep_TopoSurface(const Standard_Real eps,const Standard_Real epsGeom,const Standard_Real epsCoeff,const Standard_Boolean mode,const Standard_Boolean modeapprox,const Standard_Boolean optimized);


Standard_EXPORT   TopoDS_Shape TransferTopoSurface(const Handle(IGESData_IGESEntity)& start) ;


Standard_EXPORT   TopoDS_Shape TransferTopoBasicSurface(const Handle(IGESData_IGESEntity)& start) ;


Standard_EXPORT   TopoDS_Shape TransferRuledSurface(const Handle(IGESGeom_RuledSurface)& start) ;


Standard_EXPORT   TopoDS_Shape TransferSurfaceOfRevolution(const Handle(IGESGeom_SurfaceOfRevolution)& start) ;


Standard_EXPORT   TopoDS_Shape TransferTabulatedCylinder(const Handle(IGESGeom_TabulatedCylinder)& start) ;


Standard_EXPORT   TopoDS_Shape TransferOffsetSurface(const Handle(IGESGeom_OffsetSurface)& start) ;


Standard_EXPORT   TopoDS_Shape TransferTrimmedSurface(const Handle(IGESGeom_TrimmedSurface)& start) ;


Standard_EXPORT   TopoDS_Shape TransferBoundedSurface(const Handle(IGESGeom_BoundedSurface)& start) ;


Standard_EXPORT   TopoDS_Shape TransferPlane(const Handle(IGESGeom_Plane)& start) ;


Standard_EXPORT   TopoDS_Shape TransferPlaneSurface(const Handle(IGESSolid_PlaneSurface)& start) ;


Standard_EXPORT   TopoDS_Shape TransferPerforate(const Handle(IGESBasic_SingleParent)& start) ;


Standard_EXPORT   TopoDS_Shape ParamSurface(const Handle(IGESData_IGESEntity)& start,gp_Trsf2d& trans,Standard_Real& uFact) ;





protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


Standard_EXPORT   TopoDS_Shape TransferPlaneParts(const Handle(IGESGeom_Plane)& start,gp_Pln& gplan,gp_Trsf& locat,const Standard_Boolean first) ;


 // Fields PRIVATE
 //
Standard_Real TheULength;


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
