// File generated by CPPExt (Value)
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _IntCurveSurface_IntersectionSegment_HeaderFile
#define _IntCurveSurface_IntersectionSegment_HeaderFile

#ifndef _IntCurveSurface_IntersectionPoint_HeaderFile
#include <IntCurveSurface_IntersectionPoint.hxx>
#endif
class IntCurveSurface_IntersectionPoint;


#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_Macro_HeaderFile
#include <Standard_Macro.hxx>
#endif

//! A IntersectionSegment describes a segment of curve <br>
//!          (w1,w2) where distance(C(w),Surface) is less than a <br>
//!          given tolerances. <br>
class IntCurveSurface_IntersectionSegment  {

public:

    void* operator new(size_t,void* anAddress) 
      {
        return anAddress;
      }
    void* operator new(size_t size) 
      { 
        return Standard::Allocate(size); 
      }
    void  operator delete(void *anAddress) 
      { 
        if (anAddress) Standard::Free((Standard_Address&)anAddress); 
      }
 // Methods PUBLIC
 // 


Standard_EXPORT IntCurveSurface_IntersectionSegment();


Standard_EXPORT IntCurveSurface_IntersectionSegment(const IntCurveSurface_IntersectionPoint& P1,const IntCurveSurface_IntersectionPoint& P2);


Standard_EXPORT   void SetValues(const IntCurveSurface_IntersectionPoint& P1,const IntCurveSurface_IntersectionPoint& P2) ;


Standard_EXPORT   void Values(IntCurveSurface_IntersectionPoint& P1,IntCurveSurface_IntersectionPoint& P2) const;


Standard_EXPORT   void FirstPoint(IntCurveSurface_IntersectionPoint& P1) const;


Standard_EXPORT   void SecondPoint(IntCurveSurface_IntersectionPoint& P2) const;


Standard_EXPORT  const IntCurveSurface_IntersectionPoint& FirstPoint() const;


Standard_EXPORT  const IntCurveSurface_IntersectionPoint& SecondPoint() const;


Standard_EXPORT   void Dump() const;





protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
IntCurveSurface_IntersectionPoint myP1;
IntCurveSurface_IntersectionPoint myP2;


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
