// File generated by CPPExt (Value)
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _IntImpParGen_HeaderFile
#define _IntImpParGen_HeaderFile

#ifndef _IntRes2d_Position_HeaderFile
#include <IntRes2d_Position.hxx>
#endif
#ifndef _Standard_Real_HeaderFile
#include <Standard_Real.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
class gp_Vec2d;
class IntRes2d_Transition;
class IntRes2d_Domain;
class gp_Pnt2d;
class IntImpParGen_ImpTool;
class IntImpParGen_ParTool;
class IntImpParGen_ImpParTool;
class IntImpParGen_Intersector;
class IntImpParGen_MyImpParTool;


#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_Macro_HeaderFile
#include <Standard_Macro.hxx>
#endif

//! Gives a generic algorithm to intersect Implicit Curves <br>
//!          and Bounded Parametric Curves. <br>
//! <br>
//!  Level: Internal <br>
class IntImpParGen  {

public:

    void* operator new(size_t,void* anAddress) 
      {
        return anAddress;
      }
    void* operator new(size_t size) 
      { 
        return Standard::Allocate(size); 
      }
    void  operator delete(void *anAddress) 
      { 
        if (anAddress) Standard::Free((Standard_Address&)anAddress); 
      }
 // Methods PUBLIC
 // 


Standard_EXPORT static  void DetermineTransition(const IntRes2d_Position Pos1,gp_Vec2d& Tan1,const gp_Vec2d& Norm1,IntRes2d_Transition& Trans1,const IntRes2d_Position Pos2,gp_Vec2d& Tan2,const gp_Vec2d& Norm2,IntRes2d_Transition& Trans2,const Standard_Real Tol) ;


Standard_EXPORT static  Standard_Boolean DetermineTransition(const IntRes2d_Position Pos1,gp_Vec2d& Tan1,IntRes2d_Transition& Trans1,const IntRes2d_Position Pos2,gp_Vec2d& Tan2,IntRes2d_Transition& Trans2,const Standard_Real Tol) ;


Standard_EXPORT static  void DeterminePosition(IntRes2d_Position& Pos1,const IntRes2d_Domain& Dom1,const gp_Pnt2d& P1,const Standard_Real Tol) ;


Standard_EXPORT static  Standard_Real NormalizeOnDomain(Standard_Real& Par1,const IntRes2d_Domain& Dom1) ;





protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //

friend class IntImpParGen_ImpTool;
friend class IntImpParGen_ParTool;
friend class IntImpParGen_ImpParTool;
friend class IntImpParGen_Intersector;
friend class IntImpParGen_MyImpParTool;

};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
