// File generated by CPPExt (Value)
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _LocOpe_Pipe_HeaderFile
#define _LocOpe_Pipe_HeaderFile

#ifndef _BRepFill_Pipe_HeaderFile
#include <BRepFill_Pipe.hxx>
#endif
#ifndef _TopTools_DataMapOfShapeListOfShape_HeaderFile
#include <TopTools_DataMapOfShapeListOfShape.hxx>
#endif
#ifndef _TopoDS_Shape_HeaderFile
#include <TopoDS_Shape.hxx>
#endif
#ifndef _TopTools_ListOfShape_HeaderFile
#include <TopTools_ListOfShape.hxx>
#endif
#ifndef _TColGeom_SequenceOfCurve_HeaderFile
#include <TColGeom_SequenceOfCurve.hxx>
#endif
#ifndef _Handle_Geom_Curve_HeaderFile
#include <Handle_Geom_Curve.hxx>
#endif
class Standard_NoSuchObject;
class Standard_DomainError;
class TopoDS_Wire;
class TopoDS_Shape;
class TopTools_ListOfShape;
class TColGeom_SequenceOfCurve;
class TColgp_SequenceOfPnt;
class Geom_Curve;


#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_Macro_HeaderFile
#include <Standard_Macro.hxx>
#endif

//! Defines a  pipe  (near from   Pipe from BRepFill), <br>
//!          with modifications provided for the Pipe feature. <br>
class LocOpe_Pipe  {

public:

    void* operator new(size_t,void* anAddress) 
      {
        return anAddress;
      }
    void* operator new(size_t size) 
      { 
        return Standard::Allocate(size); 
      }
    void  operator delete(void *anAddress) 
      { 
        if (anAddress) Standard::Free((Standard_Address&)anAddress); 
      }
 // Methods PUBLIC
 // 


Standard_EXPORT LocOpe_Pipe(const TopoDS_Wire& Spine,const TopoDS_Shape& Profile);

 const TopoDS_Shape& Spine() const;

 const TopoDS_Shape& Profile() const;

 const TopoDS_Shape& FirstShape() const;

 const TopoDS_Shape& LastShape() const;


Standard_EXPORT  const TopoDS_Shape& Shape() const;


Standard_EXPORT  const TopTools_ListOfShape& Shapes(const TopoDS_Shape& S) ;


Standard_EXPORT  const TColGeom_SequenceOfCurve& Curves(const TColgp_SequenceOfPnt& Spt) ;


Standard_EXPORT   Handle_Geom_Curve BarycCurve() ;





protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
BRepFill_Pipe myPipe;
TopTools_DataMapOfShapeListOfShape myMap;
TopoDS_Shape myRes;
TopTools_ListOfShape myGShap;
TColGeom_SequenceOfCurve myCrvs;
TopoDS_Shape myFirstShape;
TopoDS_Shape myLastShape;


};


#include <LocOpe_Pipe.lxx>



// other Inline functions and methods (like "C++: function call" methods)
//


#endif
