// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _MDF_ARDriver_HeaderFile
#define _MDF_ARDriver_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_MDF_ARDriver_HeaderFile
#include <Handle_MDF_ARDriver.hxx>
#endif

#ifndef _Handle_CDM_MessageDriver_HeaderFile
#include <Handle_CDM_MessageDriver.hxx>
#endif
#ifndef _MMgt_TShared_HeaderFile
#include <MMgt_TShared.hxx>
#endif
#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
#ifndef _Handle_Standard_Type_HeaderFile
#include <Handle_Standard_Type.hxx>
#endif
#ifndef _Handle_TDF_Attribute_HeaderFile
#include <Handle_TDF_Attribute.hxx>
#endif
#ifndef _Handle_PDF_Attribute_HeaderFile
#include <Handle_PDF_Attribute.hxx>
#endif
#ifndef _Handle_MDF_RRelocationTable_HeaderFile
#include <Handle_MDF_RRelocationTable.hxx>
#endif
class CDM_MessageDriver;
class Standard_Type;
class TDF_Attribute;
class PDF_Attribute;
class MDF_RRelocationTable;
class TCollection_ExtendedString;


//! Attribute Retrieval Driver. <br>
class MDF_ARDriver : public MMgt_TShared {

public:
 // Methods PUBLIC
 // 

//! Returns the version number from which the driver <br>
//!          is available. <br>
Standard_EXPORT virtual  Standard_Integer VersionNumber() const = 0;

//! Returns the type of source object, inheriting from <br>
//!          Attribute from PDF. <br>
Standard_EXPORT virtual  Handle_Standard_Type SourceType() const = 0;

//! Creates a new attribute from PDF. <br>
Standard_EXPORT virtual  Handle_TDF_Attribute NewEmpty() const = 0;

//! Translate the contents of <aSource> and put it <br>
//!          into <aTarget>, using the relocation table <br>
//!          <aRelocTable> to keep the sharings. <br>
Standard_EXPORT virtual  void Paste(const Handle(PDF_Attribute)& aSource,const Handle(TDF_Attribute)& aTarget,const Handle(MDF_RRelocationTable)& aRelocTable) const = 0;

//! To send message to Application (if MessageDriver defined) <br>
Standard_EXPORT   void WriteMessage(const TCollection_ExtendedString& theMessage) const;
//Standard_EXPORT ~MDF_ARDriver();




 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 


Standard_EXPORT MDF_ARDriver(const Handle(CDM_MessageDriver)& theMessageDriver);


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
Handle_CDM_MessageDriver myMessageDriver;


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
