// File generated by CPPExt (Value)
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _MFT_HeaderFile
#define _MFT_HeaderFile

#ifndef _Standard_CString_HeaderFile
#include <Standard_CString.hxx>
#endif
#ifndef _MFT_TypeOfCommand_HeaderFile
#include <MFT_TypeOfCommand.hxx>
#endif
#ifndef _MFT_TypeOfValue_HeaderFile
#include <MFT_TypeOfValue.hxx>
#endif
class MFT_FontManager;
class MFT_TextManager;
class MFT_ListOfFontName;
class MFT_ListOfFontHandle;
class MFT_ListOfFontReference;
class MFT_SequenceNodeOfListOfFontName;
class MFT_SequenceNodeOfListOfFontHandle;
class MFT_SequenceNodeOfListOfFontReference;


#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_Macro_HeaderFile
#include <Standard_Macro.hxx>
#endif

//! This package contains a Meta Font toolkit and utilities. <br>
//!	    1) Enable to creates MDTV outline fonts from others specific fonts <br>
//!	       (i.e: PostScript fonts,Euclid3 fonts,...) <br>
//!	    2) Enable to retrieves a string or  extended string <br>
//!	       outline vector list according of the current font and <br>
//!	       text attribs : <br>
//!	       (policy,size,slant,orientation and curve precision) <br>
//!	    3) Enable to retrieve policy or text attribs <br>
//!	       (i.e: Foundry,Family,..,font or text size). <br>
class MFT  {

public:

    void* operator new(size_t,void* anAddress) 
      {
        return anAddress;
      }
    void* operator new(size_t size) 
      { 
        return Standard::Allocate(size); 
      }
    void  operator delete(void *anAddress) 
      { 
        if (anAddress) Standard::Free((Standard_Address&)anAddress); 
      }
 // Methods PUBLIC
 // 





protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 

//! Converts the type of command to string. <br>
Standard_EXPORT static  Standard_CString Convert(const MFT_TypeOfCommand aCommandType) ;

//! Converts the type of value to string. <br>
Standard_EXPORT static  Standard_CString Convert(const MFT_TypeOfValue aValueType) ;


 // Fields PRIVATE
 //

friend class MFT_FontManager;
friend class MFT_TextManager;
friend class MFT_ListOfFontName;
friend class MFT_ListOfFontHandle;
friend class MFT_ListOfFontReference;
friend class MFT_SequenceNodeOfListOfFontName;
friend class MFT_SequenceNodeOfListOfFontHandle;
friend class MFT_SequenceNodeOfListOfFontReference;

};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
