// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _Materials_Color_HeaderFile
#define _Materials_Color_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_Materials_Color_HeaderFile
#include <Handle_Materials_Color.hxx>
#endif

#ifndef _Quantity_Color_HeaderFile
#include <Quantity_Color.hxx>
#endif
#ifndef _Standard_Transient_HeaderFile
#include <Standard_Transient.hxx>
#endif
#ifndef _Quantity_TypeOfColor_HeaderFile
#include <Quantity_TypeOfColor.hxx>
#endif
#ifndef _Standard_Real_HeaderFile
#include <Standard_Real.hxx>
#endif
class Quantity_Color;


//! This class  encapsulates   a Quantity_Color  in  a <br>
//!          Transient object, to be used in an ObjectProperty <br>
//!          from the package Dynamic. <br>
class Materials_Color : public Standard_Transient {

public:
 // Methods PUBLIC
 // 

//! Creates an empty instance of Color. <br>
Standard_EXPORT Materials_Color();

//! Creates an instance of Color, with <acolor> as color. <br>
Standard_EXPORT Materials_Color(const Quantity_Color& acolor);

//! Sets <acolor> into <me>. <br>
Standard_EXPORT   void Color(const Quantity_Color& acolor) ;

//! Returns a Quantity_Color corresponding to <me>. <br>
Standard_EXPORT   Quantity_Color Color() const;

//! Get the values ( RGB or HLS )  between 0.0 and 1.0 <br>
Standard_EXPORT   void Color(const Quantity_TypeOfColor aTypeOfColor,Standard_Real& Reel1,Standard_Real& Reel2,Standard_Real& Reel3) const;

//! Get the values ( RGB or HLS )  between 0.0 and 255.0 <br>
Standard_EXPORT   void Color255(const Quantity_TypeOfColor aTypeOfColor,Standard_Real& Reel1,Standard_Real& Reel2,Standard_Real& Reel3) const;

//! Set the values ( RGB or HLS )  between 0.0 and 1.0 <br>
Standard_EXPORT   void SetColor(const Quantity_TypeOfColor aTypeOfColor,const Standard_Real Reel1,const Standard_Real Reel2,const Standard_Real Reel3) ;

//! Set the values ( RGB or HLS )  between 0.0 and 255.0 <br>
Standard_EXPORT   void SetColor255(const Quantity_TypeOfColor aTypeOfColor,const Standard_Real Reel1,const Standard_Real Reel2,const Standard_Real Reel3) ;
//Standard_EXPORT ~Materials_Color();




 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
Quantity_Color thecolor;


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
