// File generated by CPPExt (Value)
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _MeshAlgo_HeaderFile
#define _MeshAlgo_HeaderFile

#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
class MeshAlgo_Vertex;
class MeshAlgo_Edge;
class MeshAlgo_Triangle;
class MeshAlgo_Circ;
class MeshAlgo_DataMapOfIntegerCirc;
class MeshAlgo_CircleTool;
class MeshAlgo_PntComparator;
class MeshAlgo_IndexedPntComparator;
class MeshAlgo_Delaunay;
class MeshAlgo_DataStructure;
class MeshAlgo_ComparatorOfVertex;
class MeshAlgo_ComparatorOfIndexedVertex;
class MeshAlgo_Array1OfVertex;
class MeshAlgo_HArray1OfVertex;
class MeshAlgo_HeapSortVertex;
class MeshAlgo_HeapSortIndexedVertex;
class MeshAlgo_DataMapNodeOfDataMapOfIntegerCirc;
class MeshAlgo_DataMapIteratorOfDataMapOfIntegerCirc;


#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_Macro_HeaderFile
#include <Standard_Macro.hxx>
#endif

//! Manages different algorithms for triangulation. <br>
//!          (like Delaunay) <br>
class MeshAlgo  {

public:

    void* operator new(size_t,void* anAddress) 
      {
        return anAddress;
      }
    void* operator new(size_t size) 
      { 
        return Standard::Allocate(size); 
      }
    void  operator delete(void *anAddress) 
      { 
        if (anAddress) Standard::Free((Standard_Address&)anAddress); 
      }
 // Methods PUBLIC
 // 


Standard_EXPORT static  void SetMesure(const Standard_Boolean val) ;


Standard_EXPORT static  void SetTrace(const Standard_Integer val) ;





protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //

friend class MeshAlgo_Vertex;
friend class MeshAlgo_Edge;
friend class MeshAlgo_Triangle;
friend class MeshAlgo_Circ;
friend class MeshAlgo_DataMapOfIntegerCirc;
friend class MeshAlgo_CircleTool;
friend class MeshAlgo_PntComparator;
friend class MeshAlgo_IndexedPntComparator;
friend class MeshAlgo_Delaunay;
friend class MeshAlgo_DataStructure;
friend class MeshAlgo_ComparatorOfVertex;
friend class MeshAlgo_ComparatorOfIndexedVertex;
friend class MeshAlgo_Array1OfVertex;
friend class MeshAlgo_HArray1OfVertex;
friend class MeshAlgo_HeapSortVertex;
friend class MeshAlgo_HeapSortIndexedVertex;
friend class MeshAlgo_DataMapNodeOfDataMapOfIntegerCirc;
friend class MeshAlgo_DataMapIteratorOfDataMapOfIntegerCirc;

};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
