// File generated by CPPExt (Value)
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _MeshShape_HeaderFile
#define _MeshShape_HeaderFile

#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
class MeshShape_Vertex;
class MeshShape_Edge;
class MeshShape_Triangle;
class MeshShape_PolygonPoint;
class MeshShape_Polygon;
class MeshShape_SurfacePoint;
class MeshShape_ListOfSurfacePoint;
class MeshShape_Curve;
class MeshShape_Surface;
class MeshShape_ShapeTool;
class MeshShape_GeomTool;
class MeshShape_Couple;
class MeshShape_CoupleHasher;
class MeshShape_MapOfCouple;
class MeshShape_DataMapOfIntegerPnt;
class MeshShape_DataMapOfIntegerXY;
class MeshShape_DataMapOfShapeListOfTransient;
class MeshShape_UV;
class MeshShape_Delaun;
class MeshShape_ListOfMeshVertex;
class MeshShape_DataMapOfVertexInteger;
class MeshShape_DataMapOfEdgePolygon;
class MeshShape_DataMapOfIntegerFace;
class MeshShape_StripIterator;
class MeshShape_ListNodeOfPolygon;
class MeshShape_ListIteratorOfPolygon;
class MeshShape_ListNodeOfListOfSurfacePoint;
class MeshShape_ListIteratorOfListOfSurfacePoint;
class MeshShape_StdMapNodeOfMapOfCouple;
class MeshShape_MapIteratorOfMapOfCouple;
class MeshShape_DataMapNodeOfDataMapOfIntegerPnt;
class MeshShape_DataMapIteratorOfDataMapOfIntegerPnt;
class MeshShape_DataMapNodeOfDataMapOfIntegerXY;
class MeshShape_DataMapIteratorOfDataMapOfIntegerXY;
class MeshShape_DataMapNodeOfDataMapOfShapeListOfTransient;
class MeshShape_DataMapIteratorOfDataMapOfShapeListOfTransient;


#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_Macro_HeaderFile
#include <Standard_Macro.hxx>
#endif

//! Describes the method to mesh a  face or a shape by <br>
//!          triangles with respect of the restricted area, the <br>
//!          deflection and the shared geometrical elements. <br>
//!  Level : Advanced. <br>
//!  All methods of all  classes will be advanced. <br>
class MeshShape  {

public:

    void* operator new(size_t,void* anAddress) 
      {
        return anAddress;
      }
    void* operator new(size_t size) 
      { 
        return Standard::Allocate(size); 
      }
    void  operator delete(void *anAddress) 
      { 
        if (anAddress) Standard::Free((Standard_Address&)anAddress); 
      }
 // Methods PUBLIC
 // 


Standard_EXPORT static  void SetMesure(const Standard_Boolean val) ;


Standard_EXPORT static  void SetTrace(const Standard_Integer val) ;





protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //

friend class MeshShape_Vertex;
friend class MeshShape_Edge;
friend class MeshShape_Triangle;
friend class MeshShape_PolygonPoint;
friend class MeshShape_Polygon;
friend class MeshShape_SurfacePoint;
friend class MeshShape_ListOfSurfacePoint;
friend class MeshShape_Curve;
friend class MeshShape_Surface;
friend class MeshShape_ShapeTool;
friend class MeshShape_GeomTool;
friend class MeshShape_Couple;
friend class MeshShape_CoupleHasher;
friend class MeshShape_MapOfCouple;
friend class MeshShape_DataMapOfIntegerPnt;
friend class MeshShape_DataMapOfIntegerXY;
friend class MeshShape_DataMapOfShapeListOfTransient;
friend class MeshShape_UV;
friend class MeshShape_Delaun;
friend class MeshShape_ListOfMeshVertex;
friend class MeshShape_DataMapOfVertexInteger;
friend class MeshShape_DataMapOfEdgePolygon;
friend class MeshShape_DataMapOfIntegerFace;
friend class MeshShape_StripIterator;
friend class MeshShape_ListNodeOfPolygon;
friend class MeshShape_ListIteratorOfPolygon;
friend class MeshShape_ListNodeOfListOfSurfacePoint;
friend class MeshShape_ListIteratorOfListOfSurfacePoint;
friend class MeshShape_StdMapNodeOfMapOfCouple;
friend class MeshShape_MapIteratorOfMapOfCouple;
friend class MeshShape_DataMapNodeOfDataMapOfIntegerPnt;
friend class MeshShape_DataMapIteratorOfDataMapOfIntegerPnt;
friend class MeshShape_DataMapNodeOfDataMapOfIntegerXY;
friend class MeshShape_DataMapIteratorOfDataMapOfIntegerXY;
friend class MeshShape_DataMapNodeOfDataMapOfShapeListOfTransient;
friend class MeshShape_DataMapIteratorOfDataMapOfShapeListOfTransient;

};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
