// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _MgtTopoDS_TranslateTool_HeaderFile
#define _MgtTopoDS_TranslateTool_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_MgtTopoDS_TranslateTool_HeaderFile
#include <Handle_MgtTopoDS_TranslateTool.hxx>
#endif

#ifndef _MMgt_TShared_HeaderFile
#include <MMgt_TShared.hxx>
#endif
#ifndef _Handle_PTopoDS_HShape_HeaderFile
#include <Handle_PTopoDS_HShape.hxx>
#endif
class Standard_TypeMismatch;
class TopoDS_Shape;
class PTopoDS_HShape;
class PTColStd_TransientPersistentMap;
class PTColStd_PersistentTransientMap;


//! The TranslateTool class is provided to support the <br>
//!          translation of inherited parts of topological data <br>
//!          structures. <br>
class MgtTopoDS_TranslateTool : public MMgt_TShared {

public:
 // Methods PUBLIC
 // 


Standard_EXPORT virtual  void Add(TopoDS_Shape& S1,const TopoDS_Shape& S2) const = 0;


Standard_EXPORT virtual  void MakeVertex(TopoDS_Shape& S) const = 0;


Standard_EXPORT virtual  void MakeVertex(const Handle(PTopoDS_HShape)& S) const = 0;


Standard_EXPORT virtual  void MakeEdge(TopoDS_Shape& S) const = 0;


Standard_EXPORT virtual  void MakeEdge(const Handle(PTopoDS_HShape)& S) const = 0;


Standard_EXPORT virtual  void MakeWire(TopoDS_Shape& S) const = 0;


Standard_EXPORT virtual  void MakeWire(const Handle(PTopoDS_HShape)& S) const = 0;


Standard_EXPORT virtual  void MakeFace(TopoDS_Shape& S) const = 0;


Standard_EXPORT virtual  void MakeFace(const Handle(PTopoDS_HShape)& S) const = 0;


Standard_EXPORT virtual  void MakeShell(TopoDS_Shape& S) const = 0;


Standard_EXPORT virtual  void MakeShell(const Handle(PTopoDS_HShape)& S) const = 0;


Standard_EXPORT virtual  void MakeSolid(TopoDS_Shape& S) const = 0;


Standard_EXPORT virtual  void MakeSolid(const Handle(PTopoDS_HShape)& S) const = 0;


Standard_EXPORT virtual  void MakeCompSolid(TopoDS_Shape& S) const = 0;


Standard_EXPORT virtual  void MakeCompSolid(const Handle(PTopoDS_HShape)& S) const = 0;


Standard_EXPORT virtual  void MakeCompound(TopoDS_Shape& S) const = 0;


Standard_EXPORT virtual  void MakeCompound(const Handle(PTopoDS_HShape)& S) const = 0;

//! Basic update method <br>
Standard_EXPORT   void UpdateShape(const TopoDS_Shape& S1,const Handle(PTopoDS_HShape)& S2) const;

//! Basic update method <br>
Standard_EXPORT   void UpdateShape(const Handle(PTopoDS_HShape)& S1,TopoDS_Shape& S2) const;


Standard_EXPORT virtual  void UpdateVertex(const TopoDS_Shape& S1,const Handle(PTopoDS_HShape)& S2,PTColStd_TransientPersistentMap& M) const;


Standard_EXPORT virtual  void UpdateVertex(const Handle(PTopoDS_HShape)& S1,TopoDS_Shape& S2,PTColStd_PersistentTransientMap& M) const;


Standard_EXPORT virtual  void UpdateEdge(const TopoDS_Shape& S1,const Handle(PTopoDS_HShape)& S2,PTColStd_TransientPersistentMap& M) const;


Standard_EXPORT virtual  void UpdateEdge(const Handle(PTopoDS_HShape)& S1,TopoDS_Shape& S2,PTColStd_PersistentTransientMap& M) const;


Standard_EXPORT virtual  void UpdateWire(const TopoDS_Shape& S1,const Handle(PTopoDS_HShape)& S2) const;


Standard_EXPORT virtual  void UpdateWire(const Handle(PTopoDS_HShape)& S1,TopoDS_Shape& S2) const;


Standard_EXPORT virtual  void UpdateFace(const TopoDS_Shape& S1,const Handle(PTopoDS_HShape)& S2,PTColStd_TransientPersistentMap& M) const;


Standard_EXPORT virtual  void UpdateFace(const Handle(PTopoDS_HShape)& S1,TopoDS_Shape& S2,PTColStd_PersistentTransientMap& M) const;


Standard_EXPORT virtual  void UpdateShell(const TopoDS_Shape& S1,const Handle(PTopoDS_HShape)& S2) const;


Standard_EXPORT virtual  void UpdateShell(const Handle(PTopoDS_HShape)& S1,TopoDS_Shape& S2) const;


Standard_EXPORT virtual  void UpdateSolid(const TopoDS_Shape& S1,const Handle(PTopoDS_HShape)& S2) const;


Standard_EXPORT virtual  void UpdateSolid(const Handle(PTopoDS_HShape)& S1,TopoDS_Shape& S2) const;


Standard_EXPORT virtual  void UpdateCompSolid(const TopoDS_Shape& S1,const Handle(PTopoDS_HShape)& S2) const;


Standard_EXPORT virtual  void UpdateCompSolid(const Handle(PTopoDS_HShape)& S1,TopoDS_Shape& S2) const;


Standard_EXPORT virtual  void UpdateCompound(const TopoDS_Shape& S1,const Handle(PTopoDS_HShape)& S2) const;


Standard_EXPORT virtual  void UpdateCompound(const Handle(PTopoDS_HShape)& S1,TopoDS_Shape& S2) const;
//Standard_EXPORT ~MgtTopoDS_TranslateTool();




 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
