// File generated by CPPExt (Value)
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _MoniTool_TimerSentry_HeaderFile
#define _MoniTool_TimerSentry_HeaderFile

#ifndef _Handle_MoniTool_Timer_HeaderFile
#include <Handle_MoniTool_Timer.hxx>
#endif
#ifndef _Standard_CString_HeaderFile
#include <Standard_CString.hxx>
#endif
class MoniTool_Timer;


#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_Macro_HeaderFile
#include <Standard_Macro.hxx>
#endif

//! A tool to facilitate using MoniTool_Timer functionality <br>
//!          by automatically ensuring consistency of start/stop actions <br>
class MoniTool_TimerSentry  {

public:

    void* operator new(size_t,void* anAddress) 
      {
        return anAddress;
      }
    void* operator new(size_t size) 
      { 
        return Standard::Allocate(size); 
      }
    void  operator delete(void *anAddress) 
      { 
        if (anAddress) Standard::Free((Standard_Address&)anAddress); 
      }
 // Methods PUBLIC
 // 
//! Constructor creates an instance and runs the corresponding timer <br>
MoniTool_TimerSentry(const Standard_CString cname);
//! Constructor creates an instance and runs the corresponding timer <br>
MoniTool_TimerSentry(const Handle(MoniTool_Timer)& timer);
//! Destructor stops the associated timer <br>
  void Destroy() ;
Standard_EXPORT ~MoniTool_TimerSentry () { Destroy(); }

  Handle_MoniTool_Timer Timer() const;
//! Manually stops the timer <br>
  void Stop() ;





protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
Handle_MoniTool_Timer myTimer;


};


#include <MoniTool_TimerSentry.lxx>



// other Inline functions and methods (like "C++: function call" methods)
//


#endif
