/***********************************************************************

     FONCTION :
     ----------
        File OpenGl_tXfm.h :
 

     REMARQUES:
     ---------- 
      

     HISTORIQUE DES MODIFICATIONS   :
     --------------------------------
       xx-xx-xx : xxx ; Creation.
       26-06-96 : FMN ; Ajout commentaires
       02-11-98 : FMN ; PRO12916: Desactivation de la gestion du CharacterExpansionFactor 
			qui n'est pas implementee. Ce point sera traite de maniere
			complete avec l'utilisation d'une librairie specifique
			de type GLC. Pour le moment il est preferable de le
			desactiver car ce parametre n'est pas vraiment necessaire.
       30-11-98 : FMN ; S4069 : Textes toujours visibles.
			Mise en commun de point d'entree UNIX-WNT

************************************************************************/
#ifndef OCC2934
#define OCC2934 /* SAN 22/01/04 Texture mapped fonts on WNT */
#endif

#ifndef OCC7667
#define OCC7667 /* ASL - Export view content to vector format file */
#endif

/*----------------------------------------------------------------------*/
/*		UNIX XWINDOW                                            */
/*----------------------------------------------------------------------*/

#ifndef WNT

/*----------------------------------------------------------------------*/
/*
 * Contantes
 */

#define NUM_FONT_ENTRIES (sizeof(fontEntry)/sizeof(FontEntry))
#define NUM_FONT_SIZES 40
#define NUM_CHAR_FONT 1024
#define CACHE_SIZE 30

typedef struct TXFM_FONTHANDLE_STRUCT {
	char Xfontname[100];
        char fontname[50];
        float charsize;
        Display *dpy;
        GLuint listBase;
        float xscale;
        float yscale;
        GLboolean dirty;
	XFontStruct *fontInfo;
} TXFM_FONTHANDLE, *txfmfonthandle;

typedef struct {
    char     *name;	    
    char     *xlfd;	    /* XLFD X Font Logical Description */
    float    xsizes[NUM_FONT_SIZES];
    int	     count;
} FontEntry, *FontEntryPtr;


/*----------------------------------------------------------------------*/
/*
 * Fonctions publiques
 */

txfmfonthandle tXfmfindfont(Display *, char *, float);
GLuint tXfmsetfont( float , float );
void tXfmprstr ( unsigned char*, GLuint, GLfloat, GLfloat, GLfloat );
void sizeString(char *text, GLint *width, GLint *ascent, GLint *descent);

/*----------------------------------------------------------------------*/
/*		Windows NT                                              */
/*----------------------------------------------------------------------*/

#else  /* WNT */

# define STRICT
# include <windows.h>
#include <GL/Gl.h>
#include <GL/Glu.h>

#include <OpenGl_tgl_all.h>
#include <OpenGl_cmn_varargs.h>
#include <OpenGl_tsm.h>
#include <OpenGl_telem_attri.h>

# ifndef Display
#  define Display char
# endif  /* Display */

void   WNTFindFont ( char*, float  );
GLuint WNTSetFont  ( float, float  );
#ifdef OCC2934
void   WNTPuts     ( char*, GLuint, int, GLfloat, GLfloat, GLfloat );
#else
void   WNTPuts     ( char*, GLuint );
#endif
void   sizeString(char *text, GLint *width, GLint *ascent, GLint *descent);

#ifdef OCC2934
void   WNTUseTexMappedFont( int );
#endif

#endif  /* WNT */

/*----------------------------------------------------------------------*/
