// File generated by CPPExt (Persistent CSFDB)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.
#ifndef _PBRep_CurveOnSurface_HeaderFile
#define _PBRep_CurveOnSurface_HeaderFile

#ifndef _Handle_PBRep_CurveOnSurface_HeaderFile
#include <Handle_PBRep_CurveOnSurface.hxx>
#endif
#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif

#ifndef _Handle_PGeom_Surface_HeaderFile
#include <Handle_PGeom_Surface.hxx>
#endif
#ifndef _Handle_PGeom2d_Curve_HeaderFile
#include <Handle_PGeom2d_Curve.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
#ifndef _gp_Pnt2d_HeaderFile
#include <gp_Pnt2d.hxx>
#endif
#ifndef _PBRep_GCurve_HeaderFile
#include <PBRep_GCurve.hxx>
#endif
#ifndef _Standard_Real_HeaderFile
#include <Standard_Real.hxx>
#endif
class PGeom_Surface;
class PGeom2d_Curve;
class PTopLoc_Location;
class gp_Pnt2d;


class PBRep_CurveOnSurface : public PBRep_GCurve {

public:

 // Methods PUBLIC
 // 

//! CF is curve first parameter <br>
//!          CL is curve last parameter <br>
//!          As far as they can't be computed from a Persistent Curve <br>
//!          they are given in the CurveOnSurface constructor <br>
Standard_EXPORT PBRep_CurveOnSurface(const Handle(PGeom2d_Curve)& PC,const Standard_Real CF,const Standard_Real CL,const Handle(PGeom_Surface)& S,const PTopLoc_Location& L);


Standard_EXPORT   Handle_PGeom_Surface Surface() const;


Standard_EXPORT   Handle_PGeom2d_Curve PCurve() const;

//! Returns True. <br>
Standard_EXPORT virtual  Standard_Boolean IsCurveOnSurface() const;


Standard_EXPORT   void SetUVPoints(const gp_Pnt2d& Pnt1,const gp_Pnt2d& Pnt2) ;


Standard_EXPORT   gp_Pnt2d FirstUV() const;


Standard_EXPORT   gp_Pnt2d LastUV() const;
//Standard_EXPORT ~PBRep_CurveOnSurface();
PBRep_CurveOnSurface( )
{
  
}

PBRep_CurveOnSurface(const Storage_stCONSTclCOM& a) : PBRep_GCurve(a)
{
  
}

    Handle(PGeom2d_Curve) _CSFDB_GetPBRep_CurveOnSurfacemyPCurve() const { return myPCurve; }
    void _CSFDB_SetPBRep_CurveOnSurfacemyPCurve(const Handle(PGeom2d_Curve)& p) { myPCurve = p; }
    Handle(PGeom_Surface) _CSFDB_GetPBRep_CurveOnSurfacemySurface() const { return mySurface; }
    void _CSFDB_SetPBRep_CurveOnSurfacemySurface(const Handle(PGeom_Surface)& p) { mySurface = p; }
    const gp_Pnt2d& _CSFDB_GetPBRep_CurveOnSurfacemyUV1() const { return myUV1; }
    const gp_Pnt2d& _CSFDB_GetPBRep_CurveOnSurfacemyUV2() const { return myUV2; }



 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
// Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 

 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 

 // Fields PRIVATE
 //
Handle_PGeom2d_Curve myPCurve;
Handle_PGeom_Surface mySurface;
gp_Pnt2d myUV1;
gp_Pnt2d myUV2;


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
