// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _PCDM_StorageDriver_HeaderFile
#define _PCDM_StorageDriver_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_PCDM_StorageDriver_HeaderFile
#include <Handle_PCDM_StorageDriver.hxx>
#endif

#ifndef _TCollection_ExtendedString_HeaderFile
#include <TCollection_ExtendedString.hxx>
#endif
#ifndef _PCDM_Writer_HeaderFile
#include <PCDM_Writer.hxx>
#endif
#ifndef _Handle_PCDM_Document_HeaderFile
#include <Handle_PCDM_Document.hxx>
#endif
#ifndef _Handle_CDM_Document_HeaderFile
#include <Handle_CDM_Document.hxx>
#endif
#ifndef _Handle_Storage_Schema_HeaderFile
#include <Handle_Storage_Schema.hxx>
#endif
class Standard_NoSuchObject;
class PCDM_DriverError;
class PCDM_Document;
class CDM_Document;
class PCDM_SequenceOfDocument;
class TCollection_ExtendedString;
class Storage_Schema;
class TColStd_SequenceOfExtendedString;


//! persistent implemention of storage. <br>
class PCDM_StorageDriver : public PCDM_Writer {

public:
 // Methods PUBLIC
 // 

//! raises NotImplemented. <br>
Standard_EXPORT virtual  Handle_PCDM_Document Make(const Handle(CDM_Document)& aDocument) ;

//!By default, puts  in the Sequence the  document returns <br>
//!            by the previous Make method. <br>
//! <br>
Standard_EXPORT virtual  void Make(const Handle(CDM_Document)& aDocument,PCDM_SequenceOfDocument& Documents) ;


Standard_EXPORT virtual  TCollection_ExtendedString SchemaName() const = 0;


Standard_EXPORT virtual  void LoadExtensions(const Handle(Storage_Schema)& aSchema,const TColStd_SequenceOfExtendedString& Extensions) ;

//!  Warning! raises DriverError if an error occurs during inside the <br>
//!          Make method. <br>//! stores the content of the Document into a new file. <br>
//! <br>
//!          by  default  Write will  use Make   method to build a persistent <br>
//!          document and the Schema method to write the persistent document. <br>
//! <br>
Standard_EXPORT virtual  void Write(const Handle(CDM_Document)& aDocument,const TCollection_ExtendedString& aFileName) ;


Standard_EXPORT   void SetFormat(const TCollection_ExtendedString& aformat) ;


Standard_EXPORT   TCollection_ExtendedString GetFormat() const;
//Standard_EXPORT ~PCDM_StorageDriver();




 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
TCollection_ExtendedString myFormat;


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
