// File generated by CPPExt (Persistent CSFDB)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.
#ifndef _PGeom2d_BezierCurve_HeaderFile
#define _PGeom2d_BezierCurve_HeaderFile

#ifndef _Handle_PGeom2d_BezierCurve_HeaderFile
#include <Handle_PGeom2d_BezierCurve.hxx>
#endif
#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif

#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
#ifndef _Handle_PColgp_HArray1OfPnt2d_HeaderFile
#include <Handle_PColgp_HArray1OfPnt2d.hxx>
#endif
#ifndef _Handle_PColStd_HArray1OfReal_HeaderFile
#include <Handle_PColStd_HArray1OfReal.hxx>
#endif
#ifndef _PGeom2d_BoundedCurve_HeaderFile
#include <PGeom2d_BoundedCurve.hxx>
#endif
class PColgp_HArray1OfPnt2d;
class PColStd_HArray1OfReal;


class PGeom2d_BezierCurve : public PGeom2d_BoundedCurve {

public:

 // Methods PUBLIC
 // 

//! Creates a non rational  Bezier curve with default <br>
//!         values. <br>
Standard_EXPORT PGeom2d_BezierCurve();

//! Creates a non rational Bezier curve with a set of <br>
//!         poles aCurvePoles and a set of weights aPoleWeight. <br>
Standard_EXPORT PGeom2d_BezierCurve(const Handle(PColgp_HArray1OfPnt2d)& aPoles,const Handle(PColStd_HArray1OfReal)& aWeights,const Standard_Boolean aRational);

//! Set the value of the field rational with <aRational>. <br>
Standard_EXPORT   void Rational(const Standard_Boolean aRational) ;

//! Returns the value of the field rational. <br>
Standard_EXPORT   Standard_Boolean Rational() const;

//! Set the value of the field poles with <aPoles>. <br>
Standard_EXPORT   void Poles(const Handle(PColgp_HArray1OfPnt2d)& aPoles) ;

//! Returns the value of the field poles. <br>
Standard_EXPORT   Handle_PColgp_HArray1OfPnt2d Poles() const;

//! Set the value of the field weights. <br>
Standard_EXPORT   void Weights(const Handle(PColStd_HArray1OfReal)& aWeights) ;

//! Returns the value of the field weights. <br>
Standard_EXPORT   Handle_PColStd_HArray1OfReal Weights() const;
//Standard_EXPORT ~PGeom2d_BezierCurve();
PGeom2d_BezierCurve(const Storage_stCONSTclCOM& a) : PGeom2d_BoundedCurve(a)
{
  
}

    Standard_Boolean _CSFDB_GetPGeom2d_BezierCurverational() const { return rational; }
    void _CSFDB_SetPGeom2d_BezierCurverational(const Standard_Boolean p) { rational = p; }
    Handle(PColgp_HArray1OfPnt2d) _CSFDB_GetPGeom2d_BezierCurvepoles() const { return poles; }
    void _CSFDB_SetPGeom2d_BezierCurvepoles(const Handle(PColgp_HArray1OfPnt2d)& p) { poles = p; }
    Handle(PColStd_HArray1OfReal) _CSFDB_GetPGeom2d_BezierCurveweights() const { return weights; }
    void _CSFDB_SetPGeom2d_BezierCurveweights(const Handle(PColStd_HArray1OfReal)& p) { weights = p; }



 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
// Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 

 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 

 // Fields PRIVATE
 //
Standard_Boolean rational;
Handle_PColgp_HArray1OfPnt2d poles;
Handle_PColStd_HArray1OfReal weights;


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
