// File generated by CPPExt (Persistent CSFDB)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.
#ifndef _PGeom2d_Hyperbola_HeaderFile
#define _PGeom2d_Hyperbola_HeaderFile

#ifndef _Handle_PGeom2d_Hyperbola_HeaderFile
#include <Handle_PGeom2d_Hyperbola.hxx>
#endif
#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif

#ifndef _Standard_Real_HeaderFile
#include <Standard_Real.hxx>
#endif
#ifndef _PGeom2d_Conic_HeaderFile
#include <PGeom2d_Conic.hxx>
#endif
class gp_Ax22d;


class PGeom2d_Hyperbola : public PGeom2d_Conic {

public:

 // Methods PUBLIC
 // 

//!Creates an Hyperbola with default values. <br>
Standard_EXPORT PGeom2d_Hyperbola();

//!  Creates an   Hyperbola    with      <aPosition>, <br>
//!         <aMajorRadius> and  <aMinorRadius> as field values. <br>
//!         The major  radius of the hyperbola is  on the XAxis <br>
//!         and   the minor  radius is  on    the YAxis of  the <br>
//!         hyperbola. <br>
Standard_EXPORT PGeom2d_Hyperbola(const gp_Ax22d& aPosition,const Standard_Real aMajorRadius,const Standard_Real aMinorRadius);

//! Set the value of the field majorRadius with <aMajorRadius>. <br>
Standard_EXPORT   void MajorRadius(const Standard_Real aMajorRadius) ;

//! Returns the value of the field majorRadius. <br>
Standard_EXPORT   Standard_Real MajorRadius() const;

//! Set the value of the field minorRadius with <aMinorRadius>. <br>
Standard_EXPORT   void MinorRadius(const Standard_Real aMinorRadius) ;

//! Returns the value of the field minorRadius. <br>
Standard_EXPORT   Standard_Real MinorRadius() const;
//Standard_EXPORT ~PGeom2d_Hyperbola();
PGeom2d_Hyperbola(const Storage_stCONSTclCOM& a) : PGeom2d_Conic(a)
{
  
}

    Standard_Real _CSFDB_GetPGeom2d_HyperbolamajorRadius() const { return majorRadius; }
    void _CSFDB_SetPGeom2d_HyperbolamajorRadius(const Standard_Real p) { majorRadius = p; }
    Standard_Real _CSFDB_GetPGeom2d_HyperbolaminorRadius() const { return minorRadius; }
    void _CSFDB_SetPGeom2d_HyperbolaminorRadius(const Standard_Real p) { minorRadius = p; }



 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
// Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 

 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 

 // Fields PRIVATE
 //
Standard_Real majorRadius;
Standard_Real minorRadius;


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
