// File generated by CPPExt (Persistent CSFDB)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.
#ifndef _PGeom2d_OffsetCurve_HeaderFile
#define _PGeom2d_OffsetCurve_HeaderFile

#ifndef _Handle_PGeom2d_OffsetCurve_HeaderFile
#include <Handle_PGeom2d_OffsetCurve.hxx>
#endif
#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif

#ifndef _Handle_PGeom2d_Curve_HeaderFile
#include <Handle_PGeom2d_Curve.hxx>
#endif
#ifndef _Standard_Real_HeaderFile
#include <Standard_Real.hxx>
#endif
#ifndef _PGeom2d_Curve_HeaderFile
#include <PGeom2d_Curve.hxx>
#endif
class PGeom2d_Curve;


class PGeom2d_OffsetCurve : public PGeom2d_Curve {

public:

 // Methods PUBLIC
 // 

//! Creates an OffsetCurve with default values. <br>
Standard_EXPORT PGeom2d_OffsetCurve();

//! <aBasisCurve> is  the basis curve, <aOffsetValue> <br>
//!         is the distance between <me> and the basis curve at <br>
//!         any point.    <aOffsetDirection>  defines the fixed <br>
//!         reference direction (offset direction). <br>
Standard_EXPORT PGeom2d_OffsetCurve(const Handle(PGeom2d_Curve)& aBasisCurve,const Standard_Real aOffsetValue);

//! Set the field basisCurve with <aBasisCurve>. <br>
Standard_EXPORT   void BasisCurve(const Handle(PGeom2d_Curve)& aBasisCurve) ;

//! The basis curve can be an offset curve. <br>
Standard_EXPORT   Handle_PGeom2d_Curve BasisCurve() const;

//! Set the field offsetValue with <aOffsetValue>. <br>
Standard_EXPORT   void OffsetValue(const Standard_Real aOffsetValue) ;

//! Returns the value of the field offsetValue. <br>
Standard_EXPORT   Standard_Real OffsetValue() const;
//Standard_EXPORT ~PGeom2d_OffsetCurve();
PGeom2d_OffsetCurve(const Storage_stCONSTclCOM& a) : PGeom2d_Curve(a)
{
  
}

    Handle(PGeom2d_Curve) _CSFDB_GetPGeom2d_OffsetCurvebasisCurve() const { return basisCurve; }
    void _CSFDB_SetPGeom2d_OffsetCurvebasisCurve(const Handle(PGeom2d_Curve)& p) { basisCurve = p; }
    Standard_Real _CSFDB_GetPGeom2d_OffsetCurveoffsetValue() const { return offsetValue; }
    void _CSFDB_SetPGeom2d_OffsetCurveoffsetValue(const Standard_Real p) { offsetValue = p; }



 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
// Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 

 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 

 // Fields PRIVATE
 //
Handle_PGeom2d_Curve basisCurve;
Standard_Real offsetValue;


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
