// File generated by CPPExt (Persistent CSFDB)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.
#ifndef _PGeom_OffsetSurface_HeaderFile
#define _PGeom_OffsetSurface_HeaderFile

#ifndef _Handle_PGeom_OffsetSurface_HeaderFile
#include <Handle_PGeom_OffsetSurface.hxx>
#endif
#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif

#ifndef _Handle_PGeom_Surface_HeaderFile
#include <Handle_PGeom_Surface.hxx>
#endif
#ifndef _Standard_Real_HeaderFile
#include <Standard_Real.hxx>
#endif
#ifndef _PGeom_Surface_HeaderFile
#include <PGeom_Surface.hxx>
#endif
class PGeom_Surface;


class PGeom_OffsetSurface : public PGeom_Surface {

public:

 // Methods PUBLIC
 // 

//! Creates an OffsetSurface with default values. <br>
Standard_EXPORT PGeom_OffsetSurface();

//!  <aBasisSurface>    is  the   basis      surface, <br>
//!         <aOffsetValue> is the distance between <me> and the <br>
//!         basis  surface at any  point.    <aOffsetDirection> <br>
//!         defines  the  fixed  reference  direction   (offset <br>
//!         direction). <br>
Standard_EXPORT PGeom_OffsetSurface(const Handle(PGeom_Surface)& aBasisSurface,const Standard_Real aOffsetValue);

//! Set the field basisSurface with <aBasisSurface>. <br>
Standard_EXPORT   void BasisSurface(const Handle(PGeom_Surface)& aBasisSurface) ;

//! The basis surface can be an offset surface. <br>
Standard_EXPORT   Handle_PGeom_Surface BasisSurface() const;

//! Set the field offsetValue with <aOffsetValue>. <br>
Standard_EXPORT   void OffsetValue(const Standard_Real aOffsetValue) ;

//! Returns the value of the field offsetValue. <br>
Standard_EXPORT   Standard_Real OffsetValue() const;
//Standard_EXPORT ~PGeom_OffsetSurface();
PGeom_OffsetSurface(const Storage_stCONSTclCOM& a) : PGeom_Surface(a)
{
  
}

    Handle(PGeom_Surface) _CSFDB_GetPGeom_OffsetSurfacebasisSurface() const { return basisSurface; }
    void _CSFDB_SetPGeom_OffsetSurfacebasisSurface(const Handle(PGeom_Surface)& p) { basisSurface = p; }
    Standard_Real _CSFDB_GetPGeom_OffsetSurfaceoffsetValue() const { return offsetValue; }
    void _CSFDB_SetPGeom_OffsetSurfaceoffsetValue(const Standard_Real p) { offsetValue = p; }



 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
// Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 

 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 

 // Fields PRIVATE
 //
Handle_PGeom_Surface basisSurface;
Standard_Real offsetValue;


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
