// File generated by CPPExt (Persistent CSFDB)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.
#ifndef _PGeom_TrimmedCurve_HeaderFile
#define _PGeom_TrimmedCurve_HeaderFile

#ifndef _Handle_PGeom_TrimmedCurve_HeaderFile
#include <Handle_PGeom_TrimmedCurve.hxx>
#endif
#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif

#ifndef _Standard_Real_HeaderFile
#include <Standard_Real.hxx>
#endif
#ifndef _Handle_PGeom_Curve_HeaderFile
#include <Handle_PGeom_Curve.hxx>
#endif
#ifndef _PGeom_BoundedCurve_HeaderFile
#include <PGeom_BoundedCurve.hxx>
#endif
class PGeom_Curve;


class PGeom_TrimmedCurve : public PGeom_BoundedCurve {

public:

 // Methods PUBLIC
 // 

//! Creates a TrimmedCurve with default values. <br>
Standard_EXPORT PGeom_TrimmedCurve();

//! Creates a TrimmedCurve with these field values. <br>
Standard_EXPORT PGeom_TrimmedCurve(const Handle(PGeom_Curve)& aBasisCurve,const Standard_Real aFirstU,const Standard_Real aLastU);

//! Set the value of the field firstU with <aFirstU>. <br>
Standard_EXPORT   void FirstU(const Standard_Real aFirstU) ;

//! Returns the value of the field firstU. <br>
Standard_EXPORT   Standard_Real FirstU() const;

//! Set the value of the field lastU with <aLastU>. <br>
Standard_EXPORT   void LastU(const Standard_Real aLastU) ;

//! Returns the value of the field lastU. <br>
Standard_EXPORT   Standard_Real LastU() const;

//! Set the value of the field basisCurve with <aBasisCurve>. <br>
//!  This curve can be a trimmed curve. <br>
Standard_EXPORT   void BasisCurve(const Handle(PGeom_Curve)& aBasisCurve) ;

//! Returns the value of the field basisCurve. <br>
//!  This curve can be a trimmed curve. <br>
Standard_EXPORT   Handle_PGeom_Curve BasisCurve() const;
//Standard_EXPORT ~PGeom_TrimmedCurve();
PGeom_TrimmedCurve(const Storage_stCONSTclCOM& a) : PGeom_BoundedCurve(a)
{
  
}

    Handle(PGeom_Curve) _CSFDB_GetPGeom_TrimmedCurvebasisCurve() const { return basisCurve; }
    void _CSFDB_SetPGeom_TrimmedCurvebasisCurve(const Handle(PGeom_Curve)& p) { basisCurve = p; }
    Standard_Real _CSFDB_GetPGeom_TrimmedCurvefirstU() const { return firstU; }
    void _CSFDB_SetPGeom_TrimmedCurvefirstU(const Standard_Real p) { firstU = p; }
    Standard_Real _CSFDB_GetPGeom_TrimmedCurvelastU() const { return lastU; }
    void _CSFDB_SetPGeom_TrimmedCurvelastU(const Standard_Real p) { lastU = p; }



 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
// Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 

 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 

 // Fields PRIVATE
 //
Handle_PGeom_Curve basisCurve;
Standard_Real firstU;
Standard_Real lastU;


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
