// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _Prs2d_Tolerance_HeaderFile
#define _Prs2d_Tolerance_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_Prs2d_Tolerance_HeaderFile
#include <Handle_Prs2d_Tolerance.hxx>
#endif

#ifndef _Standard_ShortReal_HeaderFile
#include <Standard_ShortReal.hxx>
#endif
#ifndef _Graphic2d_Line_HeaderFile
#include <Graphic2d_Line.hxx>
#endif
#ifndef _Handle_Graphic2d_GraphicObject_HeaderFile
#include <Handle_Graphic2d_GraphicObject.hxx>
#endif
#ifndef _Standard_Real_HeaderFile
#include <Standard_Real.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
#ifndef _Handle_Graphic2d_Drawer_HeaderFile
#include <Handle_Graphic2d_Drawer.hxx>
#endif
class Prs2d_ToleranceFrame;
class Graphic2d_GraphicObject;
class Graphic2d_Drawer;


//! Groups all the tolerances <br>
class Prs2d_Tolerance : public Graphic2d_Line {

public:
 // Methods PUBLIC
 // 

//! Changes the coordinates of this tolerance <br>
Standard_EXPORT   void SetCoord(const Standard_Real aX,const Standard_Real aY) ;

//! Defines the size of this one <br>
Standard_EXPORT   void SetSize(const Standard_Real aLen) ;
//Standard_EXPORT ~Prs2d_Tolerance();


friend class Prs2d_ToleranceFrame;


 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 

//! Creates a tolerance with the center in the point (<aX>, <aY>); <br>
//!          reference point is <aXPosition>, <aYPosition> <br>
Standard_EXPORT Prs2d_Tolerance(const Handle(Graphic2d_GraphicObject)& aGO,const Standard_Real aX,const Standard_Real aY,const Standard_Real aLength,const Standard_Real anAngle);

//! Returns Standard_True if the Tolerance is picked, <br>
//!	        Standard_False if not. <br>
Standard_EXPORT   Standard_Boolean Pick(const Standard_ShortReal X,const Standard_ShortReal Y,const Standard_ShortReal aPrecision,const Handle(Graphic2d_Drawer)& aDrawer) ;


 // Fields PROTECTED
 //
Standard_ShortReal myX;
Standard_ShortReal myY;
Standard_ShortReal myLength;
Standard_ShortReal myAngle;


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
