// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _Prs3d_ArrowAspect_HeaderFile
#define _Prs3d_ArrowAspect_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_Prs3d_ArrowAspect_HeaderFile
#include <Handle_Prs3d_ArrowAspect.hxx>
#endif

#ifndef _Handle_Graphic3d_AspectLine3d_HeaderFile
#include <Handle_Graphic3d_AspectLine3d.hxx>
#endif
#ifndef _Quantity_PlaneAngle_HeaderFile
#include <Quantity_PlaneAngle.hxx>
#endif
#ifndef _Quantity_Length_HeaderFile
#include <Quantity_Length.hxx>
#endif
#ifndef _Prs3d_CompositeAspect_HeaderFile
#include <Prs3d_CompositeAspect.hxx>
#endif
#ifndef _Quantity_NameOfColor_HeaderFile
#include <Quantity_NameOfColor.hxx>
#endif
#ifndef _Standard_OStream_HeaderFile
#include <Standard_OStream.hxx>
#endif
class Graphic3d_AspectLine3d;
class Prs3d_InvalidAngle;
class Quantity_Color;


//! A framework for displaying arrows in representations <br>
//! of dimensions and relations. <br>
class Prs3d_ArrowAspect : public Prs3d_CompositeAspect {

public:
 // Methods PUBLIC
 // 

//! Constructs an empty framework for displaying arrows <br>
//! in representations of lengths. The lengths displayed <br>
//! are either on their own or in chamfers, fillets, <br>
//! diameters and radii. <br>
Standard_EXPORT Prs3d_ArrowAspect();

//! Constructs a framework to display an arrow with a <br>
//! shaft of the length aLength and having a head with <br>
//! sides at the angle anAngle from each other. <br>
Standard_EXPORT Prs3d_ArrowAspect(const Quantity_PlaneAngle anAngle,const Quantity_Length aLength);

//! defines the angle of the arrows. <br>
Standard_EXPORT   void SetAngle(const Quantity_PlaneAngle anAngle) ;

//! returns the current value of the angle used when drawing an arrow. <br>
Standard_EXPORT   Quantity_PlaneAngle Angle() const;

//! defines the length of the arrows. <br>
Standard_EXPORT   void SetLength(const Quantity_Length aLength) ;

//! returns the current value of the length used when drawing an arrow. <br>
Standard_EXPORT   Quantity_Length Length() const;


Standard_EXPORT   void SetColor(const Quantity_Color& aColor) ;


Standard_EXPORT   void SetColor(const Quantity_NameOfColor aColor) ;


Standard_EXPORT   Handle_Graphic3d_AspectLine3d Aspect() const;


Standard_EXPORT virtual  void Print(Standard_OStream& s) const;
//Standard_EXPORT ~Prs3d_ArrowAspect();




 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
Handle_Graphic3d_AspectLine3d myArrowAspect;
Quantity_PlaneAngle myAngle;
Quantity_Length myLength;


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
