// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _STEPControl_Controller_HeaderFile
#define _STEPControl_Controller_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_STEPControl_Controller_HeaderFile
#include <Handle_STEPControl_Controller.hxx>
#endif

#ifndef _XSControl_Controller_HeaderFile
#include <XSControl_Controller.hxx>
#endif
#ifndef _Handle_Interface_InterfaceModel_HeaderFile
#include <Handle_Interface_InterfaceModel.hxx>
#endif
#ifndef _Handle_Transfer_ActorOfTransientProcess_HeaderFile
#include <Handle_Transfer_ActorOfTransientProcess.hxx>
#endif
#ifndef _Handle_XSControl_WorkSession_HeaderFile
#include <Handle_XSControl_WorkSession.hxx>
#endif
#ifndef _IFSelect_ReturnStatus_HeaderFile
#include <IFSelect_ReturnStatus.hxx>
#endif
#ifndef _Handle_Transfer_FinderProcess_HeaderFile
#include <Handle_Transfer_FinderProcess.hxx>
#endif
#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
class Interface_InterfaceModel;
class Transfer_ActorOfTransientProcess;
class XSControl_WorkSession;
class TopoDS_Shape;
class Transfer_FinderProcess;


//! defines basic controller for STEP processor <br>
class STEPControl_Controller : public XSControl_Controller {

public:
 // Methods PUBLIC
 // 

//! Initializes the use of STEP Norm (the first time) and <br>
//!           returns a Controller <br>
Standard_EXPORT STEPControl_Controller();

//! Creates a new empty Model ready to receive data of the Norm. <br>
//!           It is taken from STEP Template Model <br>
Standard_EXPORT   Handle_Interface_InterfaceModel NewModel() const;

//! Returns a new Actor for Read attached to the pair (norm,appli) <br>
//!           It is a PmsToTopoDSAct_Actor <br>
Standard_EXPORT   Handle_Transfer_ActorOfTransientProcess ActorRead(const Handle(Interface_InterfaceModel)& model) const;


Standard_EXPORT virtual  void Customise(Handle(XSControl_WorkSession)& WS) ;

//! Takes one Shape and transfers it to the InterfaceModel <br>
//!           (already created by NewModel for instance) <br>
//!           <modeshape> is to be interpreted by each kind of XstepAdaptor <br>
//!           Returns a status : 0 OK  1 No result  2 Fail  -1 bad modeshape <br>
//!               -2 bad model (requires a StepModel) <br>
//!           modeshape : 1 Facetted BRep, 2 Shell, 3 Manifold Solid <br>
Standard_EXPORT virtual  IFSelect_ReturnStatus TransferWriteShape(const TopoDS_Shape& shape,const Handle(Transfer_FinderProcess)& FP,const Handle(Interface_InterfaceModel)& model,const Standard_Integer modetrans = 0) const;

//! Standard Initialisation. It creates a Controller for STEP <br>
//!           and records it to various names, available to select it later <br>
//!           Returns True when done, False if could not be done <br>
Standard_EXPORT static  Standard_Boolean Init() ;
//Standard_EXPORT ~STEPControl_Controller();




 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
