// File generated by CPPExt (Value)
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _STEPSelections_Counter_HeaderFile
#define _STEPSelections_Counter_HeaderFile

#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
#ifndef _TColStd_MapOfTransient_HeaderFile
#include <TColStd_MapOfTransient.hxx>
#endif
#ifndef _Handle_Standard_Transient_HeaderFile
#include <Handle_Standard_Transient.hxx>
#endif
#ifndef _Handle_StepShape_ConnectedFaceSet_HeaderFile
#include <Handle_StepShape_ConnectedFaceSet.hxx>
#endif
#ifndef _Handle_StepGeom_CompositeCurve_HeaderFile
#include <Handle_StepGeom_CompositeCurve.hxx>
#endif
class Interface_Graph;
class Standard_Transient;
class StepShape_ConnectedFaceSet;
class StepGeom_CompositeCurve;


#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_Macro_HeaderFile
#include <Standard_Macro.hxx>
#endif


class STEPSelections_Counter  {

public:

    void* operator new(size_t,void* anAddress) 
      {
        return anAddress;
      }
    void* operator new(size_t size) 
      { 
        return Standard::Allocate(size); 
      }
    void  operator delete(void *anAddress) 
      { 
        if (anAddress) Standard::Free((Standard_Address&)anAddress); 
      }
 // Methods PUBLIC
 // 


Standard_EXPORT STEPSelections_Counter();


Standard_EXPORT   void Count(const Interface_Graph& graph,const Handle(Standard_Transient)& start) ;


Standard_EXPORT   void Clear() ;

  Standard_Integer NbInstancesOfFaces() const;

  Standard_Integer POP() const;

  Standard_Integer POP2() const;

  Standard_Integer NbInstancesOfShells() const;

  Standard_Integer NbInstancesOfSolids() const;

  Standard_Integer NbInstancesOfEdges() const;

  Standard_Integer NbInstancesOfWires() const;

  Standard_Integer NbSourceFaces() const;

  Standard_Integer NbSourceShells() const;

  Standard_Integer NbSourceSolids() const;

  Standard_Integer NbSourceEdges() const;

  Standard_Integer NbSourceWires() const;





protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


Standard_EXPORT   void AddShell(const Handle(StepShape_ConnectedFaceSet)& cfs) ;


Standard_EXPORT   void AddCompositeCurve(const Handle(StepGeom_CompositeCurve)& ccurve) ;


 // Fields PRIVATE
 //
Standard_Integer myNbFaces;
Standard_Integer myNbShells;
Standard_Integer myNbSolids;
Standard_Integer myNbEdges;
Standard_Integer myNbWires;
TColStd_MapOfTransient myMapOfFaces;
TColStd_MapOfTransient myMapOfShells;
TColStd_MapOfTransient myMapOfSolids;
TColStd_MapOfTransient myMapOfEdges;
TColStd_MapOfTransient myMapOfWires;


};


#include <STEPSelections_Counter.lxx>



// other Inline functions and methods (like "C++: function call" methods)
//


#endif
