// File generated by CPPExt (Value)
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _SWDRAW_ToVRML_HeaderFile
#define _SWDRAW_ToVRML_HeaderFile

#ifndef _Standard_Real_HeaderFile
#include <Standard_Real.hxx>
#endif
#ifndef _TCollection_AsciiString_HeaderFile
#include <TCollection_AsciiString.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
#ifndef _Standard_CString_HeaderFile
#include <Standard_CString.hxx>
#endif
class TCollection_AsciiString;
class TopoDS_Shape;


#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_Macro_HeaderFile
#include <Standard_Macro.hxx>
#endif

//! Writes a Shape to a File in VRML Format <br>
class SWDRAW_ToVRML  {

public:

    void* operator new(size_t,void* anAddress) 
      {
        return anAddress;
      }
    void* operator new(size_t size) 
      { 
        return Standard::Allocate(size); 
      }
    void  operator delete(void *anAddress) 
      { 
        if (anAddress) Standard::Free((Standard_Address&)anAddress); 
      }
 // Methods PUBLIC
 // 


Standard_EXPORT SWDRAW_ToVRML();


Standard_EXPORT   Standard_Real& EmissiveColorRed() ;


Standard_EXPORT   Standard_Real& EmissiveColorGreen() ;


Standard_EXPORT   Standard_Real& EmissiveColorBlue() ;


Standard_EXPORT   Standard_Real& DiffuseColorRed() ;


Standard_EXPORT   Standard_Real& DiffuseColorGreen() ;


Standard_EXPORT   Standard_Real& DiffuseColorBlue() ;


Standard_EXPORT   Standard_Real& Transparency() ;


Standard_EXPORT   Standard_Real& AmbientIntensity() ;


Standard_EXPORT   Standard_Real& SpecularColorRed() ;


Standard_EXPORT   Standard_Real& SpecularColorGreen() ;


Standard_EXPORT   Standard_Real& SpecularColorBlue() ;


Standard_EXPORT   Standard_Real& Shininess() ;


Standard_EXPORT   TCollection_AsciiString& Texture() ;


Standard_EXPORT   Standard_Real& CreaseAngle() ;


Standard_EXPORT   Standard_Real& Deflection() ;

//! conversion of a Shape into VRML format for 3d visualisation <br>
Standard_EXPORT   Standard_Boolean Write(const TopoDS_Shape& shape,const Standard_CString filename) const;





protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
Standard_Real myEmissiveColorRed;
Standard_Real myEmissiveColorGreen;
Standard_Real myEmissiveColorBlue;
Standard_Real myDiffuseColorRed;
Standard_Real myDiffuseColorGreen;
Standard_Real myDiffuseColorBlue;
Standard_Real myTransparency;
Standard_Real myAmbientIntensity;
Standard_Real mySpecularColorRed;
Standard_Real mySpecularColorGreen;
Standard_Real mySpecularColorBlue;
Standard_Real myShininess;
TCollection_AsciiString myTexture;
Standard_Real myCreaseAngle;
Standard_Real myDeflection;


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
