// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _Select3D_SensitivePoly_HeaderFile
#define _Select3D_SensitivePoly_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_Select3D_SensitivePoly_HeaderFile
#include <Handle_Select3D_SensitivePoly.hxx>
#endif

#ifndef _Standard_Address_HeaderFile
#include <Standard_Address.hxx>
#endif
#ifndef _Select3D_Box2d_HeaderFile
#include <Select3D_Box2d.hxx>
#endif
#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
#ifndef _Select3D_SensitiveEntity_HeaderFile
#include <Select3D_SensitiveEntity.hxx>
#endif
#ifndef _Handle_SelectBasics_EntityOwner_HeaderFile
#include <Handle_SelectBasics_EntityOwner.hxx>
#endif
#ifndef _Handle_TColgp_HArray1OfPnt_HeaderFile
#include <Handle_TColgp_HArray1OfPnt.hxx>
#endif
class SelectBasics_EntityOwner;
class TColgp_Array1OfPnt;
class TColgp_HArray1OfPnt;
class Select3D_Projector;
class SelectBasics_ListOfBox2d;
class TColgp_Array1OfPnt2d;


//! Sensitive Entity to make a face selectable. <br>
class Select3D_SensitivePoly : public Select3D_SensitiveEntity {

public:
 // Methods PUBLIC
 // 

//! projection of the sensitive primitive in order to <br>
//!          get 2D boxes for the Sort Algorithm <br>
Standard_EXPORT virtual  void Project(const Select3D_Projector& aProjector) ;

//! stores in <boxes> the 2D Boxes which represent the sensitive face <br>
//!          in the selection algorithm. <br>
Standard_EXPORT   void Areas(SelectBasics_ListOfBox2d& boxes) ;
//! Returns the 3D points of the array used at construction time. <br>
  void Points3D(Handle(TColgp_HArray1OfPnt)& theHArrayOfPnt) ;
//! Returns the 2D points of the array used at construction time. <br>
  void Points2D(TColgp_Array1OfPnt2d& theArrayOfPnt2d) ;


Standard_EXPORT   void Destroy() ;
~Select3D_SensitivePoly()
{
  Destroy();
}





 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 

//! Constructs a sensitive face object defined by the <br>
//! owner OwnerId, the array of points ThePoints, and <br>
//! the sensitivity type Sensitivity. <br>
//! The array of points is the outer polygon of the geometric face. <br>
Standard_EXPORT Select3D_SensitivePoly(const Handle(SelectBasics_EntityOwner)& OwnerId,const TColgp_Array1OfPnt& ThePoints);

//! Constructs a sensitive face object defined by the <br>
//! owner OwnerId, the array of points ThePoints, and <br>
//! the sensitivity type Sensitivity. <br>
//! The array of points is the outer polygon of the geometric face. <br>
Standard_EXPORT Select3D_SensitivePoly(const Handle(SelectBasics_EntityOwner)& OwnerId,const Handle(TColgp_HArray1OfPnt)& ThePoints);

//! Constructs the sensitive circle object defined by the <br>
//! owner OwnerId, the circle Circle, the Boolean <br>
//! FilledCircle and the number of points NbOfPoints. <br>
Standard_EXPORT Select3D_SensitivePoly(const Handle(SelectBasics_EntityOwner)& OwnerId,const Standard_Integer NbOfPoints = 6);


 // Fields PROTECTED
 //
Standard_Address mypolyg3d;
Standard_Address mypolyg2d;
Select3D_Box2d mybox2d;
Standard_Integer mynbpoints;


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //


};


#include <Select3D_SensitivePoly.lxx>



// other Inline functions and methods (like "C++: function call" methods)
//


#endif
