// File generated by CPPExt (Value)
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _SelectBasics_BasicTool_HeaderFile
#define _SelectBasics_BasicTool_HeaderFile

#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
#ifndef _Standard_Real_HeaderFile
#include <Standard_Real.hxx>
#endif
#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
class gp_Pnt2d;
class TColgp_Array1OfPnt2d;


#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_Macro_HeaderFile
#include <Standard_Macro.hxx>
#endif


class SelectBasics_BasicTool  {

public:

    void* operator new(size_t,void* anAddress) 
      {
        return anAddress;
      }
    void* operator new(size_t size) 
      { 
        return Standard::Allocate(size); 
      }
    void  operator delete(void *anAddress) 
      { 
        if (anAddress) Standard::Free((Standard_Address&)anAddress); 
      }
 // Methods PUBLIC
 // 

//! returns True if The Segment {P1P2} is <br>
//!          intersected by the segment {P3P4} <br>
Standard_EXPORT static  Standard_Boolean MatchSegments(const gp_Pnt2d& P1,const gp_Pnt2d& P2,const gp_Pnt2d& P3,const gp_Pnt2d& P4) ;


Standard_EXPORT static  Standard_Boolean AutoInter(const TColgp_Array1OfPnt2d& aPolyg2d) ;

//! package method used to find if a point <br>
//!          is close enough to a polygon of 2D points <br>
//!          to be Used by Primitives like curves or faces... <br>
//!          Rank gives the index of the touched <br>
//!          segment <br>
Standard_EXPORT static  Standard_Boolean MatchPolyg2d(const TColgp_Array1OfPnt2d& tabpoint,const Standard_Real X,const Standard_Real Y,const Standard_Real aTol,Standard_Real& DMin,Standard_Integer& Rank) ;





protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
