// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _ShapeExtend_MsgRegistrator_HeaderFile
#define _ShapeExtend_MsgRegistrator_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_ShapeExtend_MsgRegistrator_HeaderFile
#include <Handle_ShapeExtend_MsgRegistrator.hxx>
#endif

#ifndef _ShapeExtend_DataMapOfTransientListOfMsg_HeaderFile
#include <ShapeExtend_DataMapOfTransientListOfMsg.hxx>
#endif
#ifndef _ShapeExtend_DataMapOfShapeListOfMsg_HeaderFile
#include <ShapeExtend_DataMapOfShapeListOfMsg.hxx>
#endif
#ifndef _ShapeExtend_BasicMsgRegistrator_HeaderFile
#include <ShapeExtend_BasicMsgRegistrator.hxx>
#endif
#ifndef _Handle_Standard_Transient_HeaderFile
#include <Handle_Standard_Transient.hxx>
#endif
#ifndef _Message_Gravity_HeaderFile
#include <Message_Gravity.hxx>
#endif
class Standard_Transient;
class Message_Msg;
class TopoDS_Shape;
class ShapeExtend_DataMapOfTransientListOfMsg;
class ShapeExtend_DataMapOfShapeListOfMsg;


//! Attaches messages to the objects (generic Transient or shape). <br>
//!          The objects of this class are transmitted to the Shape Healing <br>
//!          algorithms so that they could collect messages occurred during <br>
//!          processing. <br>
class ShapeExtend_MsgRegistrator : public ShapeExtend_BasicMsgRegistrator {

public:
 // Methods PUBLIC
 // 

//! Creates an object. <br>
Standard_EXPORT ShapeExtend_MsgRegistrator();

//! Sends a message to be attached to the object. <br>
//!          If the object is in the map then the message is added to the <br>
//!          list, otherwise the object is firstly added to the map. <br>
Standard_EXPORT virtual  void Send(const Handle(Standard_Transient)& object,const Message_Msg& message,const Message_Gravity gravity) ;

//! Sends a message to be attached to the shape. <br>
//!          If the shape is in the map then the message is added to the <br>
//!          list, otherwise the shape is firstly added to the map. <br>
Standard_EXPORT virtual  void Send(const TopoDS_Shape& shape,const Message_Msg& message,const Message_Gravity gravity) ;
//! Returns a Map of objects and message list <br>
 const ShapeExtend_DataMapOfTransientListOfMsg& MapTransient() const;
//! Returns a Map of shapes and message list <br>
 const ShapeExtend_DataMapOfShapeListOfMsg& MapShape() const;
//Standard_EXPORT ~ShapeExtend_MsgRegistrator();




 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
ShapeExtend_DataMapOfTransientListOfMsg myMapTransient;
ShapeExtend_DataMapOfShapeListOfMsg myMapShape;


};


#include <ShapeExtend_MsgRegistrator.lxx>



// other Inline functions and methods (like "C++: function call" methods)
//


#endif
