// File generated by CPPExt (Value)
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _ShapeFix_SplitTool_HeaderFile
#define _ShapeFix_SplitTool_HeaderFile

#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
#ifndef _Standard_Real_HeaderFile
#include <Standard_Real.hxx>
#endif
#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
#ifndef _Handle_ShapeBuild_ReShape_HeaderFile
#include <Handle_ShapeBuild_ReShape.hxx>
#endif
class TopoDS_Edge;
class TopoDS_Vertex;
class TopoDS_Face;
class TopTools_SequenceOfShape;
class ShapeBuild_ReShape;


#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_Macro_HeaderFile
#include <Standard_Macro.hxx>
#endif

//! Tool for splitting and cutting edges; includes methods <br>
//!          used in OverlappingTool and IntersectionTool <br>
class ShapeFix_SplitTool  {

public:

    void* operator new(size_t,void* anAddress) 
      {
        return anAddress;
      }
    void* operator new(size_t size) 
      { 
        return Standard::Allocate(size); 
      }
    void  operator delete(void *anAddress) 
      { 
        if (anAddress) Standard::Free((Standard_Address&)anAddress); 
      }
 // Methods PUBLIC
 // 

//! Empty constructor <br>
Standard_EXPORT ShapeFix_SplitTool();

//! Split edge on two new edges using new vertex "vert" <br>
//!          and "param" - parameter for splitting <br>
//!          The "face" is necessary for pcurves and using TransferParameterProj <br>
Standard_EXPORT   Standard_Boolean SplitEdge(const TopoDS_Edge& edge,const Standard_Real param,const TopoDS_Vertex& vert,const TopoDS_Face& face,TopoDS_Edge& newE1,TopoDS_Edge& newE2,const Standard_Real tol3d,const Standard_Real tol2d) const;

//! Split edge on two new edges using new vertex "vert" <br>
//!          and "param1" and "param2" - parameter for splitting and cutting <br>
//!          The "face" is necessary for pcurves and using TransferParameterProj <br>
Standard_EXPORT   Standard_Boolean SplitEdge(const TopoDS_Edge& edge,const Standard_Real param1,const Standard_Real param2,const TopoDS_Vertex& vert,const TopoDS_Face& face,TopoDS_Edge& newE1,TopoDS_Edge& newE2,const Standard_Real tol3d,const Standard_Real tol2d) const;

//! Cut edge by parameters pend and cut <br>
Standard_EXPORT   Standard_Boolean CutEdge(const TopoDS_Edge& edge,const Standard_Real pend,const Standard_Real cut,const TopoDS_Face& face,Standard_Boolean& iscutline) const;

//! Split edge on two new edges using two new vertex V1 and V2 <br>
//!          and two parameters for splitting - fp and lp correspondingly <br>
//!          The "face" is necessary for pcurves and using TransferParameterProj <br>
//!          aNum - number of edge in SeqE which corresponding to [fp,lp] <br>
Standard_EXPORT   Standard_Boolean SplitEdge(const TopoDS_Edge& edge,const Standard_Real fp,const TopoDS_Vertex& V1,const Standard_Real lp,const TopoDS_Vertex& V2,const TopoDS_Face& face,TopTools_SequenceOfShape& SeqE,Standard_Integer& aNum,const Handle(ShapeBuild_ReShape)& context,const Standard_Real tol3d,const Standard_Real tol2d) const;





protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
