// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _ShapeUpgrade_EdgeDivide_HeaderFile
#define _ShapeUpgrade_EdgeDivide_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_ShapeUpgrade_EdgeDivide_HeaderFile
#include <Handle_ShapeUpgrade_EdgeDivide.hxx>
#endif

#ifndef _TopoDS_Face_HeaderFile
#include <TopoDS_Face.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
#ifndef _Handle_TColStd_HSequenceOfReal_HeaderFile
#include <Handle_TColStd_HSequenceOfReal.hxx>
#endif
#ifndef _Handle_ShapeUpgrade_SplitCurve3d_HeaderFile
#include <Handle_ShapeUpgrade_SplitCurve3d.hxx>
#endif
#ifndef _Handle_ShapeUpgrade_SplitCurve2d_HeaderFile
#include <Handle_ShapeUpgrade_SplitCurve2d.hxx>
#endif
#ifndef _ShapeUpgrade_Tool_HeaderFile
#include <ShapeUpgrade_Tool.hxx>
#endif
class TColStd_HSequenceOfReal;
class ShapeUpgrade_SplitCurve3d;
class ShapeUpgrade_SplitCurve2d;
class TopoDS_Face;
class TopoDS_Edge;



class ShapeUpgrade_EdgeDivide : public ShapeUpgrade_Tool {

public:
 // Methods PUBLIC
 // 

//! Empty constructor <br>
Standard_EXPORT ShapeUpgrade_EdgeDivide();


Standard_EXPORT   void Clear() ;
//! Sets supporting surface by face <br>
  void SetFace(const TopoDS_Face& F) ;


Standard_EXPORT virtual  Standard_Boolean Compute(const TopoDS_Edge& E) ;

  Standard_Boolean HasCurve2d() const;

  Standard_Boolean HasCurve3d() const;

  Handle_TColStd_HSequenceOfReal Knots2d() const;

  Handle_TColStd_HSequenceOfReal Knots3d() const;

//! Sets the tool for splitting pcurves. <br>
Standard_EXPORT   void SetSplitCurve2dTool(const Handle(ShapeUpgrade_SplitCurve2d)& splitCurve2dTool) ;

//! Sets the tool for splitting 3D curves. <br>
Standard_EXPORT   void SetSplitCurve3dTool(const Handle(ShapeUpgrade_SplitCurve3d)& splitCurve3dTool) ;

//! Returns the tool for splitting pcurves. <br>
Standard_EXPORT virtual  Handle_ShapeUpgrade_SplitCurve2d GetSplitCurve2dTool() const;

//! Returns the tool for splitting 3D curves. <br>
Standard_EXPORT virtual  Handle_ShapeUpgrade_SplitCurve3d GetSplitCurve3dTool() const;
//Standard_EXPORT ~ShapeUpgrade_EdgeDivide();




 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //
TopoDS_Face myFace;
Standard_Boolean myHasCurve2d;
Standard_Boolean myHasCurve3d;
Handle_TColStd_HSequenceOfReal myKnots2d;
Handle_TColStd_HSequenceOfReal myKnots3d;


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
Handle_ShapeUpgrade_SplitCurve3d mySplitCurve3dTool;
Handle_ShapeUpgrade_SplitCurve2d mySplitCurve2dTool;


};


#include <ShapeUpgrade_EdgeDivide.lxx>



// other Inline functions and methods (like "C++: function call" methods)
//


#endif
