// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _ShapeUpgrade_Tool_HeaderFile
#define _ShapeUpgrade_Tool_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_ShapeUpgrade_Tool_HeaderFile
#include <Handle_ShapeUpgrade_Tool.hxx>
#endif

#ifndef _Handle_ShapeBuild_ReShape_HeaderFile
#include <Handle_ShapeBuild_ReShape.hxx>
#endif
#ifndef _Standard_Real_HeaderFile
#include <Standard_Real.hxx>
#endif
#ifndef _MMgt_TShared_HeaderFile
#include <MMgt_TShared.hxx>
#endif
class ShapeBuild_ReShape;


//! Tool is a root class for splitting classes <br>
//!          Provides context for recording changes, basic <br>
//!          precision value and limit (minimal and maximal) <br>
//!          values for tolerances <br>
class ShapeUpgrade_Tool : public MMgt_TShared {

public:
 // Methods PUBLIC
 // 

//! Empty constructor <br>
Standard_EXPORT ShapeUpgrade_Tool();

//! Copy all fields from another Root object <br>
Standard_EXPORT   void Set(const Handle(ShapeUpgrade_Tool)& tool) ;
//! Sets context <br>
  void SetContext(const Handle(ShapeBuild_ReShape)& context) ;
//! Returns context <br>
  Handle_ShapeBuild_ReShape Context() const;
//! Sets basic precision value <br>
  void SetPrecision(const Standard_Real preci) ;
//! Returns basic precision value <br>
  Standard_Real Precision() const;
//! Sets minimal allowed tolerance <br>
  void SetMinTolerance(const Standard_Real mintol) ;
//! Returns minimal allowed tolerance <br>
  Standard_Real MinTolerance() const;
//! Sets maximal allowed tolerance <br>
  void SetMaxTolerance(const Standard_Real maxtol) ;
//! Returns maximal allowed tolerance <br>
  Standard_Real MaxTolerance() const;
//! Returns tolerance limited by [myMinTol,myMaxTol] <br>
  Standard_Real LimitTolerance(const Standard_Real toler) const;
//Standard_EXPORT ~ShapeUpgrade_Tool();




 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
Handle_ShapeBuild_ReShape myContext;
Standard_Real myPrecision;
Standard_Real myMinTol;
Standard_Real myMaxTol;


};


#include <ShapeUpgrade_Tool.lxx>



// other Inline functions and methods (like "C++: function call" methods)
//


#endif
