#ifndef _Storage_Schema_HeaderFile_
#include <Storage_Schema.hxx>
#endif
#ifndef _Storage_BaseDriver_HeaderFile_
#include <Storage_BaseDriver.hxx>
#endif
#ifndef _Storage_CallBack_HeaderFile_
#include <Storage_CallBack.hxx>
#endif
#ifndef _Storage_Macros_HeaderFile_
#include <Storage_Macros.hxx>
#endif
class Handle_PPrsStd_AISPresentation;
class Handle_PPrsStd_AISPresentation_1;
class Handle_PFunction_Function;
class Handle_PDF_Attribute;
class Handle_Standard_Persistent;
class Standard_Storable;
class Handle_PCollection_HExtendedString;
class Standard_GUID;
class DBC_VArrayOfExtCharacter;
class Handle_PCollection_HAsciiString;
class DBC_VArrayOfCharacter;
// File generated by Schema (Schema)
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _StdSchema_HeaderFile
#define _StdSchema_HeaderFile

#ifndef _Standard_Macro_HeaderFile
#include <Standard_Macro.hxx>
#endif
#ifndef _Storage_Macros_HeaderFile
#include <Storage_Macros.hxx>
#endif
#ifndef _Storage_stCONSTclCOM_HeaderFile
#include <Storage_stCONSTclCOM.hxx>
#endif
#ifndef _Handle_Storage_Schema_HeaderFile
#include <Handle_Storage_Schema.hxx>
#endif

class Handle_Standard_Type;
Standard_EXPORT Handle_Standard_Type& StdSchema_Type_();
class Standard_Transient;
class Handle(Storage_Schema);

class StdSchema;

class Handle(StdSchema) : public Handle(Storage_Schema) {
  public:
    Handle(StdSchema)():Handle(Storage_Schema)() {} 
    Handle(StdSchema)(const Handle(StdSchema)& aHandle) : Handle(Storage_Schema)(aHandle) 
     {
     }

    Handle(StdSchema)(const StdSchema* anItem) : Handle(Storage_Schema)((Storage_Schema *)anItem) 
     {
     }

    Handle(StdSchema)& operator=(const Handle(StdSchema)& aHandle)
     {
      Assign(aHandle.Access());
      return *this;
     }

    Handle(StdSchema)& operator=(const StdSchema* anItem)
     {
      Assign((Standard_Transient *)anItem);
      return *this;
     }

    StdSchema* operator->() 
     {
      return (StdSchema *)ControlAccess();
     }

    StdSchema* operator->() const 
     {
      return (StdSchema *)ControlAccess();
     }

   ~Handle(StdSchema)(){};

   static const Handle(StdSchema) DownCast(const Handle(Storage_Schema)& AnObject) 
   {
     Handle(StdSchema) _anOtherObject;

     if (!AnObject.IsNull()) {
        if (AnObject->IsKind(STANDARD_TYPE(StdSchema))) {
          _anOtherObject = Handle(StdSchema)((Handle(StdSchema)&)AnObject);
        }
     }

     return _anOtherObject ;
   }
};

#ifndef _Storage_CallBack_HeaderFile_
#include <Storage_CallBack.hxx>
#endif
#ifndef _Storage_BaseDriver_HeaderFile_
#include <Storage_BaseDriver.hxx>
#endif

class StdSchema : public Storage_Schema {
public:

  Storage_DECLARE_SCHEMA_METHODS(StdSchema)

  Standard_Boolean IsKind(const Handle(Standard_Type)& AType) const 
  { 
    return (STANDARD_TYPE(StdSchema) == AType || Storage_Schema::IsKind(AType)); 
  }

  const Handle(Standard_Type)& DynamicType() const 
  { 
    return STANDARD_TYPE(StdSchema) ; 
  }
};

#endif
