// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _StdSelect_EdgeFilter_HeaderFile
#define _StdSelect_EdgeFilter_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_StdSelect_EdgeFilter_HeaderFile
#include <Handle_StdSelect_EdgeFilter.hxx>
#endif

#ifndef _StdSelect_TypeOfEdge_HeaderFile
#include <StdSelect_TypeOfEdge.hxx>
#endif
#ifndef _SelectMgr_Filter_HeaderFile
#include <SelectMgr_Filter.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
#ifndef _Handle_SelectMgr_EntityOwner_HeaderFile
#include <Handle_SelectMgr_EntityOwner.hxx>
#endif
#ifndef _TopAbs_ShapeEnum_HeaderFile
#include <TopAbs_ShapeEnum.hxx>
#endif
class SelectMgr_EntityOwner;


//! A framework to define a filter to select a specific type of edge. <br>
//! The types available include: <br>
//! -   any edge <br>
//! -   a linear edge <br>
//! -   a circular edge. <br>
class StdSelect_EdgeFilter : public SelectMgr_Filter {

public:
 // Methods PUBLIC
 // 

//! Constructs an edge filter object defined by the type of edge Edge. <br>
Standard_EXPORT StdSelect_EdgeFilter(const StdSelect_TypeOfEdge Edge);

//! Sets the type of edge aNewType. aNewType is to be highlighted in selection. <br>
Standard_EXPORT   void SetType(const StdSelect_TypeOfEdge aNewType) ;

//! Returns the type of edge to be highlighted in selection. <br>
Standard_EXPORT   StdSelect_TypeOfEdge Type() const;


Standard_EXPORT virtual  Standard_Boolean IsOk(const Handle(SelectMgr_EntityOwner)& anobj) const;


Standard_EXPORT virtual  Standard_Boolean ActsOn(const TopAbs_ShapeEnum aStandardMode) const;
//Standard_EXPORT ~StdSelect_EdgeFilter();




 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
StdSelect_TypeOfEdge mytype;


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
