// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _StdSelect_ShapeTypeFilter_HeaderFile
#define _StdSelect_ShapeTypeFilter_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_StdSelect_ShapeTypeFilter_HeaderFile
#include <Handle_StdSelect_ShapeTypeFilter.hxx>
#endif

#ifndef _TopAbs_ShapeEnum_HeaderFile
#include <TopAbs_ShapeEnum.hxx>
#endif
#ifndef _SelectMgr_Filter_HeaderFile
#include <SelectMgr_Filter.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
#ifndef _Handle_SelectMgr_EntityOwner_HeaderFile
#include <Handle_SelectMgr_EntityOwner.hxx>
#endif
class SelectMgr_EntityOwner;


//! A filter framework which allows you to define a filter <br>
//! for a specific shape type. The types available include: <br>
//! -   compound <br>
//! -   compsolid <br>
//! -   solid <br>
//! -   shell <br>
//! -   face <br>
//! -   wire <br>
//! -   edge <br>
//! -   vertex. <br>
class StdSelect_ShapeTypeFilter : public SelectMgr_Filter {

public:
 // Methods PUBLIC
 // 

//! Constructs a filter object defined by the shape type aType. <br>
Standard_EXPORT StdSelect_ShapeTypeFilter(const TopAbs_ShapeEnum aType);


Standard_EXPORT virtual  Standard_Boolean IsOk(const Handle(SelectMgr_EntityOwner)& anobj) const;
//! Returns the type of shape selected by the filter. <br>
  TopAbs_ShapeEnum Type() const;


Standard_EXPORT virtual  Standard_Boolean ActsOn(const TopAbs_ShapeEnum aStandardMode) const;
//Standard_EXPORT ~StdSelect_ShapeTypeFilter();




 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
TopAbs_ShapeEnum myType;


};


#include <StdSelect_ShapeTypeFilter.lxx>



// other Inline functions and methods (like "C++: function call" methods)
//


#endif
