// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _StdSelect_ViewerSelector2d_HeaderFile
#define _StdSelect_ViewerSelector2d_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_StdSelect_ViewerSelector2d_HeaderFile
#include <Handle_StdSelect_ViewerSelector2d.hxx>
#endif

#ifndef _Handle_Select2D_Projector_HeaderFile
#include <Handle_Select2D_Projector.hxx>
#endif
#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
#ifndef _Handle_Graphic2d_GraphicObject_HeaderFile
#include <Handle_Graphic2d_GraphicObject.hxx>
#endif
#ifndef _SelectMgr_ViewerSelector_HeaderFile
#include <SelectMgr_ViewerSelector.hxx>
#endif
#ifndef _Handle_SelectMgr_Selection_HeaderFile
#include <Handle_SelectMgr_Selection.hxx>
#endif
#ifndef _Handle_V2d_View_HeaderFile
#include <Handle_V2d_View.hxx>
#endif
class Select2D_Projector;
class Graphic2d_GraphicObject;
class SelectMgr_Selection;
class V2d_View;


//! A viewer selection framework. <br>
//! The objects defined in this framework can be passed to a selection manager. <br>
class StdSelect_ViewerSelector2d : public SelectMgr_ViewerSelector {

public:
 // Methods PUBLIC
 // 

//! Constructs an empty viewer selection framework. <br>
Standard_EXPORT StdSelect_ViewerSelector2d();

//! Constructs the viewer selection framework defined by <br>
//! the projector aProjector. <br>
Standard_EXPORT StdSelect_ViewerSelector2d(const Handle(Select2D_Projector)& aProjector);

//! Sets a pixel tolerance for the selection. <br>
//!         will be converted for picking in a view. <br>
Standard_EXPORT   void Set(const Standard_Integer aSensitivity) ;

//! Sets the new projector aProjector. <br>
Standard_EXPORT   void Set(const Handle(Select2D_Projector)& aProjector) ;


Standard_EXPORT   void Convert(const Handle(SelectMgr_Selection)& aSelection) ;

//! Returns the pixel coordinates of the mouse Xpix, Ypix <br>
//! in the view aView. <br>
Standard_EXPORT   void Pick(const Standard_Integer XPix,const Standard_Integer YPix,const Handle(V2d_View)& aView) ;

//! Returns the minimum and maximum pixel coordinates <br>
//! XPMin, YPMin and XPMax, YPMax defining a 2D area in the view aView. <br>
Standard_EXPORT   void Pick(const Standard_Integer XPMin,const Standard_Integer YPMin,const Standard_Integer XPMax,const Standard_Integer YPMax,const Handle(V2d_View)& aView) ;
//! Returns the projector which defines this framework. <br>
  Handle_Select2D_Projector Projector() const;

//! Displays the active areas in the given view; <br>
Standard_EXPORT   void DisplayAreas(const Handle(V2d_View)& aView) ;

//! Clear the displayed sensitive areas from this framework.. <br>
Standard_EXPORT   void ClearAreas() ;
//Standard_EXPORT ~StdSelect_ViewerSelector2d();




 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
Handle_Select2D_Projector myprj;
Standard_Integer mypixtol;
Handle_Graphic2d_GraphicObject mygo;


};


#include <StdSelect_ViewerSelector2d.lxx>



// other Inline functions and methods (like "C++: function call" methods)
//


#endif
