// File generated by CPPExt (Value)
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _StepBasic_RoleSelect_HeaderFile
#define _StepBasic_RoleSelect_HeaderFile

#ifndef _StepData_SelectType_HeaderFile
#include <StepData_SelectType.hxx>
#endif
#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
#ifndef _Handle_Standard_Transient_HeaderFile
#include <Handle_Standard_Transient.hxx>
#endif
#ifndef _Handle_StepBasic_ActionAssignment_HeaderFile
#include <Handle_StepBasic_ActionAssignment.hxx>
#endif
#ifndef _Handle_StepBasic_ActionRequestAssignment_HeaderFile
#include <Handle_StepBasic_ActionRequestAssignment.hxx>
#endif
#ifndef _Handle_StepBasic_ApprovalAssignment_HeaderFile
#include <Handle_StepBasic_ApprovalAssignment.hxx>
#endif
#ifndef _Handle_StepBasic_ApprovalDateTime_HeaderFile
#include <Handle_StepBasic_ApprovalDateTime.hxx>
#endif
#ifndef _Handle_StepBasic_CertificationAssignment_HeaderFile
#include <Handle_StepBasic_CertificationAssignment.hxx>
#endif
#ifndef _Handle_StepBasic_ContractAssignment_HeaderFile
#include <Handle_StepBasic_ContractAssignment.hxx>
#endif
#ifndef _Handle_StepBasic_DocumentReference_HeaderFile
#include <Handle_StepBasic_DocumentReference.hxx>
#endif
#ifndef _Handle_StepBasic_EffectivityAssignment_HeaderFile
#include <Handle_StepBasic_EffectivityAssignment.hxx>
#endif
#ifndef _Handle_StepBasic_GroupAssignment_HeaderFile
#include <Handle_StepBasic_GroupAssignment.hxx>
#endif
#ifndef _Handle_StepBasic_NameAssignment_HeaderFile
#include <Handle_StepBasic_NameAssignment.hxx>
#endif
#ifndef _Handle_StepBasic_SecurityClassificationAssignment_HeaderFile
#include <Handle_StepBasic_SecurityClassificationAssignment.hxx>
#endif
class Standard_Transient;
class StepBasic_ActionAssignment;
class StepBasic_ActionRequestAssignment;
class StepBasic_ApprovalAssignment;
class StepBasic_ApprovalDateTime;
class StepBasic_CertificationAssignment;
class StepBasic_ContractAssignment;
class StepBasic_DocumentReference;
class StepBasic_EffectivityAssignment;
class StepBasic_GroupAssignment;
class StepBasic_NameAssignment;
class StepBasic_SecurityClassificationAssignment;


#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_Macro_HeaderFile
#include <Standard_Macro.hxx>
#endif

//! Representation of STEP SELECT type RoleSelect <br>
class StepBasic_RoleSelect  : public StepData_SelectType {

public:

    void* operator new(size_t,void* anAddress) 
      {
        return anAddress;
      }
    void* operator new(size_t size) 
      { 
        return Standard::Allocate(size); 
      }
    void  operator delete(void *anAddress) 
      { 
        if (anAddress) Standard::Free((Standard_Address&)anAddress); 
      }
 // Methods PUBLIC
 // 

//! Empty constructor <br>
Standard_EXPORT StepBasic_RoleSelect();

//! Recognizes a kind of RoleSelect select type <br>
//!          1 -> ActionAssignment from StepBasic <br>
//!          2 -> ActionRequestAssignment from StepBasic <br>
//!          3 -> ApprovalAssignment from StepBasic <br>
//!          4 -> ApprovalDateTime from StepBasic <br>
//!          5 -> CertificationAssignment from StepBasic <br>
//!          6 -> ContractAssignment from StepBasic <br>
//!          7 -> DocumentReference from StepBasic <br>
//!          8 -> EffectivityAssignment from StepBasic <br>
//!          9 -> GroupAssignment from StepBasic <br>
//!          10 -> NameAssignment from StepBasic <br>
//!          11 -> SecurityClassificationAssignment from StepBasic <br>
//!          0 else <br>
Standard_EXPORT   Standard_Integer CaseNum(const Handle(Standard_Transient)& ent) const;

//! Returns Value as ActionAssignment (or Null if another type) <br>
Standard_EXPORT   Handle_StepBasic_ActionAssignment ActionAssignment() const;

//! Returns Value as ActionRequestAssignment (or Null if another type) <br>
Standard_EXPORT   Handle_StepBasic_ActionRequestAssignment ActionRequestAssignment() const;

//! Returns Value as ApprovalAssignment (or Null if another type) <br>
Standard_EXPORT   Handle_StepBasic_ApprovalAssignment ApprovalAssignment() const;

//! Returns Value as ApprovalDateTime (or Null if another type) <br>
Standard_EXPORT   Handle_StepBasic_ApprovalDateTime ApprovalDateTime() const;

//! Returns Value as CertificationAssignment (or Null if another type) <br>
Standard_EXPORT   Handle_StepBasic_CertificationAssignment CertificationAssignment() const;

//! Returns Value as ContractAssignment (or Null if another type) <br>
Standard_EXPORT   Handle_StepBasic_ContractAssignment ContractAssignment() const;

//! Returns Value as DocumentReference (or Null if another type) <br>
Standard_EXPORT   Handle_StepBasic_DocumentReference DocumentReference() const;

//! Returns Value as EffectivityAssignment (or Null if another type) <br>
Standard_EXPORT   Handle_StepBasic_EffectivityAssignment EffectivityAssignment() const;

//! Returns Value as GroupAssignment (or Null if another type) <br>
Standard_EXPORT   Handle_StepBasic_GroupAssignment GroupAssignment() const;

//! Returns Value as NameAssignment (or Null if another type) <br>
Standard_EXPORT   Handle_StepBasic_NameAssignment NameAssignment() const;

//! Returns Value as SecurityClassificationAssignment (or Null if another type) <br>
Standard_EXPORT   Handle_StepBasic_SecurityClassificationAssignment SecurityClassificationAssignment() const;





protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
