// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _StepData_DescrProtocol_HeaderFile
#define _StepData_DescrProtocol_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_StepData_DescrProtocol_HeaderFile
#include <Handle_StepData_DescrProtocol.hxx>
#endif

#ifndef _TCollection_AsciiString_HeaderFile
#include <TCollection_AsciiString.hxx>
#endif
#ifndef _StepData_FileProtocol_HeaderFile
#include <StepData_FileProtocol.hxx>
#endif
#ifndef _Standard_CString_HeaderFile
#include <Standard_CString.hxx>
#endif


//! A DescrProtocol is a protocol dynamically (at execution time) <br>
//!           defined with : <br>
//!           - a list of resources (inherits FileProtocol) <br>
//!           - a list of entity descriptions <br>
//!           i.e. it can be defined with only C++ writing to initialize it <br>
//!           Its initialization must : <br>
//!           - set its schema name <br>
//!           - define its resources (which can also be other DescrProtocol) <br>
//!           - define its entity descriptions <br>
//!           - record it in the system by calling RecordLib <br>
class StepData_DescrProtocol : public StepData_FileProtocol {

public:
 // Methods PUBLIC
 // 


Standard_EXPORT StepData_DescrProtocol();

//! Defines a specific Schema Name for this Protocol <br>
Standard_EXPORT   void SetSchemaName(const Standard_CString name) ;

//! Records this Protocol in the service libraries, with a <br>
//!           DescrGeneral and a DescrReadWrite <br>
//!           Does nothing if the Protocol brings no proper description <br>
Standard_EXPORT   void LibRecord() const;

//! Returns the Schema Name attached to each class of Protocol <br>
//!           here, returns the SchemaName set by SetSchemaName <br>
//! was C++ : return const <br>
Standard_EXPORT virtual  Standard_CString SchemaName() const;
//Standard_EXPORT ~StepData_DescrProtocol();




 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
TCollection_AsciiString thename;


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
