// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _StepSelect_StepType_HeaderFile
#define _StepSelect_StepType_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_StepSelect_StepType_HeaderFile
#include <Handle_StepSelect_StepType.hxx>
#endif

#ifndef _Handle_StepData_Protocol_HeaderFile
#include <Handle_StepData_Protocol.hxx>
#endif
#ifndef _StepData_WriterLib_HeaderFile
#include <StepData_WriterLib.hxx>
#endif
#ifndef _IFSelect_Signature_HeaderFile
#include <IFSelect_Signature.hxx>
#endif
#ifndef _Handle_Interface_Protocol_HeaderFile
#include <Handle_Interface_Protocol.hxx>
#endif
#ifndef _Standard_CString_HeaderFile
#include <Standard_CString.hxx>
#endif
#ifndef _Handle_Standard_Transient_HeaderFile
#include <Handle_Standard_Transient.hxx>
#endif
#ifndef _Handle_Interface_InterfaceModel_HeaderFile
#include <Handle_Interface_InterfaceModel.hxx>
#endif
class StepData_Protocol;
class Interface_InterfaceError;
class Interface_Protocol;
class Standard_Transient;
class Interface_InterfaceModel;


//! StepType is a Signature specific to Step definitions : it <br>
//!           considers the type as defined in STEP Schemas, the same which <br>
//!           is used in files. <br>
//!           For a Complex Type, if its definition is known, StepType <br>
//!           produces the list of basic types, separated by commas, the <br>
//!           whole between brackets : "(TYPE1,TYPE2..)". <br>
//!           If its precise definition is not known (simply it is known as <br>
//!           Complex, it can be recognised, but the list is produced at <br>
//!           Write time only), StepType produces : "(..COMPLEX TYPE..)" <br>
class StepSelect_StepType : public IFSelect_Signature {

public:
 // Methods PUBLIC
 // 

//! Creates a Signature for Step Type. Protocol is undefined here, <br>
//!           hence no Signature may yet be produced. The StepType signature <br>
//!           requires a Protocol before working <br>
Standard_EXPORT StepSelect_StepType();

//! Sets the StepType signature to work with a Protocol : this <br>
//!           initialises the library <br>
Standard_EXPORT   void SetProtocol(const Handle(Interface_Protocol)& proto) ;

//! Returns the Step Type defined from the Protocol (see above). <br>
//!           If <ent> is not recognised, produces "..NOT FROM SCHEMA <name>.." <br>
Standard_EXPORT   Standard_CString Value(const Handle(Standard_Transient)& ent,const Handle(Interface_InterfaceModel)& model) const;
//Standard_EXPORT ~StepSelect_StepType();




 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //
StepData_WriterLib thelib;


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
Handle_StepData_Protocol theproto;


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
