// File generated by CPPExt (Value)
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _StepToTopoDS_TranslateCompositeCurve_HeaderFile
#define _StepToTopoDS_TranslateCompositeCurve_HeaderFile

#ifndef _TopoDS_Wire_HeaderFile
#include <TopoDS_Wire.hxx>
#endif
#ifndef _StepToTopoDS_Root_HeaderFile
#include <StepToTopoDS_Root.hxx>
#endif
#ifndef _Handle_StepGeom_CompositeCurve_HeaderFile
#include <Handle_StepGeom_CompositeCurve.hxx>
#endif
#ifndef _Handle_Transfer_TransientProcess_HeaderFile
#include <Handle_Transfer_TransientProcess.hxx>
#endif
#ifndef _Handle_StepGeom_Surface_HeaderFile
#include <Handle_StepGeom_Surface.hxx>
#endif
#ifndef _Handle_Geom_Surface_HeaderFile
#include <Handle_Geom_Surface.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
class StepGeom_CompositeCurve;
class Transfer_TransientProcess;
class StepGeom_Surface;
class Geom_Surface;
class TopoDS_Wire;


#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_Macro_HeaderFile
#include <Standard_Macro.hxx>
#endif

//! Translate STEP entity composite_curve to TopoDS_Wire <br>
//!          If surface is given, the curve is assumed to lie on that <br>
//!          surface and in case if any segment of it is a <br>
//!          curve_on_surface, the pcurve for that segment will be taken. <br>
//!          Note: a segment of composite_curve may be itself <br>
//!                composite_curve. Only one-level protection against <br>
//!                cyclic references is implemented. <br>
class StepToTopoDS_TranslateCompositeCurve  : public StepToTopoDS_Root {

public:

    void* operator new(size_t,void* anAddress) 
      {
        return anAddress;
      }
    void* operator new(size_t size) 
      { 
        return Standard::Allocate(size); 
      }
    void  operator delete(void *anAddress) 
      { 
        if (anAddress) Standard::Free((Standard_Address&)anAddress); 
      }
 // Methods PUBLIC
 // 

//! Empty constructor <br>
Standard_EXPORT StepToTopoDS_TranslateCompositeCurve();

//! Translates standalone composite_curve <br>
Standard_EXPORT StepToTopoDS_TranslateCompositeCurve(const Handle(StepGeom_CompositeCurve)& CC,const Handle(Transfer_TransientProcess)& TP);

//! Translates composite_curve lying on surface <br>
Standard_EXPORT StepToTopoDS_TranslateCompositeCurve(const Handle(StepGeom_CompositeCurve)& CC,const Handle(Transfer_TransientProcess)& TP,const Handle(StepGeom_Surface)& S,const Handle(Geom_Surface)& Surf);

//! Translates standalone composite_curve <br>
Standard_EXPORT   Standard_Boolean Init(const Handle(StepGeom_CompositeCurve)& CC,const Handle(Transfer_TransientProcess)& TP) ;

//! Translates composite_curve lying on surface <br>
Standard_EXPORT   Standard_Boolean Init(const Handle(StepGeom_CompositeCurve)& CC,const Handle(Transfer_TransientProcess)& TP,const Handle(StepGeom_Surface)& S,const Handle(Geom_Surface)& Surf) ;

//! Returns result of last translation or null wire if failed. <br>
Standard_EXPORT  const TopoDS_Wire& Value() const;





protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
TopoDS_Wire myWire;


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
