// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _StlMesh_MeshTriangle_HeaderFile
#define _StlMesh_MeshTriangle_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_StlMesh_MeshTriangle_HeaderFile
#include <Handle_StlMesh_MeshTriangle.hxx>
#endif

#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
#ifndef _Standard_Real_HeaderFile
#include <Standard_Real.hxx>
#endif
#ifndef _MMgt_TShared_HeaderFile
#include <MMgt_TShared.hxx>
#endif
class Standard_NegativeValue;


//! A  mesh triangle is defined with <br>
//!          three geometric vertices and an orientation <br>
//! <br>
class StlMesh_MeshTriangle : public MMgt_TShared {

public:
 // Methods PUBLIC
 // 

//! empty constructor <br>
Standard_EXPORT StlMesh_MeshTriangle();

//! create a triangle defined with the indexes of its three vertices <br>
//!          and its orientation <br>//! Raised if V1, V2 or V3 is lower than zero <br>
Standard_EXPORT StlMesh_MeshTriangle(const Standard_Integer V1,const Standard_Integer V2,const Standard_Integer V3,const Standard_Real Xn,const Standard_Real Yn,const Standard_Real Zn);

//! get indexes of the three vertices (V1,V2,V3) and the orientation <br>
Standard_EXPORT   void GetVertexAndOrientation(Standard_Integer& V1,Standard_Integer& V2,Standard_Integer& V3,Standard_Real& Xn,Standard_Real& Yn,Standard_Real& Zn) const;

//! set indexes of the three vertices (V1,V2,V3) and the orientation <br>//! Raised if V1, V2 or V3 is lower than zero <br>
Standard_EXPORT   void SetVertexAndOrientation(const Standard_Integer V1,const Standard_Integer V2,const Standard_Integer V3,const Standard_Real Xn,const Standard_Real Yn,const Standard_Real Zn) ;

//! get indexes of the three vertices (V1,V2,V3) <br>
Standard_EXPORT   void GetVertex(Standard_Integer& V1,Standard_Integer& V2,Standard_Integer& V3) const;

//! set indexes of the three vertices (V1,V2,V3) <br>//! Raised if V1, V2 or V3 is lower than zero <br>
Standard_EXPORT   void SetVertex(const Standard_Integer V1,const Standard_Integer V2,const Standard_Integer V3) ;
//Standard_EXPORT ~StlMesh_MeshTriangle();




 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
Standard_Integer MyV1;
Standard_Integer MyV2;
Standard_Integer MyV3;
Standard_Real MyXn;
Standard_Real MyYn;
Standard_Real MyZn;


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
