// File generated by CPPExt (Value)
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _TDF_IDList_HeaderFile
#define _TDF_IDList_HeaderFile

#ifndef _Standard_Address_HeaderFile
#include <Standard_Address.hxx>
#endif
#ifndef _Handle_TDF_ListNodeOfIDList_HeaderFile
#include <Handle_TDF_ListNodeOfIDList.hxx>
#endif
#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
class Standard_NoSuchObject;
class TDF_ListIteratorOfIDList;
class Standard_GUID;
class TDF_ListNodeOfIDList;


#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_Macro_HeaderFile
#include <Standard_Macro.hxx>
#endif


class TDF_IDList  {

public:

    void* operator new(size_t,void* anAddress) 
      {
        return anAddress;
      }
    void* operator new(size_t size) 
      { 
        return Standard::Allocate(size); 
      }
    void  operator delete(void *anAddress) 
      { 
        if (anAddress) Standard::Free((Standard_Address&)anAddress); 
      }
 // Methods PUBLIC
 // 


Standard_EXPORT TDF_IDList();


Standard_EXPORT   void Assign(const TDF_IDList& Other) ;
  void operator=(const TDF_IDList& Other) 
{
  Assign(Other);
}



Standard_EXPORT   Standard_Integer Extent() const;


Standard_EXPORT   void Clear() ;
~TDF_IDList()
{
  Clear();
}


  Standard_Boolean IsEmpty() const;


Standard_EXPORT   void Prepend(const Standard_GUID& I) ;


Standard_EXPORT   void Prepend(const Standard_GUID& I,TDF_ListIteratorOfIDList& theIt) ;


Standard_EXPORT   void Prepend(TDF_IDList& Other) ;


Standard_EXPORT   void Append(const Standard_GUID& I) ;


Standard_EXPORT   void Append(const Standard_GUID& I,TDF_ListIteratorOfIDList& theIt) ;


Standard_EXPORT   void Append(TDF_IDList& Other) ;


Standard_EXPORT   Standard_GUID& First() const;


Standard_EXPORT   Standard_GUID& Last() const;


Standard_EXPORT   void RemoveFirst() ;


Standard_EXPORT   void Remove(TDF_ListIteratorOfIDList& It) ;


Standard_EXPORT   void InsertBefore(const Standard_GUID& I,TDF_ListIteratorOfIDList& It) ;


Standard_EXPORT   void InsertBefore(TDF_IDList& Other,TDF_ListIteratorOfIDList& It) ;


Standard_EXPORT   void InsertAfter(const Standard_GUID& I,TDF_ListIteratorOfIDList& It) ;


Standard_EXPORT   void InsertAfter(TDF_IDList& Other,TDF_ListIteratorOfIDList& It) ;


friend class TDF_ListIteratorOfIDList;



protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


Standard_EXPORT TDF_IDList(const TDF_IDList& Other);


 // Fields PRIVATE
 //
Standard_Address myFirst;
Standard_Address myLast;


};

#define Item Standard_GUID
#define Item_hxx <Standard_GUID.hxx>
#define TCollection_ListNode TDF_ListNodeOfIDList
#define TCollection_ListNode_hxx <TDF_ListNodeOfIDList.hxx>
#define TCollection_ListIterator TDF_ListIteratorOfIDList
#define TCollection_ListIterator_hxx <TDF_ListIteratorOfIDList.hxx>
#define Handle_TCollection_ListNode Handle_TDF_ListNodeOfIDList
#define TCollection_ListNode_Type_() TDF_ListNodeOfIDList_Type_()
#define TCollection_List TDF_IDList
#define TCollection_List_hxx <TDF_IDList.hxx>

#include <TCollection_List.lxx>

#undef Item
#undef Item_hxx
#undef TCollection_ListNode
#undef TCollection_ListNode_hxx
#undef TCollection_ListIterator
#undef TCollection_ListIterator_hxx
#undef Handle_TCollection_ListNode
#undef TCollection_ListNode_Type_
#undef TCollection_List
#undef TCollection_List_hxx


// other Inline functions and methods (like "C++: function call" methods)
//


#endif
