// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _TDataStd_IntPackedMap_HeaderFile
#define _TDataStd_IntPackedMap_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_TDataStd_IntPackedMap_HeaderFile
#include <Handle_TDataStd_IntPackedMap.hxx>
#endif

#ifndef _Handle_TColStd_HPackedMapOfInteger_HeaderFile
#include <Handle_TColStd_HPackedMapOfInteger.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
#ifndef _TDF_Attribute_HeaderFile
#include <TDF_Attribute.hxx>
#endif
#ifndef _TColStd_PackedMapOfInteger_HeaderFile
#include <TColStd_PackedMapOfInteger.hxx>
#endif
#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
#ifndef _Handle_TDF_Attribute_HeaderFile
#include <Handle_TDF_Attribute.hxx>
#endif
#ifndef _Handle_TDF_RelocationTable_HeaderFile
#include <Handle_TDF_RelocationTable.hxx>
#endif
#ifndef _Standard_OStream_HeaderFile
#include <Standard_OStream.hxx>
#endif
#ifndef _Handle_TDF_DeltaOnModification_HeaderFile
#include <Handle_TDF_DeltaOnModification.hxx>
#endif
class TColStd_HPackedMapOfInteger;
class TDataStd_DeltaOnModificationOfIntPackedMap;
class Standard_GUID;
class TDF_Label;
class TDF_Attribute;
class TDF_RelocationTable;
class TDF_DeltaOnModification;


//! Attribute for storing TColStd_PackedMapOfInteger <br>
class TDataStd_IntPackedMap : public TDF_Attribute {

public:
 // Methods PUBLIC
 // 

//! class methods <br>
//!          ============= <br>//! Returns the GUID of the attribute. <br>
Standard_EXPORT static const Standard_GUID& GetID() ;

//! Finds or creates an integer map attribute on the given label. <br>
//! If <isDelta> == False, DefaultDeltaOnModification is used. <br>
//! If <isDelta> == True, DeltaOnModification of the current attribute is used. <br>
//! If attribute is already set, input parameter <isDelta> is refused and the found <br>
//! attribute returned. <br>//! Attribute methods <br>
//!          =================== <br>
Standard_EXPORT static  Handle_TDataStd_IntPackedMap Set(const TDF_Label& label,const Standard_Boolean isDelta = Standard_False) ;


Standard_EXPORT TDataStd_IntPackedMap();


Standard_EXPORT   Standard_Boolean ChangeMap(const Handle(TColStd_HPackedMapOfInteger)& theMap) ;

 const TColStd_PackedMapOfInteger& GetMap() const;

 const Handle_TColStd_HPackedMapOfInteger& GetHMap() const;


Standard_EXPORT   Standard_Boolean Clear() ;


Standard_EXPORT   Standard_Boolean Add(const Standard_Integer theKey) ;


Standard_EXPORT   Standard_Boolean Remove(const Standard_Integer theKey) ;


Standard_EXPORT   Standard_Boolean Contains(const Standard_Integer theKey) const;

  Standard_Integer Extent() const;

  Standard_Boolean IsEmpty() const;

  Standard_Boolean GetDelta() const;
//! for  internal  use  only! <br>
  void SetDelta(const Standard_Boolean isDelta) ;


Standard_EXPORT  const Standard_GUID& ID() const;


Standard_EXPORT   void Restore(const Handle(TDF_Attribute)& with) ;


Standard_EXPORT   Handle_TDF_Attribute NewEmpty() const;


Standard_EXPORT   void Paste(const Handle(TDF_Attribute)& into,const Handle(TDF_RelocationTable)& RT) const;


Standard_EXPORT virtual  Standard_OStream& Dump(Standard_OStream& anOS) const;

//! Makes a DeltaOnModification between <me> and <br>
//!         <anOldAttribute>. <br>
Standard_EXPORT virtual  Handle_TDF_DeltaOnModification DeltaOnModification(const Handle(TDF_Attribute)& anOldAttribute) const;
//Standard_EXPORT ~TDataStd_IntPackedMap();


friend class TDataStd_DeltaOnModificationOfIntPackedMap;


 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 

  void RemoveMap() ;


 // Fields PRIVATE
 //
Handle_TColStd_HPackedMapOfInteger myMap;
Standard_Boolean myIsDelta;


};


#include <TDataStd_IntPackedMap.lxx>



// other Inline functions and methods (like "C++: function call" methods)
//


#endif
