// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _TDataStd_Plane_HeaderFile
#define _TDataStd_Plane_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_TDataStd_Plane_HeaderFile
#include <Handle_TDataStd_Plane.hxx>
#endif

#ifndef _TDF_Attribute_HeaderFile
#include <TDF_Attribute.hxx>
#endif
#ifndef _Handle_TDF_Attribute_HeaderFile
#include <Handle_TDF_Attribute.hxx>
#endif
#ifndef _Handle_TDF_RelocationTable_HeaderFile
#include <Handle_TDF_RelocationTable.hxx>
#endif
#ifndef _Standard_OStream_HeaderFile
#include <Standard_OStream.hxx>
#endif
class Standard_GUID;
class TDF_Label;
class gp_Pln;
class TDF_Attribute;
class TDF_RelocationTable;


//! The basis to define a plane attribute. <br>
//! This attribute is used as a projection plane by the <br>
//! sketch attribute TDataStd_Sketch. <br>
//! <br>
//!  Warning:  Use TDataStd_Geometry  attribute  to retrieve  the <br>
//!          gp_Pln of the Plane attribute <br>
class TDataStd_Plane : public TDF_Attribute {

public:
 // Methods PUBLIC
 // 

//! class methods <br>
//!          ============= <br>
//! Returns the GUID for plane attributes. <br>
Standard_EXPORT static const Standard_GUID& GetID() ;

//!  Finds or creates the plane attribute defined by <br>
//! the label label. <br>
//! Warning <br>
//! If you are creating the attribute with this syntax, a <br>
//! planar face should already be associated with label. <br>
Standard_EXPORT static  Handle_TDataStd_Plane Set(const TDF_Label& label) ;

//! Finds,  or creates,  a Plane  attribute  and sets <P>  as <br>
//!          generated the associated NamedShape. <br>//! Plane methods <br>
//!         ============= <br>
Standard_EXPORT static  Handle_TDataStd_Plane Set(const TDF_Label& label,const gp_Pln& P) ;


Standard_EXPORT TDataStd_Plane();


Standard_EXPORT  const Standard_GUID& ID() const;


Standard_EXPORT   void Restore(const Handle(TDF_Attribute)& With) ;


Standard_EXPORT   Handle_TDF_Attribute NewEmpty() const;


Standard_EXPORT   void Paste(const Handle(TDF_Attribute)& Into,const Handle(TDF_RelocationTable)& RT) const;


Standard_EXPORT virtual  Standard_OStream& Dump(Standard_OStream& anOS) const;
//Standard_EXPORT ~TDataStd_Plane();




 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
