// File generated by CPPExt (Enum)
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _TopAbs_Orientation_HeaderFile
#define _TopAbs_Orientation_HeaderFile

//! Identifies the orientation of a topological shape. <br>
//! Orientation can represent a relation between two <br>
//! entities, or it can apply to a shape in its own right. <br>
//! When used to describe a relation between two <br>
//! shapes, orientation allows you to use the underlying <br>
//! entity in either direction. For example on a curve <br>
//! which is oriented FORWARD (say from left to right) <br>
//! you can have both a FORWARD and a REVERSED <br>
//! edge. The FORWARD edge will be oriented from <br>
//! left to right, and the REVERSED edge from right to <br>
//! left. In this way, you share the underlying entity. In <br>
//! other words, two faces of a cube can share an <br>
//! edge, and can also be used to build compound shapes. <br>
//! For each case in which an element is used as the <br>
//! boundary of a geometric domain of a higher <br>
//! dimension, this element defines two local regions of <br>
//! which one is arbitrarily considered as the default <br>
//! region. A change in orientation implies a switch of <br>
//! default region. This allows you to apply changes of <br>
//! orientation to the shape as a whole. <br>
enum TopAbs_Orientation { 
 TopAbs_FORWARD,
TopAbs_REVERSED,
TopAbs_INTERNAL,
TopAbs_EXTERNAL
};


#ifndef _Standard_PrimitiveTypes_HeaderFile
#include <Standard_PrimitiveTypes.hxx>
#endif

#endif
