// File generated by CPPExt (Value)
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _TopOpeBRepDS_Edge3dInterferenceTool_HeaderFile
#define _TopOpeBRepDS_Edge3dInterferenceTool_HeaderFile

#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
#ifndef _TopTrans_SurfaceTransition_HeaderFile
#include <TopTrans_SurfaceTransition.hxx>
#endif
#ifndef _Standard_Real_HeaderFile
#include <Standard_Real.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
#ifndef _TopoDS_Shape_HeaderFile
#include <TopoDS_Shape.hxx>
#endif
#ifndef _gp_Pnt_HeaderFile
#include <gp_Pnt.hxx>
#endif
#ifndef _gp_Dir_HeaderFile
#include <gp_Dir.hxx>
#endif
#ifndef _Handle_TopOpeBRepDS_Interference_HeaderFile
#include <Handle_TopOpeBRepDS_Interference.hxx>
#endif
class TopoDS_Shape;
class TopOpeBRepDS_Interference;


#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_Macro_HeaderFile
#include <Standard_Macro.hxx>
#endif

//! a tool computing edge / face complex transition, <br>
//!          Interferences of edge reference are given by <br>
//!          I = (T on face, G = point or vertex, S = edge) <br>
class TopOpeBRepDS_Edge3dInterferenceTool  {

public:

    void* operator new(size_t,void* anAddress) 
      {
        return anAddress;
      }
    void* operator new(size_t size) 
      { 
        return Standard::Allocate(size); 
      }
    void  operator delete(void *anAddress) 
      { 
        if (anAddress) Standard::Free((Standard_Address&)anAddress); 
      }
 // Methods PUBLIC
 // 


Standard_EXPORT TopOpeBRepDS_Edge3dInterferenceTool();


Standard_EXPORT   void InitPointVertex(const Standard_Integer IsVertex,const TopoDS_Shape& VonOO) ;


Standard_EXPORT   void Init(const TopoDS_Shape& Eref,const TopoDS_Shape& E,const TopoDS_Shape& F,const Handle(TopOpeBRepDS_Interference)& I) ;


Standard_EXPORT   void Add(const TopoDS_Shape& Eref,const TopoDS_Shape& E,const TopoDS_Shape& F,const Handle(TopOpeBRepDS_Interference)& I) ;


Standard_EXPORT   void Transition(const Handle(TopOpeBRepDS_Interference)& I) const;





protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
Standard_Integer myFaceOriented;
TopTrans_SurfaceTransition myTool;
Standard_Real myTole;
Standard_Boolean myrefdef;
Standard_Integer myIsVertex;
TopoDS_Shape myVonOO;
gp_Pnt myP3d;
gp_Dir myTgtref;


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
