// File generated by CPPExt (Value)
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _UTL_HeaderFile
#define _UTL_HeaderFile

#ifndef _Standard_CString_HeaderFile
#include <Standard_CString.hxx>
#endif
#ifndef _Storage_Error_HeaderFile
#include <Storage_Error.hxx>
#endif
#ifndef _Storage_OpenMode_HeaderFile
#include <Storage_OpenMode.hxx>
#endif
#ifndef _Handle_Storage_Data_HeaderFile
#include <Handle_Storage_Data.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
#ifndef _Handle_Resource_Manager_HeaderFile
#include <Handle_Resource_Manager.hxx>
#endif
#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
class TCollection_ExtendedString;
class Storage_BaseDriver;
class Storage_Data;
class OSD_Path;
class OSD_FileIterator;
class TCollection_AsciiString;
class Standard_GUID;
class Resource_Manager;


#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_Macro_HeaderFile
#include <Standard_Macro.hxx>
#endif


class UTL  {

public:

    void* operator new(size_t,void* anAddress) 
      {
        return anAddress;
      }
    void* operator new(size_t size) 
      { 
        return Standard::Allocate(size); 
      }
    void  operator delete(void *anAddress) 
      { 
        if (anAddress) Standard::Free((Standard_Address&)anAddress); 
      }
 // Methods PUBLIC
 // 


Standard_EXPORT static  TCollection_ExtendedString xgetenv(const Standard_CString aCString) ;


Standard_EXPORT static  Storage_Error OpenFile(Storage_BaseDriver& aFile,const TCollection_ExtendedString& aName,const Storage_OpenMode aMode) ;


Standard_EXPORT static  void AddToUserInfo(const Handle(Storage_Data)& aData,const TCollection_ExtendedString& anInfo) ;


Standard_EXPORT static  OSD_Path Path(const TCollection_ExtendedString& aFileName) ;


Standard_EXPORT static  TCollection_ExtendedString Disk(const OSD_Path& aPath) ;


Standard_EXPORT static  TCollection_ExtendedString Trek(const OSD_Path& aPath) ;


Standard_EXPORT static  TCollection_ExtendedString Name(const OSD_Path& aPath) ;


Standard_EXPORT static  TCollection_ExtendedString Extension(const OSD_Path& aPath) ;


Standard_EXPORT static  OSD_FileIterator FileIterator(const OSD_Path& aPath,const TCollection_ExtendedString& aMask) ;


Standard_EXPORT static  TCollection_ExtendedString Extension(const TCollection_ExtendedString& aFileName) ;


Standard_EXPORT static  TCollection_ExtendedString LocalHost() ;


Standard_EXPORT static  TCollection_ExtendedString ExtendedString(const TCollection_AsciiString& anAsciiString) ;


Standard_EXPORT static  Standard_GUID GUID(const TCollection_ExtendedString& anXString) ;


Standard_EXPORT static  Standard_Boolean Find(const Handle(Resource_Manager)& aResourceManager,const TCollection_ExtendedString& aResourceName) ;


Standard_EXPORT static  TCollection_ExtendedString Value(const Handle(Resource_Manager)& aResourceManager,const TCollection_ExtendedString& aResourceName) ;


Standard_EXPORT static  Standard_Integer IntegerValue(const TCollection_ExtendedString& anExtendedString) ;


Standard_EXPORT static  Standard_CString CString(const TCollection_ExtendedString& anExtendedString) ;


Standard_EXPORT static  Standard_Boolean IsReadOnly(const TCollection_ExtendedString& aFileName) ;





protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
