// File generated by CPPExt (Value)
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _Vrml_Cube_HeaderFile
#define _Vrml_Cube_HeaderFile

#ifndef _Standard_Real_HeaderFile
#include <Standard_Real.hxx>
#endif
#ifndef _Standard_OStream_HeaderFile
#include <Standard_OStream.hxx>
#endif


#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_Macro_HeaderFile
#include <Standard_Macro.hxx>
#endif

//! defines a Cube node of VRML specifying geometry shapes. <br>
//! This  node  represents  a  cuboid aligned with  the coordinate  axes. <br>
//! By  default ,  the  cube  is  centred  at  (0,0,0) and  measures  2  units <br>
//! in  each  dimension, from -1  to  +1. <br>
//! A cube's width is its extent along its object-space X axis, its height is <br>
//! its extent along the object-space Y axis, and its depth is its extent along its <br>
//! object-space Z axis. <br>
class Vrml_Cube  {

public:

    void* operator new(size_t,void* anAddress) 
      {
        return anAddress;
      }
    void* operator new(size_t size) 
      { 
        return Standard::Allocate(size); 
      }
    void  operator delete(void *anAddress) 
      { 
        if (anAddress) Standard::Free((Standard_Address&)anAddress); 
      }
 // Methods PUBLIC
 // 


Standard_EXPORT Vrml_Cube(const Standard_Real aWidth = 2,const Standard_Real aHeight = 2,const Standard_Real aDepth = 2);


Standard_EXPORT   void SetWidth(const Standard_Real aWidth) ;


Standard_EXPORT   Standard_Real Width() const;


Standard_EXPORT   void SetHeight(const Standard_Real aHeight) ;


Standard_EXPORT   Standard_Real Height() const;


Standard_EXPORT   void SetDepth(const Standard_Real aDepth) ;


Standard_EXPORT   Standard_Real Depth() const;


Standard_EXPORT   Standard_OStream& Print(Standard_OStream& anOStream) const;





protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
Standard_Real myWidth;
Standard_Real myHeight;
Standard_Real myDepth;


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
