// File generated by CPPExt (Value)
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _Vrml_PerspectiveCamera_HeaderFile
#define _Vrml_PerspectiveCamera_HeaderFile

#ifndef _gp_Vec_HeaderFile
#include <gp_Vec.hxx>
#endif
#ifndef _Vrml_SFRotation_HeaderFile
#include <Vrml_SFRotation.hxx>
#endif
#ifndef _Standard_Real_HeaderFile
#include <Standard_Real.hxx>
#endif
#ifndef _Standard_OStream_HeaderFile
#include <Standard_OStream.hxx>
#endif
class gp_Vec;
class Vrml_SFRotation;


#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_Macro_HeaderFile
#include <Standard_Macro.hxx>
#endif

//! specifies a PerspectiveCamera node of VRML specifying properties of cameras. <br>
//!  A perspective camera defines a perspective projection from a viewpoint. The viewing <br>
//!  volume for a perspective camera is a truncated right pyramid. <br>
class Vrml_PerspectiveCamera  {

public:

    void* operator new(size_t,void* anAddress) 
      {
        return anAddress;
      }
    void* operator new(size_t size) 
      { 
        return Standard::Allocate(size); 
      }
    void  operator delete(void *anAddress) 
      { 
        if (anAddress) Standard::Free((Standard_Address&)anAddress); 
      }
 // Methods PUBLIC
 // 


Standard_EXPORT Vrml_PerspectiveCamera();


Standard_EXPORT Vrml_PerspectiveCamera(const gp_Vec& aPosition,const Vrml_SFRotation& aOrientation,const Standard_Real aFocalDistance,const Standard_Real aHeightAngle);


Standard_EXPORT   void SetPosition(const gp_Vec& aPosition) ;


Standard_EXPORT   gp_Vec Position() const;


Standard_EXPORT   void SetOrientation(const Vrml_SFRotation& aOrientation) ;


Standard_EXPORT   Vrml_SFRotation Orientation() const;


Standard_EXPORT   void SetFocalDistance(const Standard_Real aFocalDistance) ;


Standard_EXPORT   Standard_Real FocalDistance() const;


Standard_EXPORT   void SetAngle(const Standard_Real aHeightAngle) ;


Standard_EXPORT   Standard_Real Angle() const;


Standard_EXPORT   Standard_OStream& Print(Standard_OStream& anOStream) const;





protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
gp_Vec myPosition;
Vrml_SFRotation myOrientation;
Standard_Real myFocalDistance;
Standard_Real myHeightAngle;


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
