// File generated by CPPExt (Value)
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _Vrml_SFRotation_HeaderFile
#define _Vrml_SFRotation_HeaderFile

#ifndef _Standard_Real_HeaderFile
#include <Standard_Real.hxx>
#endif


#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_Macro_HeaderFile
#include <Standard_Macro.hxx>
#endif

//! defines SFRotation type of VRML field types. <br>
//!          The  4  values  represent  an  axis  of  rotation  followed  by  amount  of <br>
//!          right-handed  rotation  about  the  that  axis, in  radians. <br>
class Vrml_SFRotation  {

public:

    void* operator new(size_t,void* anAddress) 
      {
        return anAddress;
      }
    void* operator new(size_t size) 
      { 
        return Standard::Allocate(size); 
      }
    void  operator delete(void *anAddress) 
      { 
        if (anAddress) Standard::Free((Standard_Address&)anAddress); 
      }
 // Methods PUBLIC
 // 


Standard_EXPORT Vrml_SFRotation();


Standard_EXPORT Vrml_SFRotation(const Standard_Real aRotationX,const Standard_Real aRotationY,const Standard_Real aRotationZ,const Standard_Real anAngle);


Standard_EXPORT   void SetRotationX(const Standard_Real aRotationX) ;


Standard_EXPORT   Standard_Real RotationX() const;


Standard_EXPORT   void SetRotationY(const Standard_Real aRotationY) ;


Standard_EXPORT   Standard_Real RotationY() const;


Standard_EXPORT   void SetRotationZ(const Standard_Real aRotationZ) ;


Standard_EXPORT   Standard_Real RotationZ() const;


Standard_EXPORT   void SetAngle(const Standard_Real anAngle) ;


Standard_EXPORT   Standard_Real Angle() const;





protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
Standard_Real myRotationX;
Standard_Real myRotationY;
Standard_Real myRotationZ;
Standard_Real myAngle;


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
