// File generated by CPPExt (Value)
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _Vrml_Texture2Transform_HeaderFile
#define _Vrml_Texture2Transform_HeaderFile

#ifndef _gp_Vec2d_HeaderFile
#include <gp_Vec2d.hxx>
#endif
#ifndef _Standard_Real_HeaderFile
#include <Standard_Real.hxx>
#endif
#ifndef _Standard_OStream_HeaderFile
#include <Standard_OStream.hxx>
#endif
class gp_Vec2d;


#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_Macro_HeaderFile
#include <Standard_Macro.hxx>
#endif

//! defines a Texture2Transform node of VRML specifying properties of geometry <br>
//!          and its appearance. <br>
//!  This  node  defines  a 2D  transformation  applied  to  texture  coordinates. <br>
//!  This  affect  the  way  textures  are  applied  to  the  surfaces  of  subsequent <br>
//!  shapes. <br>
//!  Transformation  consisits  of(in  order)  a  non-uniform  scale  about  an <br>
//!  arbitrary  center  point,  a  rotation  about  that  same  point,  and <br>
//!  a  translation.  This  allows  a  user  to  change  the  size  and  position  of <br>
//!  the  textures  on  the  shape. <br>
//!  By  default  : <br>
//!    myTranslation (0 0) <br>
//!    myRotation (0) <br>
//!    myScaleFactor (1 1) <br>
//!    myCenter (0 0) <br>
class Vrml_Texture2Transform  {

public:

    void* operator new(size_t,void* anAddress) 
      {
        return anAddress;
      }
    void* operator new(size_t size) 
      { 
        return Standard::Allocate(size); 
      }
    void  operator delete(void *anAddress) 
      { 
        if (anAddress) Standard::Free((Standard_Address&)anAddress); 
      }
 // Methods PUBLIC
 // 


Standard_EXPORT Vrml_Texture2Transform();


Standard_EXPORT Vrml_Texture2Transform(const gp_Vec2d& aTranslation,const Standard_Real aRotation,const gp_Vec2d& aScaleFactor,const gp_Vec2d& aCenter);


Standard_EXPORT   void SetTranslation(const gp_Vec2d& aTranslation) ;


Standard_EXPORT   gp_Vec2d Translation() const;


Standard_EXPORT   void SetRotation(const Standard_Real aRotation) ;


Standard_EXPORT   Standard_Real Rotation() const;


Standard_EXPORT   void SetScaleFactor(const gp_Vec2d& aScaleFactor) ;


Standard_EXPORT   gp_Vec2d ScaleFactor() const;


Standard_EXPORT   void SetCenter(const gp_Vec2d& aCenter) ;


Standard_EXPORT   gp_Vec2d Center() const;


Standard_EXPORT   Standard_OStream& Print(Standard_OStream& anOStream) const;





protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
gp_Vec2d myTranslation;
Standard_Real myRotation;
gp_Vec2d myScaleFactor;
gp_Vec2d myCenter;


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
