// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _WOKUnix_Process_HeaderFile
#define _WOKUnix_Process_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_WOKUnix_Process_HeaderFile
#include <Handle_WOKUnix_Process.hxx>
#endif

#ifndef _WOKTools_ArgTable_HeaderFile
#include <WOKTools_ArgTable.hxx>
#endif
#ifndef _WOKUnix_PopenOutputMode_HeaderFile
#include <WOKUnix_PopenOutputMode.hxx>
#endif
#ifndef _WOKUnix_PopenBufferMode_HeaderFile
#include <WOKUnix_PopenBufferMode.hxx>
#endif
#ifndef _WOKUnix_FDescr_HeaderFile
#include <WOKUnix_FDescr.hxx>
#endif
#ifndef _Handle_WOKUnix_ProcessOutput_HeaderFile
#include <Handle_WOKUnix_ProcessOutput.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
#ifndef _MMgt_TShared_HeaderFile
#include <MMgt_TShared.hxx>
#endif
#ifndef _Handle_TCollection_HAsciiString_HeaderFile
#include <Handle_TCollection_HAsciiString.hxx>
#endif
#ifndef _WOKUnix_Timeval_HeaderFile
#include <WOKUnix_Timeval.hxx>
#endif
#ifndef _WOKUnix_FDSet_HeaderFile
#include <WOKUnix_FDSet.hxx>
#endif
class WOKUnix_ProcessOutput;
class OSD_OSDError;
class TCollection_HAsciiString;



class WOKUnix_Process : public MMgt_TShared {

public:
 // Methods PUBLIC
 // 


Standard_EXPORT WOKUnix_Process(const Standard_Integer argcount,const WOKTools_ArgTable& cmdline,const WOKUnix_PopenOutputMode anoutputmode = WOKUnix_POPEN_MIX_OUT_ERR,const WOKUnix_PopenBufferMode abuffermode = WOKUnix_POPEN_BUFFERED,const Standard_Integer atimeout = -1);


Standard_EXPORT WOKUnix_Process(const Handle(TCollection_HAsciiString)& cmdline,const WOKUnix_PopenOutputMode anoutputmode = WOKUnix_POPEN_MIX_OUT_ERR,const WOKUnix_PopenBufferMode abuffermode = WOKUnix_POPEN_BUFFERED,const Standard_Integer atimeout = -1);


Standard_EXPORT   void SetCommand(const Standard_Integer argcount,const WOKTools_ArgTable& cmdline) ;


Standard_EXPORT   void Launch() ;


Standard_EXPORT   Standard_Boolean IsLaunched() const;


Standard_EXPORT   Standard_Integer Pid() const;


Standard_EXPORT   Standard_Integer Timeout() const;


Standard_EXPORT   void SetTimeout(const Standard_Integer atimeout) ;


Standard_EXPORT virtual  void Send(const Handle(TCollection_HAsciiString)& astring) ;


Standard_EXPORT   void Kill() ;


Standard_EXPORT   void Destroy() ;
~WOKUnix_Process()
{
  Destroy();
}





 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 


Standard_EXPORT   Handle_WOKUnix_ProcessOutput& Output() ;


Standard_EXPORT   void Select(Standard_Integer& afdmax,WOKUnix_Timeval& atimeout,WOKUnix_FDSet& aset) const;


Standard_EXPORT   void Acquit(const Standard_Integer selectstatus,const WOKUnix_FDSet& aset) const;


Standard_EXPORT   void SelectAndAcquit() const;


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
WOKTools_ArgTable myargv;
WOKUnix_PopenOutputMode mymode;
WOKUnix_PopenBufferMode mybuffermode;
WOKUnix_FDescr myinput;
Handle_WOKUnix_ProcessOutput myoutput;
Standard_Boolean mylaunched;
Standard_Integer mytimeout;
Standard_Integer mychildpid;


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
