// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _WOKUnix_Shell_HeaderFile
#define _WOKUnix_Shell_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_WOKUnix_Shell_HeaderFile
#include <Handle_WOKUnix_Shell.hxx>
#endif

#ifndef _Handle_WOKUnix_ShellStatus_HeaderFile
#include <Handle_WOKUnix_ShellStatus.hxx>
#endif
#ifndef _WOKUnix_ShellMode_HeaderFile
#include <WOKUnix_ShellMode.hxx>
#endif
#ifndef _Handle_TCollection_HAsciiString_HeaderFile
#include <Handle_TCollection_HAsciiString.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
#ifndef _Handle_WOKUnix_Path_HeaderFile
#include <Handle_WOKUnix_Path.hxx>
#endif
#ifndef _WOKUnix_Process_HeaderFile
#include <WOKUnix_Process.hxx>
#endif
#ifndef _WOKUnix_PopenOutputMode_HeaderFile
#include <WOKUnix_PopenOutputMode.hxx>
#endif
#ifndef _WOKUnix_PopenBufferMode_HeaderFile
#include <WOKUnix_PopenBufferMode.hxx>
#endif
#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
#ifndef _Handle_TColStd_HSequenceOfHAsciiString_HeaderFile
#include <Handle_TColStd_HSequenceOfHAsciiString.hxx>
#endif
class WOKUnix_ShellStatus;
class TCollection_HAsciiString;
class WOKUnix_Path;
class TCollection_AsciiString;
class TColStd_HSequenceOfHAsciiString;



class WOKUnix_Shell : public WOKUnix_Process {

public:
 // Methods PUBLIC
 // 


Standard_EXPORT WOKUnix_Shell(const WOKUnix_ShellMode amode = WOKUnix_AsynchronousMode,const WOKUnix_PopenOutputMode outmode = WOKUnix_POPEN_MIX_OUT_ERR,const WOKUnix_PopenBufferMode bufmode = WOKUnix_POPEN_BUFFERED);


Standard_EXPORT WOKUnix_Shell(const TCollection_AsciiString& apath,const WOKUnix_ShellMode amode = WOKUnix_AsynchronousMode,const WOKUnix_PopenOutputMode outmode = WOKUnix_POPEN_MIX_OUT_ERR,const WOKUnix_PopenBufferMode bufmode = WOKUnix_POPEN_BUFFERED);


Standard_EXPORT   void SetEcho() ;


Standard_EXPORT   void UnsetEcho() ;


Standard_EXPORT   Standard_Boolean IsEchoed() const;


Standard_EXPORT   void Echo(const Handle(TCollection_HAsciiString)& astr) const;


Standard_EXPORT   void Lock() ;


Standard_EXPORT   void UnLock() ;


Standard_EXPORT   Standard_Boolean IsLocked() const;


Standard_EXPORT   void LogInFile(const Handle(WOKUnix_Path)& apath) ;


Standard_EXPORT   void NoLog() ;


Standard_EXPORT   Handle_WOKUnix_Path LogFile() const;


Standard_EXPORT   void Log(const Handle(TCollection_HAsciiString)& astr) const;


Standard_EXPORT   void SetSynchronous() ;


Standard_EXPORT   void SetASynchronous() ;


Standard_EXPORT virtual  Standard_Integer SyncAndStatus() ;


Standard_EXPORT   Standard_Integer Status() const;


Standard_EXPORT   Handle_TColStd_HSequenceOfHAsciiString Errors() ;


Standard_EXPORT   void ClearOutput() ;


Standard_EXPORT virtual  void Send(const Handle(TCollection_HAsciiString)& astring) ;


Standard_EXPORT   Standard_Integer Execute(const Handle(TCollection_HAsciiString)& astring) ;


Standard_EXPORT   Standard_Integer Execute(const Handle(TColStd_HSequenceOfHAsciiString)& somestrings) ;


Standard_EXPORT   void SetHost(const Handle(TCollection_HAsciiString)& ahost) ;


Standard_EXPORT   Handle_TCollection_HAsciiString Host() const;
//Standard_EXPORT ~WOKUnix_Shell();




 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //
Handle_WOKUnix_ShellStatus mystatus;


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
WOKUnix_ShellMode mymode;
Handle_TCollection_HAsciiString myname;
Standard_Boolean mylocked;
Standard_Boolean myecho;
Handle_WOKUnix_Path mylogfile;
Handle_TCollection_HAsciiString myhost;


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
