// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _WOKernel_BaseEntity_HeaderFile
#define _WOKernel_BaseEntity_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_WOKernel_BaseEntity_HeaderFile
#include <Handle_WOKernel_BaseEntity.hxx>
#endif

#ifndef _Handle_TCollection_HAsciiString_HeaderFile
#include <Handle_TCollection_HAsciiString.hxx>
#endif
#ifndef _WOKernel_PSession_HeaderFile
#include <WOKernel_PSession.hxx>
#endif
#ifndef _MMgt_TShared_HeaderFile
#include <MMgt_TShared.hxx>
#endif
#ifndef _Handle_WOKernel_Entity_HeaderFile
#include <Handle_WOKernel_Entity.hxx>
#endif
#ifndef _Handle_WOKernel_Session_HeaderFile
#include <Handle_WOKernel_Session.hxx>
#endif
class TCollection_HAsciiString;
class Standard_ProgramError;
class WOKernel_Entity;
class WOKernel_Session;


//! Common WOKernel Base class <br>
class WOKernel_BaseEntity : public MMgt_TShared {

public:
 // Methods PUBLIC
 // 

//! change name of Entity <br>
Standard_EXPORT   void SetName(const Handle(TCollection_HAsciiString)& aname) ;
//! get Name of Entity <br>
 const Handle_TCollection_HAsciiString& Name() const;

 const Handle_TCollection_HAsciiString& UserPathName() const;

 const Handle_TCollection_HAsciiString& FullName() const;


Standard_EXPORT   void SetFullName(const Handle(TCollection_HAsciiString)& afullname) ;


Standard_EXPORT virtual  Handle_TCollection_HAsciiString GetUniqueName() const = 0;

//! change Nesting Entity of current Entity <br>
Standard_EXPORT   void SetNesting(const Handle(WOKernel_Entity)& anesting) ;
//! get Name of nesting Entity <br>
 const Handle_TCollection_HAsciiString& Nesting() const;

//! change session Of Entity <br>
Standard_EXPORT   void SetSession(const Handle(WOKernel_Session)& asession) ;
//! get pointer to current Session <br>
  Handle_WOKernel_Session Session() const;
//Standard_EXPORT ~WOKernel_BaseEntity();




 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 

//! Initialize a WOKernel BaseEntity <br>
Standard_EXPORT WOKernel_BaseEntity(const Handle(TCollection_HAsciiString)& aname,const Handle(WOKernel_Entity)& anesting);


 // Fields PROTECTED
 //
Handle_TCollection_HAsciiString myfullname;


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
Handle_TCollection_HAsciiString myname;
Handle_TCollection_HAsciiString mynestingentity;
WOKernel_PSession mysession;


};


#include <WOKernel_BaseEntity.lxx>



// other Inline functions and methods (like "C++: function call" methods)
//


#endif
