// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _XCAFDoc_DocumentTool_HeaderFile
#define _XCAFDoc_DocumentTool_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_XCAFDoc_DocumentTool_HeaderFile
#include <Handle_XCAFDoc_DocumentTool.hxx>
#endif

#ifndef _TDF_Attribute_HeaderFile
#include <TDF_Attribute.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
#ifndef _Handle_TDocStd_Document_HeaderFile
#include <Handle_TDocStd_Document.hxx>
#endif
#ifndef _Handle_XCAFDoc_ShapeTool_HeaderFile
#include <Handle_XCAFDoc_ShapeTool.hxx>
#endif
#ifndef _Handle_XCAFDoc_ColorTool_HeaderFile
#include <Handle_XCAFDoc_ColorTool.hxx>
#endif
#ifndef _Handle_XCAFDoc_LayerTool_HeaderFile
#include <Handle_XCAFDoc_LayerTool.hxx>
#endif
#ifndef _Handle_XCAFDoc_DimTolTool_HeaderFile
#include <Handle_XCAFDoc_DimTolTool.hxx>
#endif
#ifndef _Handle_XCAFDoc_MaterialTool_HeaderFile
#include <Handle_XCAFDoc_MaterialTool.hxx>
#endif
#ifndef _Handle_TDF_Attribute_HeaderFile
#include <Handle_TDF_Attribute.hxx>
#endif
#ifndef _Handle_TDF_RelocationTable_HeaderFile
#include <Handle_TDF_RelocationTable.hxx>
#endif
class Standard_GUID;
class TDF_Label;
class TDocStd_Document;
class XCAFDoc_ShapeTool;
class XCAFDoc_ColorTool;
class XCAFDoc_LayerTool;
class XCAFDoc_DimTolTool;
class XCAFDoc_MaterialTool;
class TDF_Attribute;
class TDF_RelocationTable;


//! Defines sections structure of an XDE document. <br>
class XCAFDoc_DocumentTool : public TDF_Attribute {

public:
 // Methods PUBLIC
 // 


Standard_EXPORT static const Standard_GUID& GetID() ;

//! Create (if not exist) DocumentTool attribute <br>
//!          on 0.1 label if <IsAcces> is true, else <br>
//!          on <L> label. <br>
//!          This label will be returned by DocLabel(); <br>
//!          If the attribute is already set it won't be reset on <br>
//!          <L> even if <IsAcces> is false. <br>
//!          ColorTool and ShapeTool attributes are also set by this method. <br>
Standard_EXPORT static  Handle_XCAFDoc_DocumentTool Set(const TDF_Label& L,const Standard_Boolean IsAcces = Standard_True) ;


Standard_EXPORT static  Standard_Boolean IsXCAFDocument(const Handle(TDocStd_Document)& Doc) ;

//! Returns label where the DocumentTool attribute is or <br>
//!          0.1 if DocumentTool is not yet set. <br>
Standard_EXPORT static  TDF_Label DocLabel(const TDF_Label& acces) ;

//! Returns sub-label of DocLabel() with tag 1. <br>
Standard_EXPORT static  TDF_Label ShapesLabel(const TDF_Label& acces) ;

//! Returns sub-label of DocLabel() with tag 2. <br>
Standard_EXPORT static  TDF_Label ColorsLabel(const TDF_Label& acces) ;

//! Returns sub-label of DocLabel() with tag 3. <br>
Standard_EXPORT static  TDF_Label LayersLabel(const TDF_Label& acces) ;

//! Returns sub-label of DocLabel() with tag 4. <br>
Standard_EXPORT static  TDF_Label DGTsLabel(const TDF_Label& acces) ;

//! Returns sub-label of DocLabel() with tag 5. <br>
Standard_EXPORT static  TDF_Label MaterialsLabel(const TDF_Label& acces) ;

//! Creates (if it does not exist) ShapeTool attribute on ShapesLabel(). <br>
Standard_EXPORT static  Handle_XCAFDoc_ShapeTool ShapeTool(const TDF_Label& acces) ;

//! Creates (if it does not exist) ColorTool attribute on ColorsLabel(). <br>
Standard_EXPORT static  Handle_XCAFDoc_ColorTool ColorTool(const TDF_Label& acces) ;

//! Creates (if it does not exist) LayerTool attribute on LayersLabel(). <br>
Standard_EXPORT static  Handle_XCAFDoc_LayerTool LayerTool(const TDF_Label& acces) ;

//! Creates (if it does not exist) DimTolTool attribute on DGTsLabel(). <br>
Standard_EXPORT static  Handle_XCAFDoc_DimTolTool DimTolTool(const TDF_Label& acces) ;

//! Creates (if it does not exist) DimTolTool attribute on DGTsLabel(). <br>
Standard_EXPORT static  Handle_XCAFDoc_MaterialTool MaterialTool(const TDF_Label& acces) ;


Standard_EXPORT XCAFDoc_DocumentTool();

//! to be called when reading this attribute from file <br>
Standard_EXPORT   void Init() const;


Standard_EXPORT  const Standard_GUID& ID() const;


Standard_EXPORT   void Restore(const Handle(TDF_Attribute)& with) ;


Standard_EXPORT   Handle_TDF_Attribute NewEmpty() const;


Standard_EXPORT   void Paste(const Handle(TDF_Attribute)& into,const Handle(TDF_RelocationTable)& RT) const;
//Standard_EXPORT ~XCAFDoc_DocumentTool();




 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
