// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _XCAFDoc_ShapeMapTool_HeaderFile
#define _XCAFDoc_ShapeMapTool_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_XCAFDoc_ShapeMapTool_HeaderFile
#include <Handle_XCAFDoc_ShapeMapTool.hxx>
#endif

#ifndef _TopTools_IndexedMapOfShape_HeaderFile
#include <TopTools_IndexedMapOfShape.hxx>
#endif
#ifndef _TDF_Attribute_HeaderFile
#include <TDF_Attribute.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
#ifndef _Handle_TDF_Attribute_HeaderFile
#include <Handle_TDF_Attribute.hxx>
#endif
#ifndef _Handle_TDF_RelocationTable_HeaderFile
#include <Handle_TDF_RelocationTable.hxx>
#endif
class Standard_GUID;
class TDF_Label;
class TopoDS_Shape;
class TDF_Attribute;
class TDF_RelocationTable;
class TopTools_IndexedMapOfShape;



class XCAFDoc_ShapeMapTool : public TDF_Attribute {

public:
 // Methods PUBLIC
 // 


Standard_EXPORT static const Standard_GUID& GetID() ;

//! Create (if not exist) ShapeTool from XCAFDoc on <L>. <br>
Standard_EXPORT static  Handle_XCAFDoc_ShapeMapTool Set(const TDF_Label& L) ;

//! Creates an empty tool <br>
Standard_EXPORT XCAFDoc_ShapeMapTool();

//! Checks whether shape <sub> is subshape of shape stored on <br>
//!          label shapeL <br>
Standard_EXPORT   Standard_Boolean IsSubShape(const TopoDS_Shape& sub) const;

//! Sets representation (TopoDS_Shape) for top-level shape <br>
Standard_EXPORT   void SetShape(const TopoDS_Shape& S) ;


Standard_EXPORT  const Standard_GUID& ID() const;


Standard_EXPORT   void Restore(const Handle(TDF_Attribute)& with) ;


Standard_EXPORT   Handle_TDF_Attribute NewEmpty() const;


Standard_EXPORT   void Paste(const Handle(TDF_Attribute)& into,const Handle(TDF_RelocationTable)& RT) const;


Standard_EXPORT  const TopTools_IndexedMapOfShape& GetMap() const;
//Standard_EXPORT ~XCAFDoc_ShapeMapTool();




 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
TopTools_IndexedMapOfShape myMap;


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
