// File generated by CPPExt (Value)
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _XSControl_FuncShape_HeaderFile
#define _XSControl_FuncShape_HeaderFile

#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
#ifndef _Handle_XSControl_WorkSession_HeaderFile
#include <Handle_XSControl_WorkSession.hxx>
#endif
#ifndef _Handle_TopTools_HSequenceOfShape_HeaderFile
#include <Handle_TopTools_HSequenceOfShape.hxx>
#endif
#ifndef _Standard_CString_HeaderFile
#include <Standard_CString.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
class XSControl_WorkSession;
class TopTools_HSequenceOfShape;
class TCollection_AsciiString;


#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_Macro_HeaderFile
#include <Standard_Macro.hxx>
#endif

//! Defines additionnal commands for XSControl to : <br>
//!           - control of initialisation (xinit, xnorm, newmodel) <br>
//!           - analyse of the result of a transfer (recorded in a <br>
//!             TransientProcess for Read, FinderProcess for Write) : <br>
//!             statistics, various lists (roots,complete,abnormal), what <br>
//!             about one specific entity, producing a model with the <br>
//!             abnormal result <br>
//! <br>
//!           This appendix of XSControl is compiled separately to distinguish <br>
//!           basic features from user callable forms <br>
class XSControl_FuncShape  {

public:

    void* operator new(size_t,void* anAddress) 
      {
        return anAddress;
      }
    void* operator new(size_t size) 
      { 
        return Standard::Allocate(size); 
      }
    void  operator delete(void *anAddress) 
      { 
        if (anAddress) Standard::Free((Standard_Address&)anAddress); 
      }
 // Methods PUBLIC
 // 

//! Defines and loads all functions which work on shapes for XSControl (as ActFunc) <br>
Standard_EXPORT static  void Init() ;

//! Analyses a name as designating Shapes from a Vars or from <br>
//!           XSTEP transfer (last Transfer on Reading). <name> can be : <br>
//!           "*" : all the root shapes produced by last Transfer (Read) <br>
//!                 i.e. considers roots of the TransientProcess <br>
//!           a name : a name of a variable DRAW <br>
//! <br>
//!           Returns the count of designated Shapes. Their list is put in <br>
//!           <list>. If <list> is null, it is firstly created. Then it is <br>
//!           completed (Append without Clear) by the Shapes found <br>
//!           Returns 0 if no Shape could be found <br>
Standard_EXPORT static  Standard_Integer MoreShapes(const Handle(XSControl_WorkSession)& session,Handle(TopTools_HSequenceOfShape)& list,const Standard_CString name) ;

//! Analyses given file name and variable name, with a default <br>
//!           name for variables. Returns resulting file name and variable <br>
//!           name plus status "file to read"(True) or "already read"(False) <br>
//!           In the latter case, empty resfile means no file available <br>
//! <br>
//!           If <file> is null or empty or equates ".", considers Session <br>
//!             and returned status is False <br>
//!           Else, returns resfile = file and status is True <br>
//!           If <var> is neither null nor empty, resvar = var <br>
//!           Else, the root part of <resfile> is considered, if defined <br>
//!           Else, <def> is taken <br>
Standard_EXPORT static  Standard_Boolean FileAndVar(const Handle(XSControl_WorkSession)& session,const Standard_CString file,const Standard_CString var,const Standard_CString def,TCollection_AsciiString& resfile,TCollection_AsciiString& resvar) ;





protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
