// File generated by CPPExt (Value)
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _XmlMDataStd_HeaderFile
#define _XmlMDataStd_HeaderFile

#ifndef _Handle_XmlMDF_ADriverTable_HeaderFile
#include <Handle_XmlMDF_ADriverTable.hxx>
#endif
#ifndef _Handle_CDM_MessageDriver_HeaderFile
#include <Handle_CDM_MessageDriver.hxx>
#endif
#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
class XmlMDF_ADriverTable;
class CDM_MessageDriver;
class XmlMDataStd_NameDriver;
class XmlMDataStd_IntegerDriver;
class XmlMDataStd_RealDriver;
class XmlMDataStd_IntegerArrayDriver;
class XmlMDataStd_RealArrayDriver;
class XmlMDataStd_ExtStringArrayDriver;
class XmlMDataStd_UAttributeDriver;
class XmlMDataStd_AxisDriver;
class XmlMDataStd_ShapeDriver;
class XmlMDataStd_DirectoryDriver;
class XmlMDataStd_CommentDriver;
class XmlMDataStd_PointDriver;
class XmlMDataStd_PlaneDriver;
class XmlMDataStd_GeometryDriver;
class XmlMDataStd_ConstraintDriver;
class XmlMDataStd_PlacementDriver;
class XmlMDataStd_PatternStdDriver;
class XmlMDataStd_VariableDriver;
class XmlMDataStd_ExpressionDriver;
class XmlMDataStd_RelationDriver;
class XmlMDataStd_NoteBookDriver;
class XmlMDataStd_TreeNodeDriver;
class XmlMDataStd_TickDriver;
class XmlMDataStd_IntegerListDriver;
class XmlMDataStd_RealListDriver;
class XmlMDataStd_ExtStringListDriver;
class XmlMDataStd_BooleanListDriver;
class XmlMDataStd_ReferenceListDriver;
class XmlMDataStd_BooleanArrayDriver;
class XmlMDataStd_ReferenceArrayDriver;
class XmlMDataStd_ByteArrayDriver;
class XmlMDataStd_NamedDataDriver;
class XmlMDataStd_AsciiStringDriver;
class XmlMDataStd_IntPackedMapDriver;


#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_Macro_HeaderFile
#include <Standard_Macro.hxx>
#endif

//! Storage and Retrieval drivers for modelling attributes. <br>
//!          Transient attributes are defined in package TDataStd <br>
//!          and persistent one are defined in package XmlPDataStd <br>
class XmlMDataStd  {

public:

    void* operator new(size_t,void* anAddress) 
      {
        return anAddress;
      }
    void* operator new(size_t size) 
      { 
        return Standard::Allocate(size); 
      }
    void  operator delete(void *anAddress) 
      { 
        if (anAddress) Standard::Free((Standard_Address&)anAddress); 
      }
 // Methods PUBLIC
 // 

//! Adds the attribute drivers to <aDriverTable>. <br>
Standard_EXPORT static  void AddDrivers(const Handle(XmlMDF_ADriverTable)& aDriverTable,const Handle(CDM_MessageDriver)& anMsgDrv) ;


Standard_EXPORT static  void SetDocumentVersion(const Standard_Integer DocVersion) ;


Standard_EXPORT static  Standard_Integer DocumentVersion() ;





protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //

friend class XmlMDataStd_NameDriver;
friend class XmlMDataStd_IntegerDriver;
friend class XmlMDataStd_RealDriver;
friend class XmlMDataStd_IntegerArrayDriver;
friend class XmlMDataStd_RealArrayDriver;
friend class XmlMDataStd_ExtStringArrayDriver;
friend class XmlMDataStd_UAttributeDriver;
friend class XmlMDataStd_AxisDriver;
friend class XmlMDataStd_ShapeDriver;
friend class XmlMDataStd_DirectoryDriver;
friend class XmlMDataStd_CommentDriver;
friend class XmlMDataStd_PointDriver;
friend class XmlMDataStd_PlaneDriver;
friend class XmlMDataStd_GeometryDriver;
friend class XmlMDataStd_ConstraintDriver;
friend class XmlMDataStd_PlacementDriver;
friend class XmlMDataStd_PatternStdDriver;
friend class XmlMDataStd_VariableDriver;
friend class XmlMDataStd_ExpressionDriver;
friend class XmlMDataStd_RelationDriver;
friend class XmlMDataStd_NoteBookDriver;
friend class XmlMDataStd_TreeNodeDriver;
friend class XmlMDataStd_TickDriver;
friend class XmlMDataStd_IntegerListDriver;
friend class XmlMDataStd_RealListDriver;
friend class XmlMDataStd_ExtStringListDriver;
friend class XmlMDataStd_BooleanListDriver;
friend class XmlMDataStd_ReferenceListDriver;
friend class XmlMDataStd_BooleanArrayDriver;
friend class XmlMDataStd_ReferenceArrayDriver;
friend class XmlMDataStd_ByteArrayDriver;
friend class XmlMDataStd_NamedDataDriver;
friend class XmlMDataStd_AsciiStringDriver;
friend class XmlMDataStd_IntPackedMapDriver;

};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
