#include <TPrsStd_PlaneDriver.ixx>

#include <TDF_Label.hxx>
#include <TDataStd_Plane.hxx>
//#include <TDataStd_Datum.hxx>
#include <TDataStd_Geometry.hxx>
#include <AIS_Plane.hxx>
#include <AIS_Drawer.hxx>
#include <AIS_InteractiveContext.hxx>
#include <TNaming_NamedShape.hxx>
#include <TNaming_Tool.hxx>
#include <Geom_Plane.hxx>
#include <gp_Pln.hxx>

//=======================================================================
//function :
//purpose  : 
//=======================================================================
TPrsStd_PlaneDriver::TPrsStd_PlaneDriver()
{
}

//=======================================================================
//function :
//purpose  : 
//=======================================================================
Standard_Boolean TPrsStd_PlaneDriver::Update (const TDF_Label& aLabel,
					     Handle(AIS_InteractiveObject)& anAISObject) 
{
  Handle(TDataStd_Plane) apPlane;

  if ( !aLabel.FindAttribute(TDataStd_Plane::GetID(), apPlane) ) {
    return Standard_False;
  }  

  gp_Pln pln;
  if (!TDataStd_Geometry::Plane(aLabel,pln)) {
    return Standard_False;
  }
  Handle(Geom_Plane) apt = new Geom_Plane(pln);

  //  Update AIS
  Handle(AIS_Plane) aisplane;
  if (anAISObject.IsNull())
    aisplane = new AIS_Plane(apt,pln.Location());
  else {
    aisplane = Handle(AIS_Plane)::DownCast(anAISObject);
    if (aisplane.IsNull()) 
      aisplane = new AIS_Plane(apt,pln.Location());
    else {
      aisplane->SetComponent(apt); 
      aisplane->SetCenter(pln.Location());
      aisplane->ResetLocation();
      aisplane->SetToUpdate();
      aisplane->UpdateSelection();
    }
  }
  anAISObject = aisplane;
  return Standard_True;
}

